require '_h2ph_pre.ph';

unless(defined(&WIN32)) {
    eval 'sub XCONN_CHECK_FREQ () {256;}' unless defined(&XCONN_CHECK_FREQ);
    unless(defined(&X11_OPEN_MAX)) {
	unless(defined(&X_NOT_POSIX)) {
	    if(defined(&_POSIX_SOURCE)) {
		require 'limits.ph';
	    } else {
		eval 'sub _POSIX_SOURCE () {1;}' unless defined(&_POSIX_SOURCE);
		require 'limits.ph';
		undef(&_POSIX_SOURCE) if defined(&_POSIX_SOURCE);
	    }
	}
	unless(defined(&OPEN_MAX)) {
	    if(defined(&SVR4)) {
		eval 'sub OPEN_MAX () {256;}' unless defined(&OPEN_MAX);
	    } else {
		require 'sys/param.ph';
		unless(defined(&OPEN_MAX)) {
		    if(defined(&__OSF1__)) {
			eval 'sub OPEN_MAX () {256;}' unless defined(&OPEN_MAX);
		    } else {
			if(defined(&NOFILE)) {
			    eval 'sub OPEN_MAX () { &NOFILE;}' unless defined(&OPEN_MAX);
			} else {
			    eval 'sub OPEN_MAX () { &NOFILES_MAX;}' unless defined(&OPEN_MAX);
			}
		    }
		}
	    }
	}
	if((defined(&OPEN_MAX) ? &OPEN_MAX : 0) > 256) {
	    eval 'sub X11_OPEN_MAX () {256;}' unless defined(&X11_OPEN_MAX);
	} else {
	    eval 'sub X11_OPEN_MAX () { &OPEN_MAX;}' unless defined(&X11_OPEN_MAX);
	}
    }
    if(defined(&USE_POLL)) {
	require 'sys/poll.ph';
    }
    if(!defined( &USE_POLL) || defined( &STREAMSCONN)) {
	if(defined(&WORD64)) {
	    eval 'sub NMSKBITS () {64;}' unless defined(&NMSKBITS);
	} else {
	    eval 'sub NMSKBITS () {32;}' unless defined(&NMSKBITS);
	}
	eval 'sub MSKCNT () {(( &X11_OPEN_MAX +  &NMSKBITS - 1) /  &NMSKBITS);}' unless defined(&MSKCNT);
	if(defined(&LONG64)) {
	} else {
	}
	if(((defined(&MSKCNT) ? &MSKCNT : 0)==1)) {
	    eval 'sub BITMASK {
	        local($i) = @_;
    		eval q((1<< ($i)));
	    }' unless defined(&BITMASK);
	    eval 'sub MASKIDX {
	        local($i) = @_;
    		eval q(0);
	    }' unless defined(&MASKIDX);
	}
	if(((defined(&MSKCNT) ? &MSKCNT : 0)>1)) {
	    eval 'sub BITMASK {
	        local($i) = @_;
    		eval q((1<< (($i) & ( &NMSKBITS - 1))));
	    }' unless defined(&BITMASK);
	    eval 'sub MASKIDX {
	        local($i) = @_;
    		eval q((($i) /  &NMSKBITS));
	    }' unless defined(&MASKIDX);
	}
	eval 'sub MASKWORD {
	    local($buf, $i) = @_;
    	    eval q($buf->[ &MASKIDX($i)]);
	}' unless defined(&MASKWORD);
	eval 'sub BITSET {
	    local($buf, $i) = @_;
    	    eval q( &MASKWORD($buf, $i) |=  &BITMASK($i));
	}' unless defined(&BITSET);
	eval 'sub BITCLEAR {
	    local($buf, $i) = @_;
    	    eval q( &MASKWORD($buf, $i) &= ~ &BITMASK($i));
	}' unless defined(&BITCLEAR);
	eval 'sub GETBIT {
	    local($buf, $i) = @_;
    	    eval q(( &MASKWORD($buf, $i) &  &BITMASK($i)));
	}' unless defined(&GETBIT);
	if(((defined(&MSKCNT) ? &MSKCNT : 0)==1)) {
	    eval 'sub COPYBITS {
	        local($src, $dst) = @_;
    		eval q($dst->[0] = $src->[0]);
	    }' unless defined(&COPYBITS);
	    eval 'sub CLEARBITS {
	        local($buf) = @_;
    		eval q($buf->[0] = 0);
	    }' unless defined(&CLEARBITS);
	    eval 'sub MASKANDSETBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q($dst->[0] = ($b1->[0] & $b2->[0]));
	    }' unless defined(&MASKANDSETBITS);
	    eval 'sub ORBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q($dst->[0] = ($b1->[0] | $b2->[0]));
	    }' unless defined(&ORBITS);
	    eval 'sub UNSETBITS {
	        local($dst, $b1) = @_;
    		eval q(($dst->[0] &= ~$b1->[0]));
	    }' unless defined(&UNSETBITS);
	    eval 'sub _XANYSET {
	        local($src) = @_;
    		eval q(($src->[0]));
	    }' unless defined(&_XANYSET);
	}
	if(((defined(&MSKCNT) ? &MSKCNT : 0)==2)) {
	    eval 'sub COPYBITS {
	        local($src, $dst) = @_;
    		eval q({ $dst->[0] = $src->[0]; $dst->[1] = $src->[1]; });
	    }' unless defined(&COPYBITS);
	    eval 'sub CLEARBITS {
	        local($buf) = @_;
    		eval q({ $buf->[0] = 0; $buf->[1] = 0; });
	    }' unless defined(&CLEARBITS);
	    eval 'sub MASKANDSETBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q({ $dst->[0] = ($b1->[0] & $b2->[0]); $dst->[1] = ($b1->[1] & $b2->[1]); });
	    }' unless defined(&MASKANDSETBITS);
	    eval 'sub ORBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q({ $dst->[0] = ($b1->[0] | $b2->[0]); $dst->[1] = ($b1->[1] | $b2->[1]); });
	    }' unless defined(&ORBITS);
	    eval 'sub UNSETBITS {
	        local($dst, $b1) = @_;
    		eval q({ $dst->[0] &= ~$b1->[0]; $dst->[1] &= ~$b1->[1]; });
	    }' unless defined(&UNSETBITS);
	    eval 'sub _XANYSET {
	        local($src) = @_;
    		eval q(($src->[0] || $src->[1]));
	    }' unless defined(&_XANYSET);
	}
	if(((defined(&MSKCNT) ? &MSKCNT : 0)==3)) {
	    eval 'sub COPYBITS {
	        local($src, $dst) = @_;
    		eval q({ $dst->[0] = $src->[0]; $dst->[1] = $src->[1]; $dst->[2] = $src->[2]; });
	    }' unless defined(&COPYBITS);
	    eval 'sub CLEARBITS {
	        local($buf) = @_;
    		eval q({ $buf->[0] = 0; $buf->[1] = 0; $buf->[2] = 0; });
	    }' unless defined(&CLEARBITS);
	    eval 'sub MASKANDSETBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q({ $dst->[0] = ($b1->[0] & $b2->[0]); $dst->[1] = ($b1->[1] & $b2->[1]); $dst->[2] = ($b1->[2] & $b2->[2]); });
	    }' unless defined(&MASKANDSETBITS);
	    eval 'sub ORBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q({ $dst->[0] = ($b1->[0] | $b2->[0]); $dst->[1] = ($b1->[1] | $b2->[1]); $dst->[2] = ($b1->[2] | $b2->[2]); });
	    }' unless defined(&ORBITS);
	    eval 'sub UNSETBITS {
	        local($dst, $b1) = @_;
    		eval q({ $dst->[0] &= ~$b1->[0]; $dst->[1] &= ~$b1->[1]; $dst->[2] &= ~$b1->[2]; });
	    }' unless defined(&UNSETBITS);
	    eval 'sub _XANYSET {
	        local($src) = @_;
    		eval q(($src->[0] || $src->[1] || $src->[2]));
	    }' unless defined(&_XANYSET);
	}
	if(((defined(&MSKCNT) ? &MSKCNT : 0)==4)) {
	    eval 'sub COPYBITS {
	        local($src, $dst) = @_;
    		eval q($dst->[0] = $src->[0]; $dst->[1] = $src->[1]; $dst->[2] = $src->[2]; $dst->[3] = $src->[3]);
	    }' unless defined(&COPYBITS);
	    eval 'sub CLEARBITS {
	        local($buf) = @_;
    		eval q($buf->[0] = 0; $buf->[1] = 0; $buf->[2] = 0; $buf->[3] = 0);
	    }' unless defined(&CLEARBITS);
	    eval 'sub MASKANDSETBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q($dst->[0] = ($b1->[0] & $b2->[0]); $dst->[1] = ($b1->[1] & $b2->[1]); $dst->[2] = ($b1->[2] & $b2->[2]); $dst->[3] = ($b1->[3] & $b2->[3]));
	    }' unless defined(&MASKANDSETBITS);
	    eval 'sub ORBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q($dst->[0] = ($b1->[0] | $b2->[0]); $dst->[1] = ($b1->[1] | $b2->[1]); $dst->[2] = ($b1->[2] | $b2->[2]); $dst->[3] = ($b1->[3] | $b2->[3]));
	    }' unless defined(&ORBITS);
	    eval 'sub UNSETBITS {
	        local($dst, $b1) = @_;
    		eval q($dst->[0] &= ~$b1->[0]; $dst->[1] &= ~$b1->[1]; $dst->[2] &= ~$b1->[2]; $dst->[3] &= ~$b1->[3]);
	    }' unless defined(&UNSETBITS);
	    eval 'sub _XANYSET {
	        local($src) = @_;
    		eval q(($src->[0] || $src->[1] || $src->[2] || $src->[3]));
	    }' unless defined(&_XANYSET);
	}
	if(((defined(&MSKCNT) ? &MSKCNT : 0)>4)) {
	    eval 'sub COPYBITS {
	        local($src, $dst) = @_;
    		eval q( &memcpy( $dst, $src, $sizeof{ &FdSet}));
	    }' unless defined(&COPYBITS);
	    eval 'sub CLEARBITS {
	        local($buf) = @_;
    		eval q( &bzero( $buf, $sizeof{ &FdSet}));
	    }' unless defined(&CLEARBITS);
	    eval 'sub MASKANDSETBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q({ \'int\'  &cri;  &for ( &cri= &MSKCNT; -- &cri>=0; ) $dst->[ &cri] = ($b1->[ &cri] & $b2->[ &cri]); });
	    }' unless defined(&MASKANDSETBITS);
	    eval 'sub ORBITS {
	        local($dst, $b1, $b2) = @_;
    		eval q({ \'int\'  &cri;  &for ( &cri= &MSKCNT; -- &cri>=0; ) $dst->[ &cri] = ($b1->[ &cri] | $b2->[ &cri]); });
	    }' unless defined(&ORBITS);
	    eval 'sub UNSETBITS {
	        local($dst, $b1) = @_;
    		eval q({ \'int\'  &cri;  &for ( &cri= &MSKCNT; -- &cri>=0; ) $dst->[ &cri] &= ~$b1->[ &cri]; });
	    }' unless defined(&UNSETBITS);
	}
    }
} else {
    eval 'sub BOOL () { &wBOOL;}' unless defined(&BOOL);
    undef(&Status) if defined(&Status);
    eval 'sub Status () { &wStatus;}' unless defined(&Status);
    require 'winsock.ph';
    undef(&Status) if defined(&Status);
    eval 'sub Status () {\'int\';}' unless defined(&Status);
    undef(&BOOL) if defined(&BOOL);
    require 'X11/Xw32defs.ph';
    eval 'sub CLEARBITS {
        local($set) = @_;
	    eval q( &FD_ZERO($set));
    }' unless defined(&CLEARBITS);
    eval 'sub BITSET {
        local($set,$s) = @_;
	    eval q( &FD_SET($s,$set));
    }' unless defined(&BITSET);
    eval 'sub GETBIT {
        local($set,$s) = @_;
	    eval q( &FD_ISSET($s,$set));
    }' unless defined(&GETBIT);
    eval 'sub _XANYSET {
        local($set) = @_;
	    eval q( ($set->{fd_count}));
    }' unless defined(&_XANYSET);
}
1;
