require '_h2ph_pre.ph';

unless(defined(&_XTHREADS_H_)) {
    eval 'sub _XTHREADS_H_ () {1;}' unless defined(&_XTHREADS_H_);
    unless(defined(&xmalloc)) {
	eval 'sub xmalloc () { &malloc;}' unless defined(&xmalloc);
    }
    unless(defined(&xfree)) {
	eval 'sub xfree () { &free;}' unless defined(&xfree);
    }
    if(defined(&CTHREADS)) {
	require 'cthreads.ph';
	eval 'sub xthread_init () {
	    eval q( &cthread_init());
	}' unless defined(&xthread_init);
	eval 'sub xthread_self () { &cthread_self;}' unless defined(&xthread_self);
	eval 'sub xthread_fork {
	    local($func,$closure) = @_;
    	    eval q( &cthread_fork($func,$closure));
	}' unless defined(&xthread_fork);
	eval 'sub xthread_yield () {
	    eval q( &cthread_yield());
	}' unless defined(&xthread_yield);
	eval 'sub xthread_exit {
	    local($v) = @_;
    	    eval q( &cthread_exit($v));
	}' unless defined(&xthread_exit);
	eval 'sub xthread_set_name {
	    local($t,$str) = @_;
    	    eval q( &cthread_set_name($t,$str));
	}' unless defined(&xthread_set_name);
	eval 'sub xmutex_init {
	    local($m) = @_;
    	    eval q( &mutex_init($m));
	}' unless defined(&xmutex_init);
	eval 'sub xmutex_clear {
	    local($m) = @_;
    	    eval q( &mutex_clear($m));
	}' unless defined(&xmutex_clear);
	eval 'sub xmutex_lock {
	    local($m) = @_;
    	    eval q( &mutex_lock($m));
	}' unless defined(&xmutex_lock);
	eval 'sub xmutex_unlock {
	    local($m) = @_;
    	    eval q( &mutex_unlock($m));
	}' unless defined(&xmutex_unlock);
	eval 'sub xmutex_set_name {
	    local($m,$str) = @_;
    	    eval q( &mutex_set_name($m,$str));
	}' unless defined(&xmutex_set_name);
	eval 'sub xcondition_init {
	    local($cv) = @_;
    	    eval q( &condition_init($cv));
	}' unless defined(&xcondition_init);
	eval 'sub xcondition_clear {
	    local($cv) = @_;
    	    eval q( &condition_clear($cv));
	}' unless defined(&xcondition_clear);
	eval 'sub xcondition_wait {
	    local($cv,$m) = @_;
    	    eval q( &condition_wait($cv,$m));
	}' unless defined(&xcondition_wait);
	eval 'sub xcondition_signal {
	    local($cv) = @_;
    	    eval q( &condition_signal($cv));
	}' unless defined(&xcondition_signal);
	eval 'sub xcondition_broadcast {
	    local($cv) = @_;
    	    eval q( &condition_broadcast($cv));
	}' unless defined(&xcondition_broadcast);
	eval 'sub xcondition_set_name {
	    local($cv,$str) = @_;
    	    eval q( &condition_set_name($cv,$str));
	}' unless defined(&xcondition_set_name);
    } else {
	if(defined(&SVR4)) {
	    require 'thread.ph';
	    require 'synch.ph';
	    unless(defined(&LINE_MAX)) {
		eval 'sub LINE_MAX () {2048;}' unless defined(&LINE_MAX);
	    }
	    eval 'sub xthread_self () { &thr_self;}' unless defined(&xthread_self);
	    eval 'sub xthread_fork {
	        local($func,$closure) = @_;
    		eval q( &thr_create( &NULL,0,$func,$closure, &THR_NEW_LWP| &THR_DETACHED, &NULL));
	    }' unless defined(&xthread_fork);
	    eval 'sub xthread_yield () {
	        eval q( &thr_yield());
	    }' unless defined(&xthread_yield);
	    eval 'sub xthread_exit {
	        local($v) = @_;
    		eval q( &thr_exit($v));
	    }' unless defined(&xthread_exit);
	    eval 'sub xthread_key_create {
	        local($kp,$d) = @_;
    		eval q( &thr_keycreate($kp,$d));
	    }' unless defined(&xthread_key_create);
	    if(defined(&sun)) {
		eval 'sub xthread_key_delete {
		    local($k) = @_;
    		    eval q(0);
		}' unless defined(&xthread_key_delete);
	    } else {
		eval 'sub xthread_key_delete {
		    local($k) = @_;
    		    eval q( &thr_keydelete($k));
		}' unless defined(&xthread_key_delete);
	    }
	    eval 'sub xthread_set_specific {
	        local($k,$v) = @_;
    		eval q( &thr_setspecific($k,$v));
	    }' unless defined(&xthread_set_specific);
	    eval 'sub xthread_get_specific {
	        local($k,$vp) = @_;
    		eval q( &thr_getspecific($k,$vp));
	    }' unless defined(&xthread_get_specific);
	    eval 'sub xmutex_init {
	        local($m) = @_;
    		eval q( &mutex_init($m, &USYNC_THREAD,0));
	    }' unless defined(&xmutex_init);
	    eval 'sub xmutex_clear {
	        local($m) = @_;
    		eval q( &mutex_destroy($m));
	    }' unless defined(&xmutex_clear);
	    eval 'sub xmutex_lock {
	        local($m) = @_;
    		eval q( &mutex_lock($m));
	    }' unless defined(&xmutex_lock);
	    eval 'sub xmutex_unlock {
	        local($m) = @_;
    		eval q( &mutex_unlock($m));
	    }' unless defined(&xmutex_unlock);
	    eval 'sub xcondition_init {
	        local($cv) = @_;
    		eval q( &cond_init($cv, &USYNC_THREAD,0));
	    }' unless defined(&xcondition_init);
	    eval 'sub xcondition_clear {
	        local($cv) = @_;
    		eval q( &cond_destroy($cv));
	    }' unless defined(&xcondition_clear);
	    eval 'sub xcondition_wait {
	        local($cv,$m) = @_;
    		eval q( &cond_wait($cv,$m));
	    }' unless defined(&xcondition_wait);
	    eval 'sub xcondition_signal {
	        local($cv) = @_;
    		eval q( &cond_signal($cv));
	    }' unless defined(&xcondition_signal);
	    eval 'sub xcondition_broadcast {
	        local($cv) = @_;
    		eval q( &cond_broadcast($cv));
	    }' unless defined(&xcondition_broadcast);
	} else {
	    if(defined(&WIN32)) {
		eval 'sub BOOL () { &wBOOL;}' unless defined(&BOOL);
		if(defined(&Status)) {
		    undef(&Status) if defined(&Status);
		    eval 'sub Status () { &wStatus;}' unless defined(&Status);
		}
		require 'windows.ph';
		if(defined(&Status)) {
		    undef(&Status) if defined(&Status);
		    eval 'sub Status () {\'int\';}' unless defined(&Status);
		}
		undef(&BOOL) if defined(&BOOL);
		eval 'sub xthread_init () {
		    eval q( &_Xthread_init());
		}' unless defined(&xthread_init);
		eval 'sub xthread_self () { &GetCurrentThreadId;}' unless defined(&xthread_self);
		eval 'sub xthread_fork {
		    local($func,$closure) = @_;
    		    eval q({  &DWORD  &_tmptid;  &CreateThread( &NULL, 0, $func, $closure, 0, & &_tmptid); });
		}' unless defined(&xthread_fork);
		eval 'sub xthread_yield () {
		    eval q( &Sleep(0));
		}' unless defined(&xthread_yield);
		eval 'sub xthread_exit {
		    local($v) = @_;
    		    eval q( &ExitThread(($v)));
		}' unless defined(&xthread_exit);
		eval 'sub xthread_key_create {
		    local($kp,$d) = @_;
    		    eval q(*($kp) =  &TlsAlloc());
		}' unless defined(&xthread_key_create);
		eval 'sub xthread_key_delete {
		    local($k) = @_;
    		    eval q( &TlsFree($k));
		}' unless defined(&xthread_key_delete);
		eval 'sub xthread_set_specific {
		    local($k,$v) = @_;
    		    eval q( &TlsSetValue($k,$v));
		}' unless defined(&xthread_set_specific);
		eval 'sub xthread_get_specific {
		    local($k,$vp) = @_;
    		    eval q( &TlsGetValue($k));
		}' unless defined(&xthread_get_specific);
		eval 'sub xmutex_init {
		    local($m) = @_;
    		    eval q( &InitializeCriticalSection($m));
		}' unless defined(&xmutex_init);
		eval 'sub xmutex_clear {
		    local($m) = @_;
    		    eval q( &DeleteCriticalSection($m));
		}' unless defined(&xmutex_clear);
		eval 'sub _XMUTEX_NESTS () {1;}' unless defined(&_XMUTEX_NESTS);
		eval 'sub xmutex_lock {
		    local($m) = @_;
    		    eval q( &EnterCriticalSection($m));
		}' unless defined(&xmutex_lock);
		eval 'sub xmutex_unlock {
		    local($m) = @_;
    		    eval q( &LeaveCriticalSection($m));
		}' unless defined(&xmutex_unlock);
		eval 'sub xcondition_init {
		    local($cv) = @_;
    		    eval q({  &InitializeCriticalSection(($cv)-> &cs); ($cv)-> &waiters =  &NULL; });
		}' unless defined(&xcondition_init);
		eval 'sub xcondition_clear {
		    local($cv) = @_;
    		    eval q( &DeleteCriticalSection(($cv)-> &cs));
		}' unless defined(&xcondition_clear);
		eval 'sub xcondition_wait {
		    local($cv,$m) = @_;
    		    eval q({ \'struct _xthread_waiter\' * &_tmpthr =  &_Xthread_waiter();  &EnterCriticalSection(($cv)-> &cs);  ($_tmpthr->{next}) = ($cv)-> &waiters; ($cv)-> &waiters =  &_tmpthr;  &LeaveCriticalSection(($cv)-> &cs);  &LeaveCriticalSection($m);  &WaitForSingleObject( ($_tmpthr->{sem}),  &INFINITE);  &EnterCriticalSection($m); });
		}' unless defined(&xcondition_wait);
		eval 'sub xcondition_signal {
		    local($cv) = @_;
    		    eval q({  &EnterCriticalSection(($cv)-> &cs);  &if (($cv)-> &waiters) {  &ReleaseSemaphore(($cv)-> ($waiters->{sem}), 1,  &NULL); ($cv)-> &waiters = ($cv)-> ($waiters->{next}); }  &LeaveCriticalSection(($cv)-> &cs); });
		}' unless defined(&xcondition_signal);
		eval 'sub xcondition_broadcast {
		    local($cv) = @_;
    		    eval q({ \'struct _xthread_waiter\' * &_tmpthr;  &EnterCriticalSection(($cv)-> &cs);  &for ( &_tmpthr = ($cv)-> &waiters;  &_tmpthr;  &_tmpthr =  ($_tmpthr->{next}))  &ReleaseSemaphore( ($_tmpthr->{sem}), 1,  &NULL); ($cv)-> &waiters =  &NULL;  &LeaveCriticalSection(($cv)-> &cs); });
		}' unless defined(&xcondition_broadcast);
	    } else {
		if(defined(&USE_TIS_SUPPORT)) {
		    require 'tis.ph';
		    eval 'sub pthread_key_t () { &xthread_key_t;;}' unless defined(&pthread_key_t);
		    eval 'sub xthread_self () { &tis_self;}' unless defined(&xthread_self);
		    eval 'sub xthread_fork {
		        local($func,$closure) = @_;
    			eval q({  &pthread_t  &_tmpxthr;  &pthread_create(& &_tmpxthr, &NULL,$func,$closure); });
		    }' unless defined(&xthread_fork);
		    eval 'sub xthread_yield () {
		        eval q( &pthread_yield_np());
		    }' unless defined(&xthread_yield);
		    eval 'sub xthread_exit {
		        local($v) = @_;
    			eval q( &pthread_exit($v));
		    }' unless defined(&xthread_exit);
		    eval 'sub xthread_set_specific {
		        local($k,$v) = @_;
    			eval q( &pthread_setspecific($k,$v));
		    }' unless defined(&xthread_set_specific);
		    eval 'sub xmutex_init {
		        local($m) = @_;
    			eval q( &tis_mutex_init($m));
		    }' unless defined(&xmutex_init);
		    eval 'sub xmutex_clear {
		        local($m) = @_;
    			eval q( &tis_mutex_destroy($m));
		    }' unless defined(&xmutex_clear);
		    eval 'sub xmutex_lock {
		        local($m) = @_;
    			eval q( &tis_mutex_lock($m));
		    }' unless defined(&xmutex_lock);
		    eval 'sub xmutex_unlock {
		        local($m) = @_;
    			eval q( &tis_mutex_unlock($m));
		    }' unless defined(&xmutex_unlock);
		    eval 'sub xcondition_init {
		        local($c) = @_;
    			eval q( &tis_cond_init($c));
		    }' unless defined(&xcondition_init);
		    eval 'sub xcondition_clear {
		        local($c) = @_;
    			eval q( &tis_cond_destroy($c));
		    }' unless defined(&xcondition_clear);
		    eval 'sub xcondition_wait {
		        local($c,$m) = @_;
    			eval q( &tis_cond_wait($c,$m));
		    }' unless defined(&xcondition_wait);
		    eval 'sub xcondition_signal {
		        local($c) = @_;
    			eval q( &tis_cond_signal($c));
		    }' unless defined(&xcondition_signal);
		    eval 'sub xcondition_broadcast {
		        local($c) = @_;
    			eval q( &tis_cond_broadcast($c));
		    }' unless defined(&xcondition_broadcast);
		} else {
		    require 'pthread.ph';
		    unless(defined(&LINE_MAX)) {
			eval 'sub LINE_MAX () {2048;}' unless defined(&LINE_MAX);
		    }
		    eval 'sub xthread_self () { &pthread_self;}' unless defined(&xthread_self);
		    eval 'sub xthread_yield () {
		        eval q( &pthread_yield());
		    }' unless defined(&xthread_yield);
		    eval 'sub xthread_exit {
		        local($v) = @_;
    			eval q( &pthread_exit($v));
		    }' unless defined(&xthread_exit);
		    eval 'sub xmutex_clear {
		        local($m) = @_;
    			eval q( &pthread_mutex_destroy($m));
		    }' unless defined(&xmutex_clear);
		    eval 'sub xmutex_lock {
		        local($m) = @_;
    			eval q( &pthread_mutex_lock($m));
		    }' unless defined(&xmutex_lock);
		    eval 'sub xmutex_unlock {
		        local($m) = @_;
    			eval q( &pthread_mutex_unlock($m));
		    }' unless defined(&xmutex_unlock);
		    unless(defined(&XPRE_STANDARD_API)) {
			eval 'sub xthread_key_create {
			    local($kp,$d) = @_;
    			    eval q( &pthread_key_create($kp,$d));
			}' unless defined(&xthread_key_create);
			eval 'sub xthread_key_delete {
			    local($k) = @_;
    			    eval q( &pthread_key_delete($k));
			}' unless defined(&xthread_key_delete);
			eval 'sub xthread_get_specific {
			    local($k,$vp) = @_;
    			    eval q(*($vp) =  &pthread_getspecific($k));
			}' unless defined(&xthread_get_specific);
			eval 'sub xthread_fork {
			    local($func,$closure) = @_;
    			    eval q({  &pthread_t  &_tmpxthr;  &pthread_create(& &_tmpxthr, &NULL,$func,$closure); });
			}' unless defined(&xthread_fork);
			eval 'sub xmutex_init {
			    local($m) = @_;
    			    eval q( &pthread_mutex_init($m,  &NULL));
			}' unless defined(&xmutex_init);
			eval 'sub xcondition_init {
			    local($c) = @_;
    			    eval q( &pthread_cond_init($c,  &NULL));
			}' unless defined(&xcondition_init);
		    } else {
			eval 'sub xthread_key_create {
			    local($kp,$d) = @_;
    			    eval q( &pthread_keycreate($kp,$d));
			}' unless defined(&xthread_key_create);
			eval 'sub xthread_key_delete {
			    local($k) = @_;
    			    eval q(0);
			}' unless defined(&xthread_key_delete);
			eval 'sub xthread_get_specific {
			    local($k,$vp) = @_;
    			    eval q( &pthread_getspecific($k,$vp));
			}' unless defined(&xthread_get_specific);
			eval 'sub xthread_fork {
			    local($func,$closure) = @_;
    			    eval q({  &pthread_t  &_tmpxthr;  &pthread_create(& &_tmpxthr, &pthread_attr_default,$func,$closure); });
			}' unless defined(&xthread_fork);
			eval 'sub xmutex_init {
			    local($m) = @_;
    			    eval q( &pthread_mutex_init($m,  &pthread_mutexattr_default));
			}' unless defined(&xmutex_init);
			eval 'sub xcondition_init {
			    local($c) = @_;
    			    eval q( &pthread_cond_init($c,  &pthread_condattr_default));
			}' unless defined(&xcondition_init);
		    }
		    eval 'sub xcondition_clear {
		        local($c) = @_;
    			eval q( &pthread_cond_destroy($c));
		    }' unless defined(&xcondition_clear);
		    eval 'sub xcondition_wait {
		        local($c,$m) = @_;
    			eval q( &pthread_cond_wait($c,$m));
		    }' unless defined(&xcondition_wait);
		    eval 'sub xcondition_signal {
		        local($c) = @_;
    			eval q( &pthread_cond_signal($c));
		    }' unless defined(&xcondition_signal);
		    eval 'sub xcondition_broadcast {
		        local($c) = @_;
    			eval q( &pthread_cond_broadcast($c));
		    }' unless defined(&xcondition_broadcast);
		    if(defined(&_DECTHREADS_)) {
			eval 'sub xthread_have_id {
			    local($id) = @_;
    			    eval q(! &pthread_equal($id,  &_X_no_thread_id));
			}' unless defined(&xthread_have_id);
			eval 'sub xthread_clear_id {
			    local($id) = @_;
    			    eval q($id =  &_X_no_thread_id);
			}' unless defined(&xthread_clear_id);
			eval 'sub xthread_equal {
			    local($id1,$id2) = @_;
    			    eval q( &pthread_equal($id1, $id2));
			}' unless defined(&xthread_equal);
		    }
		    if((defined(&_CMA_VENDOR_) ? &_CMA_VENDOR_ : 0) == (defined(&_CMA__IBM) ? &_CMA__IBM : 0)) {
			if(defined(&DEBUG)) {
			    eval 'sub xmutex_set_name {
			        local($m,$str) = @_;
    				eval q((($m)-> &field1)[5] = ($str));
			    }' unless defined(&xmutex_set_name);
			    eval 'sub xcondition_set_name {
			        local($cv,$str) = @_;
    				eval q((($cv)-> &field1)[5] = ($str));
			    }' unless defined(&xcondition_set_name);
			}
		    }
		}
	    }
	}
    }
    unless(defined(&xcondition_malloc)) {
	eval 'sub xcondition_malloc () {
	    eval q( &xmalloc($sizeof{ &xcondition_rec}));
	}' unless defined(&xcondition_malloc);
    }
    unless(defined(&xcondition_free)) {
	eval 'sub xcondition_free {
	    local($c) = @_;
    	    eval q( &xfree($c));
	}' unless defined(&xcondition_free);
    }
    unless(defined(&xmutex_malloc)) {
	eval 'sub xmutex_malloc () {
	    eval q( &xmalloc($sizeof{ &xmutex_rec}));
	}' unless defined(&xmutex_malloc);
    }
    unless(defined(&xmutex_free)) {
	eval 'sub xmutex_free {
	    local($m) = @_;
    	    eval q( &xfree($m));
	}' unless defined(&xmutex_free);
    }
    unless(defined(&xthread_have_id)) {
	eval 'sub xthread_have_id {
	    local($id) = @_;
    	    eval q($id);
	}' unless defined(&xthread_have_id);
    }
    unless(defined(&xthread_clear_id)) {
	eval 'sub xthread_clear_id {
	    local($id) = @_;
    	    eval q($id = 0);
	}' unless defined(&xthread_clear_id);
    }
    unless(defined(&xthread_equal)) {
	eval 'sub xthread_equal {
	    local($id1,$id2) = @_;
    	    eval q((($id1) == ($id2)));
	}' unless defined(&xthread_equal);
    }
    unless(defined(&xthread_set_name)) {
	eval 'sub xthread_set_name {
	    local($t,$str) = @_;
    	    eval q();
	}' unless defined(&xthread_set_name);
    }
    unless(defined(&xmutex_set_name)) {
	eval 'sub xmutex_set_name {
	    local($m,$str) = @_;
    	    eval q();
	}' unless defined(&xmutex_set_name);
    }
    unless(defined(&xcondition_set_name)) {
	eval 'sub xcondition_set_name {
	    local($cv,$str) = @_;
    	    eval q();
	}' unless defined(&xcondition_set_name);
    }
}
1;
