require '_h2ph_pre.ph';

unless(defined(&_SYS_IN_PCB_INCLUDED)) {
    eval 'sub _SYS_IN_PCB_INCLUDED () {1;}' unless defined(&_SYS_IN_PCB_INCLUDED);
    eval 'sub INP_COPY () {1;}' unless defined(&INP_COPY);
    eval 'sub INP_RESERVED () {2;}' unless defined(&INP_RESERVED);
    eval 'sub INP_NONCACHEABLE () {4;}' unless defined(&INP_NONCACHEABLE);
    eval 'sub INP_SOURCE_ADDR_NOT_BOUND () {8;}' unless defined(&INP_SOURCE_ADDR_NOT_BOUND);
    eval 'sub INP_ROUTETOBIF () {0x10;}' unless defined(&INP_ROUTETOBIF);
    eval 'sub INP_INPCBNOTIFY_PENDING () {0x20;}' unless defined(&INP_INPCBNOTIFY_PENDING);
    eval 'sub INP_RTNOTIFY_PENDING () {0x40;}' unless defined(&INP_RTNOTIFY_PENDING);
    eval 'sub INPLOOKUP_WILDCARD () {1;}' unless defined(&INPLOOKUP_WILDCARD);
    eval 'sub INPLOOKUP_SETLOCAL () {2;}' unless defined(&INPLOOKUP_SETLOCAL);
    eval 'sub MAKE_PCB_NONCACHEABLE {
        local($inp) = @_;
	    eval q(($inp)-> &flags |=  &INP_NONCACHEABLE);
    }' unless defined(&MAKE_PCB_NONCACHEABLE);
    eval 'sub MAKE_PCB_CACHEABLE {
        local($inp) = @_;
	    eval q(($inp)-> &flags &= ~ &INP_NONCACHEABLE);
    }' unless defined(&MAKE_PCB_CACHEABLE);
    eval 'sub IS_PCB_CACHEABLE {
        local($inp) = @_;
	    eval q((!(($inp)-> &flags &  &INP_NONCACHEABLE)));
    }' unless defined(&IS_PCB_CACHEABLE);
    eval 'sub INVALIDATE_PCB_IN_CACHE {
        local($inp) = @_;
	    eval q( &if (($inp)-> ($inp_head->{inp_recent})==($inp)) ($inp)-> ($inp_head->{inp_recent})=0);
    }' unless defined(&INVALIDATE_PCB_IN_CACHE);
    eval 'sub sotoinpcb {
        local($so) = @_;
	    eval q((($so)-> &so_pcb));
    }' unless defined(&sotoinpcb);
    eval 'sub inp_socket () { ($inp_route->{ro_socket});}' unless defined(&inp_socket);
    if(defined(&_KERNEL)) {
	eval 'sub PCB_NB () {256;}' unless defined(&PCB_NB);
	eval 'sub PCB_HASH {
	    local($faddr,$fport,$laddr,$lport,$hash) = @_;
    	    eval q({ ($hash) = ($lport) ^ ($fport) ^ ($laddr). &s_addr ^ ($faddr). &s_addr; ($hash) = ($hash) & ( &PCB_NB -1); });
	}' unless defined(&PCB_HASH);
	eval 'sub PCB_LOOK {
	    local($table,$faddr,$fport,$laddr,$lport,$hash,$inp,$hashqp,$context) = @_;
    	    eval q({  &PCB_HASH (($faddr), ($fport), ($laddr), ($lport), ($hash)); ($hashqp) = ($table)[($hash)];  &INPHASH_LOCK_USAV(($hashqp), ($context));  &for (($inp) = ($hashqp)-> &inp_nexth; ($inp)!=($hashqp); ($inp)=($inp)-> &inp_nexth) {  &if (($inp)-> &inp_lport != ($lport))  &continue;  &if (($inp)-> &inp_fport != ($fport))  &continue;  &if (($inp)-> ($inp_faddr->{s_addr}) != ($faddr). &s_addr)  &continue;  &if (($inp)-> ($inp_laddr->{s_addr}) != ($laddr). &s_addr)  &continue;  &break; }  &if (($inp) == ($hashqp)) ($inp) = 0;  &else  &INPCBRC_REF($inp);  &INPHASH_UNLOCK_USAV(($hashqp), ($context)); });
	}' unless defined(&PCB_LOOK);
	eval 'sub UDB_NB () {64;}' unless defined(&UDB_NB);
	eval 'sub UDP_HASH_LIST {
	    local($lport) = @_;
    	    eval q(( $udphash[($lport) & ( &UDB_NB - 1)]));
	}' unless defined(&UDP_HASH_LIST);
	eval 'sub netenq {
	    local($p, $prev, $nextp, $prevp) = @_;
    	    eval q({ ($p)->$prevp = ($prev); ($p)->$nextp = ($prev)->$nextp; ($prev)-> ($nextp->{prevp}) = ($p); ($prev)->$nextp = ($p); });
	}' unless defined(&netenq);
	eval 'sub netdeq {
	    local($p, $nextp, $prevp) = @_;
    	    eval q({ ($p)-> ($prevp->{nextp}) = ($p)->$nextp; ($p)-> ($nextp->{prevp}) = ($p)->$prevp; ($p)->$nextp = 0; });
	}' unless defined(&netdeq);
	eval 'sub INPCB_NB () {(( &NBPG - $sizeof{\'caddr_t\'} - $sizeof{\'int\'}) / $sizeof{\'caddr_t\'});}' unless defined(&INPCB_NB);
	if(defined(&INPCB_LOCK_ON)) {
	    eval 'sub INPCB_LOCK {
	        local($inp) = @_;
    		eval q( &simple_lock((($inp)-> &inp_lock)));
	    }' unless defined(&INPCB_LOCK);
	    eval 'sub INPCB_UNLOCK {
	        local($inp) = @_;
    		eval q( &simple_unlock((($inp)-> &inp_lock)));
	    }' unless defined(&INPCB_UNLOCK);
	    eval 'sub INPCB_ISLOCKED {
	        local($inp) = @_;
    		eval q( &simple_lock_try((($inp)-> &inp_lock)));
	    }' unless defined(&INPCB_ISLOCKED);
	} else {
	    eval 'sub INPCB_LOCK {
	        local($inp) = @_;
    		eval q();
	    }' unless defined(&INPCB_LOCK);
	    eval 'sub INPCB_UNLOCK {
	        local($inp) = @_;
    		eval q();
	    }' unless defined(&INPCB_UNLOCK);
	    eval 'sub INPCB_ISLOCKED {
	        local($inp) = @_;
    		eval q(1);
	    }' unless defined(&INPCB_ISLOCKED);
	}
	eval 'sub INHEAD_LOCKINIT {
	    local($head) = @_;
    	    eval q(($head)-> &inp_lock =  &alloc_spinlock( &INHEAD_LOCK_ORDER, \\"INHEAD\\"));
	}' unless defined(&INHEAD_LOCKINIT);
	eval 'sub INHEAD_LOCK {
	    local($head) = @_;
    	    eval q( &if (! &uniprocessor)  &spinlock(($head)-> &inp_lock));
	}' unless defined(&INHEAD_LOCK);
	eval 'sub INHEAD_UNLOCK {
	    local($head) = @_;
    	    eval q( &if (! &uniprocessor)  &spinunlock(($head)-> &inp_lock));
	}' unless defined(&INHEAD_UNLOCK);
	eval 'sub INHEAD_LOCK_USAV {
	    local($head, $context) = @_;
    	    eval q( &MP_SPINLOCK_USAV(($head)-> &inp_lock, $context));
	}' unless defined(&INHEAD_LOCK_USAV);
	eval 'sub INHEAD_UNLOCK_USAV {
	    local($head, $context) = @_;
    	    eval q( &MP_SPINUNLOCK_USAV(($head)-> &inp_lock, $context));
	}' unless defined(&INHEAD_UNLOCK_USAV);
	eval 'sub INHEAD_READ_LOCK {
	    local($head) = @_;
    	    eval q( &INHEAD_LOCK($head));
	}' unless defined(&INHEAD_READ_LOCK);
	eval 'sub INHEAD_READ_UNLOCK {
	    local($head) = @_;
    	    eval q( &INHEAD_UNLOCK($head));
	}' unless defined(&INHEAD_READ_UNLOCK);
	eval 'sub INHEAD_WRITE_LOCK {
	    local($head) = @_;
    	    eval q( &INHEAD_LOCK($head));
	}' unless defined(&INHEAD_WRITE_LOCK);
	eval 'sub INHEAD_WRITE_UNLOCK {
	    local($head) = @_;
    	    eval q( &INHEAD_UNLOCK($head));
	}' unless defined(&INHEAD_WRITE_UNLOCK);
	eval 'sub INHEAD_ISLOCKED {
	    local($head) = @_;
    	    eval q(1);
	}' unless defined(&INHEAD_ISLOCKED);
	eval 'sub INPHASH_LOCK_USAV {
	    local($head, $context) = @_;
    	    eval q( &MP_SPINLOCK_USAV(($head)-> &inp_lock, $context));
	}' unless defined(&INPHASH_LOCK_USAV);
	eval 'sub INPHASH_UNLOCK_USAV {
	    local($head, $context) = @_;
    	    eval q( &MP_SPINUNLOCK_USAV(($head)-> &inp_lock, $context));
	}' unless defined(&INPHASH_UNLOCK_USAV);
	eval 'sub INPHASH_LOCKINIT {
	    local($head) = @_;
    	    eval q(($head)-> &inp_lock =  &alloc_spinlock( &INPHASH_LOCK_ORDER, \\"INPHASH\\"));
	}' unless defined(&INPHASH_LOCKINIT);
	eval 'sub INPHASH_ISLOCKED {
	    local($head) = @_;
    	    eval q(1);
	}' unless defined(&INPHASH_ISLOCKED);
	eval 'sub INPCB_RTHASH_LOCKINIT () {
	    eval q( &inpcb_rthash_lock =  &alloc_spinlock( &INPCB_RTHASH_LOCK_ORDER, \\"RTHASH\\"));
	}' unless defined(&INPCB_RTHASH_LOCKINIT);
	eval 'sub INPCB_RTHASH_LOCK () {
	    eval q( &if (! &uniprocessor)  &spinlock( &inpcb_rthash_lock));
	}' unless defined(&INPCB_RTHASH_LOCK);
	eval 'sub INPCB_RTHASH_UNLOCK () {
	    eval q( &if (! &uniprocessor)  &spinunlock( &inpcb_rthash_lock));
	}' unless defined(&INPCB_RTHASH_UNLOCK);
	eval 'sub INPCB_RTHASH_LOCK_USAV {
	    local($context) = @_;
    	    eval q( &MP_SPINLOCK_USAV( &inpcb_rthash_lock, $context));
	}' unless defined(&INPCB_RTHASH_LOCK_USAV);
	eval 'sub INPCB_RTHASH_UNLOCK_USAV {
	    local($context) = @_;
    	    eval q( &MP_SPINUNLOCK_USAV( &inpcb_rthash_lock, $context));
	}' unless defined(&INPCB_RTHASH_UNLOCK_USAV);
	eval 'sub INPCB_RTHASH_READ_LOCK () {
	    eval q( &INPCB_RTHASH_LOCK());
	}' unless defined(&INPCB_RTHASH_READ_LOCK);
	eval 'sub INPCB_RTHASH_READ_UNLOCK () {
	    eval q( &INPCB_RTHASH_UNLOCK());
	}' unless defined(&INPCB_RTHASH_READ_UNLOCK);
	eval 'sub INPCB_RTHASH_WRITE_LOCK () {
	    eval q( &INPCB_RTHASH_LOCK());
	}' unless defined(&INPCB_RTHASH_WRITE_LOCK);
	eval 'sub INPCB_RTHASH_WRITE_UNLOCK () {
	    eval q( &INPCB_RTHASH_UNLOCK());
	}' unless defined(&INPCB_RTHASH_WRITE_UNLOCK);
	eval 'sub INPCB_RTHASH_ISLOCKED () {
	    eval q(1);
	}' unless defined(&INPCB_RTHASH_ISLOCKED);
	eval 'sub INPCBRC_LOCKINIT {
	    local($inp) = @_;
    	    eval q( &alloc_spinlock_nowait((($inp)-> &inp_rc_lock),\\"IN_PCBRC\\",  &INPCBRC_LOCK_ORDER));
	}' unless defined(&INPCBRC_LOCKINIT);
	eval 'sub INPCBRC_LOCKINIT_WAIT {
	    local($inp) = @_;
    	    eval q(($inp)-> &inp_rc_lock =  &alloc_spinlock( &INPCBRC_LOCK_ORDER,\\"IN_PCBRC\\"));
	}' unless defined(&INPCBRC_LOCKINIT_WAIT);
	eval 'sub INPCBRC_LOCK {
	    local($inp) = @_;
    	    eval q(( &uniprocessor ? 0:  &spinlock(($inp)-> &inp_rc_lock)));
	}' unless defined(&INPCBRC_LOCK);
	eval 'sub INPCBRC_UNLOCK {
	    local($inp) = @_;
    	    eval q(( &uniprocessor ? 0:  &spinunlock(($inp)-> &inp_rc_lock)));
	}' unless defined(&INPCBRC_UNLOCK);
	eval 'sub INPCBRC_LOCK_USAV {
	    local($inp, $context) = @_;
    	    eval q( &MP_SPINLOCK_USAV(($inp)-> &inp_rc_lock, $context));
	}' unless defined(&INPCBRC_LOCK_USAV);
	eval 'sub INPCBRC_UNLOCK_USAV {
	    local($inp, $context) = @_;
    	    eval q( &MP_SPINUNLOCK_USAV(($inp)-> &inp_rc_lock, $context));
	}' unless defined(&INPCBRC_UNLOCK_USAV);
	eval 'sub INPCBRC_REF {
	    local($inp) = @_;
    	    eval q({  &register \'u_int\'  &inpcbrc_context;  &INPCBRC_LOCK_USAV($inp,  &inpcbrc_context); ($inp)-> &inp_refcnt++;  &INPCBRC_UNLOCK_USAV($inp,  &inpcbrc_context); });
	}' unless defined(&INPCBRC_REF);
	eval 'sub INPCBRC_UNREF {
	    local($inp) = @_;
    	    eval q({  &register \'u_int\'  &inpcbrc_context;  &INPCBRC_LOCK_USAV($inp,  &inpcbrc_context);  &if (($inp)-> &inp_refcnt == 1) {  &INPCBRC_UNLOCK_USAV($inp,  &inpcbrc_context);  &in_pcbfree($inp); }  &else { ($inp)-> &inp_refcnt--;  &INPCBRC_UNLOCK_USAV($inp,  &inpcbrc_context); } });
	}' unless defined(&INPCBRC_UNREF);
    }
}
1;
