require '_h2ph_pre.ph';

unless(defined(&_NFS_NFS_INCLUDED)) {
    eval 'sub _NFS_NFS_INCLUDED () {1;}' unless defined(&_NFS_NFS_INCLUDED);
    if(defined(&_KERNEL_BUILD)) {
	require '../h/stdsyms.ph';
    } else {
	require 'sys/stdsyms.ph';
    }
    if(defined(&_INCLUDE_HPUX_SOURCE)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/errno.ph';
	    require '../h/time.ph';
	    require '../rpc/types.ph';
	    require '../h/uio.ph';
	    require '../h/socketvar.ph';
	} else {
	    require 'sys/errno.ph';
	    require 'sys/time.ph';
	    require 'rpc/types.ph';
	    require 'sys/uio.ph';
	}
	unless(defined(&_NFS_AUTOMOUNT)) {
	    eval 'sub NFS_MAXDATA () {8192;}' unless defined(&NFS_MAXDATA);
	    eval 'sub NFS_MAXNAMLEN () {255;}' unless defined(&NFS_MAXNAMLEN);
	    eval 'sub NFS_MAXPATHLEN () {1024;}' unless defined(&NFS_MAXPATHLEN);
	    eval 'sub NFS_MAXIOVEC () {16;}' unless defined(&NFS_MAXIOVEC);
	    eval 'sub NFS_TIMEO () {7;}' unless defined(&NFS_TIMEO);
	    eval 'sub NFS_RETRIES () {4;}' unless defined(&NFS_RETRIES);
	    eval 'sub ECTSIZE () {4096;}' unless defined(&ECTSIZE);
	    eval 'sub IETSIZE () {8192;}' unless defined(&IETSIZE);
	    eval("sub NFS_OK () { 0; }") unless defined(&NFS_OK);
	    eval("sub NFSERR_PERM () { EPERM; }") unless defined(&NFSERR_PERM);
	    eval("sub NFSERR_NOENT () { ENOENT; }") unless defined(&NFSERR_NOENT);
	    eval("sub NFSERR_IO () { EIO; }") unless defined(&NFSERR_IO);
	    eval("sub NFSERR_NXIO () { ENXIO; }") unless defined(&NFSERR_NXIO);
	    eval("sub NFSERR_ACCES () { EACCES; }") unless defined(&NFSERR_ACCES);
	    eval("sub NFSERR_EXIST () { EEXIST; }") unless defined(&NFSERR_EXIST);
	    eval("sub NFSERR_NODEV () { ENODEV; }") unless defined(&NFSERR_NODEV);
	    eval("sub NFSERR_NOTDIR () { ENOTDIR; }") unless defined(&NFSERR_NOTDIR);
	    eval("sub NFSERR_ISDIR () { EISDIR; }") unless defined(&NFSERR_ISDIR);
	    eval("sub NFSERR_FBIG () { EFBIG; }") unless defined(&NFSERR_FBIG);
	    eval("sub NFSERR_NOSPC () { ENOSPC; }") unless defined(&NFSERR_NOSPC);
	    eval("sub NFSERR_ROFS () { EROFS; }") unless defined(&NFSERR_ROFS);
	    eval("sub NFSERR_NAMETOOLONG () { ENAMETOOLONG; }") unless defined(&NFSERR_NAMETOOLONG);
	    eval("sub NFSERR_NOTEMPTY () { ENOTEMPTY; }") unless defined(&NFSERR_NOTEMPTY);
	    eval("sub NFSERR_DQUOT () { EDQUOT; }") unless defined(&NFSERR_DQUOT);
	    eval("sub NFSERR_STALE () { ESTALE; }") unless defined(&NFSERR_STALE);
	    eval("sub NFSERR_WFLUSH () { 1; }") unless defined(&NFSERR_WFLUSH);
	    eval 'sub puterrno {
	        local($error) = @_;
    		eval q(($error));
	    }' unless defined(&puterrno);
	    eval 'sub geterrno {
	        local($status) = @_;
    		eval q(($status));
	    }' unless defined(&geterrno);
	    eval("sub NFNON () { 0; }") unless defined(&NFNON);
	    eval("sub NFREG () { 1; }") unless defined(&NFREG);
	    eval("sub NFDIR () { 2; }") unless defined(&NFDIR);
	    eval("sub NFBLK () { 3; }") unless defined(&NFBLK);
	    eval("sub NFCHR () { 4; }") unless defined(&NFCHR);
	    eval("sub NFLNK () { 5; }") unless defined(&NFLNK);
	    eval 'sub NFS_FIFO_TYPE () { &NFCHR;}' unless defined(&NFS_FIFO_TYPE);
	    eval 'sub NFS_FIFO_MODE () { &S_IFCHR;}' unless defined(&NFS_FIFO_MODE);
	    eval 'sub NFS_FIFO_DEV () {(~0);}' unless defined(&NFS_FIFO_DEV);
	    eval 'sub NA_ISFIFO {
	        local($NA) = @_;
    		eval q(((($NA)-> &na_type ==  &NFS_FIFO_TYPE)  && (($NA)-> &na_rdev ==  &NFS_FIFO_DEV)));
	    }' unless defined(&NA_ISFIFO);
	    eval 'sub NA_SETFIFO {
	        local($NA) = @_;
    		eval q({ ($NA)-> &na_type =  &NFS_FIFO_TYPE; ($NA)-> &na_rdev =  &NFS_FIFO_DEV; ($NA)-> &na_mode = (($NA)-> &na_mode&~ &S_IFMT)| &NFS_FIFO_MODE; });
	    }' unless defined(&NA_SETFIFO);
	    eval 'sub NFS_FHSIZE () {32;}' unless defined(&NFS_FHSIZE);
	    eval 'sub NFSSTAT_LOCK_ORDER () { &LAST_HELD_ORDER-100;}' unless defined(&NFSSTAT_LOCK_ORDER);
	    eval 'sub NFSSTAT_LOCK {
	        local($lock) = @_;
    		eval q( &spinlock($lock));
	    }' unless defined(&NFSSTAT_LOCK);
	    eval 'sub NFSSTAT_UNLOCK {
	        local($lock) = @_;
    		eval q( &spinunlock($lock));
	    }' unless defined(&NFSSTAT_UNLOCK);
	    if(defined(&_KERNEL_BUILD)) {
	    }
	    if(defined(&NFSSERVER)) {
		eval 'sub NFS_FHMAXDATA () {(( &NFS_FHSIZE - $sizeof{\'struct fhsize\'} + 8) / 2);}' unless defined(&NFS_FHMAXDATA);
	    } else {
	    }
	    eval 'sub n2v_type {
	        local($x) = @_;
    		eval q(( &NA_ISFIFO ?  &VFIFO : (($x)-> &na_type)));
	    }' unless defined(&n2v_type);
	    eval 'sub n2v_rdev {
	        local($x) = @_;
    		eval q(( &NA_ISFIFO($x) ? 0: ($x)-> &na_rdev));
	    }' unless defined(&n2v_rdev);
	    eval 'sub rr_ok () { ($rr_u->{rr_ok_u});}' unless defined(&rr_ok);
	    eval 'sub rr_attr () { ($rr_u->{rr_ok_u}->{rrok_attr});}' unless defined(&rr_attr);
	    eval 'sub rr_count () { ($rr_u->{rr_ok_u}->{rrok_count});}' unless defined(&rr_count);
	    eval 'sub rr_data () { ($rr_u->{rr_ok_u}->{rrok_data});}' unless defined(&rr_data);
	    eval 'sub rr_bp () { ($rr_u->{rr_ok_u}->{rrok_bp});}' unless defined(&rr_bp);
	    eval 'sub rr_vp () { ($rr_u->{rr_ok_u}->{rrok_vp});}' unless defined(&rr_vp);
	    eval 'sub ns_attr () { ($ns_u->{ns_attr_u});}' unless defined(&ns_attr);
	    eval 'sub rl_srok () { ($rl_u->{rl_srok_u});}' unless defined(&rl_srok);
	    eval 'sub rl_count () { ($rl_u->{rl_srok_u}->{srok_count});}' unless defined(&rl_count);
	    eval 'sub rl_data () { ($rl_u->{rl_srok_u}->{srok_data});}' unless defined(&rl_data);
	    eval 'sub rd_rdok () { ($rd_u->{rd_rdok_u});}' unless defined(&rd_rdok);
	    eval 'sub rd_offset () { ($rd_u->{rd_rdok_u}->{rdok_offset});}' unless defined(&rd_offset);
	    eval 'sub rd_size () { ($rd_u->{rd_rdok_u}->{rdok_size});}' unless defined(&rd_size);
	    eval 'sub rd_eof () { ($rd_u->{rd_rdok_u}->{rdok_eof});}' unless defined(&rd_eof);
	    eval 'sub rd_entries () { ($rd_u->{rd_rdok_u}->{rdok_entries});}' unless defined(&rd_entries);
	    eval 'sub rd_mem () { ($rd_u->{rd_rdok_u}->{rdok_mem});}' unless defined(&rd_mem);
	    eval 'sub dr_drok () { ($dr_u->{dr_drok_u});}' unless defined(&dr_drok);
	    eval 'sub dr_fhandle () { ($dr_u->{dr_drok_u}->{drok_fhandle});}' unless defined(&dr_fhandle);
	    eval 'sub dr_attr () { ($dr_u->{dr_drok_u}->{drok_attr});}' unless defined(&dr_attr);
	    eval 'sub fs_fsok () { ($fs_u->{fs_fsok_u});}' unless defined(&fs_fsok);
	    eval 'sub fs_tsize () { ($fs_u->{fs_fsok_u}->{fsok_tsize});}' unless defined(&fs_tsize);
	    eval 'sub fs_bsize_nfs () { ($fs_u->{fs_fsok_u}->{fsok_bsize});}' unless defined(&fs_bsize_nfs);
	    eval 'sub fs_blocks () { ($fs_u->{fs_fsok_u}->{fsok_blocks});}' unless defined(&fs_blocks);
	    eval 'sub fs_bfree () { ($fs_u->{fs_fsok_u}->{fsok_bfree});}' unless defined(&fs_bfree);
	    eval 'sub fs_bavail () { ($fs_u->{fs_fsok_u}->{fsok_bavail});}' unless defined(&fs_bavail);
	    eval 'sub RFS_NULL () {0;}' unless defined(&RFS_NULL);
	    eval 'sub RFS_GETATTR () {1;}' unless defined(&RFS_GETATTR);
	    eval 'sub RFS_SETATTR () {2;}' unless defined(&RFS_SETATTR);
	    eval 'sub RFS_ROOT () {3;}' unless defined(&RFS_ROOT);
	    eval 'sub RFS_LOOKUP () {4;}' unless defined(&RFS_LOOKUP);
	    eval 'sub RFS_READLINK () {5;}' unless defined(&RFS_READLINK);
	    eval 'sub RFS_READ () {6;}' unless defined(&RFS_READ);
	    eval 'sub RFS_WRITECACHE () {7;}' unless defined(&RFS_WRITECACHE);
	    eval 'sub RFS_WRITE () {8;}' unless defined(&RFS_WRITE);
	    eval 'sub RFS_CREATE () {9;}' unless defined(&RFS_CREATE);
	    eval 'sub RFS_REMOVE () {10;}' unless defined(&RFS_REMOVE);
	    eval 'sub RFS_RENAME () {11;}' unless defined(&RFS_RENAME);
	    eval 'sub RFS_LINK () {12;}' unless defined(&RFS_LINK);
	    eval 'sub RFS_SYMLINK () {13;}' unless defined(&RFS_SYMLINK);
	    eval 'sub RFS_MKDIR () {14;}' unless defined(&RFS_MKDIR);
	    eval 'sub RFS_RMDIR () {15;}' unless defined(&RFS_RMDIR);
	    eval 'sub RFS_READDIR () {16;}' unless defined(&RFS_READDIR);
	    eval 'sub RFS_STATFS () {17;}' unless defined(&RFS_STATFS);
	    eval 'sub RFS_NPROC () {18;}' unless defined(&RFS_NPROC);
	    eval 'sub NFS_PROGRAM () {(100003);}' unless defined(&NFS_PROGRAM);
	    eval 'sub NFS_VERSION () {(2);}' unless defined(&NFS_VERSION);
	    eval 'sub NFS_PORT () {2049;}' unless defined(&NFS_PORT);
	}
	eval 'sub NFSMNT_SOFT () {0x001;}' unless defined(&NFSMNT_SOFT);
	eval 'sub NFSMNT_WSIZE () {0x002;}' unless defined(&NFSMNT_WSIZE);
	eval 'sub NFSMNT_RSIZE () {0x004;}' unless defined(&NFSMNT_RSIZE);
	eval 'sub NFSMNT_TIMEO () {0x008;}' unless defined(&NFSMNT_TIMEO);
	eval 'sub NFSMNT_RETRANS () {0x010;}' unless defined(&NFSMNT_RETRANS);
	eval 'sub NFSMNT_HOSTNAME () {0x020;}' unless defined(&NFSMNT_HOSTNAME);
	eval 'sub NFSMNT_INT () {0x040;}' unless defined(&NFSMNT_INT);
	eval 'sub NFSMNT_NODEVS () {0x080;}' unless defined(&NFSMNT_NODEVS);
	eval 'sub NFSMNT_FSNAME () {0x100;}' unless defined(&NFSMNT_FSNAME);
	eval 'sub NFSMNT_IGNORE () {0x200;}' unless defined(&NFSMNT_IGNORE);
	eval 'sub NFSMNT_NOAC () {0x400;}' unless defined(&NFSMNT_NOAC);
	eval 'sub NFSMNT_NOCTO () {0x800;}' unless defined(&NFSMNT_NOCTO);
	eval 'sub NFSMNT_DYNAMIC () {0x1000;}' unless defined(&NFSMNT_DYNAMIC);
	eval 'sub NFSMNT_ACREGMIN () {0x02000;}' unless defined(&NFSMNT_ACREGMIN);
	eval 'sub NFSMNT_ACREGMAX () {0x04000;}' unless defined(&NFSMNT_ACREGMAX);
	eval 'sub NFSMNT_ACDIRMIN () {0x08000;}' unless defined(&NFSMNT_ACDIRMIN);
	eval 'sub NFSMNT_ACDIRMAX () {0x10000;}' unless defined(&NFSMNT_ACDIRMAX);
	eval 'sub NFSMNT_DOWN () {0x20000;}' unless defined(&NFSMNT_DOWN);
	eval 'sub NFSEXP_ASYNC_STR () {"async";}' unless defined(&NFSEXP_ASYNC_STR);
	eval 'sub NFSEXP_NO_OPTS () {0x0000;}' unless defined(&NFSEXP_NO_OPTS);
	eval 'sub NFSEXP_ASYNC () {0x0001;}' unless defined(&NFSEXP_ASYNC);
	eval 'sub NFSCALL {
	    local($func) = @_;
    	    eval q((* $nfsproc[$func]));
	}' unless defined(&NFSCALL);
	eval 'sub NFS_INFORMLM () {0;}' unless defined(&NFS_INFORMLM);
	eval 'sub NFS_LMEXIT () {1;}' unless defined(&NFS_LMEXIT);
	unless(defined(&_KERNEL)) {
	    if(defined(&__cplusplus)) {
	    }
	    if(defined(&_PROTOTYPES)) {
	    } else {
	    }
	    if(defined(&__cplusplus)) {
	    }
	}
    }
}
1;
