require '_h2ph_pre.ph';

if(defined(&_KERNEL_BUILD)) {
    require '../h/ioctl.ph';
} else {
    require 'sys/ioctl.ph';
    require 'sys/param.ph';
}
unless(defined(&MAXBUFF)) {
    sub MAXBUFF () {	(32*1024);}
}
unless(defined(&BUF_SIZE_TOO_BIG)) {
    sub BUF_SIZE_TOO_BIG {
	local($size) = @_;
	eval q(($size >=  &MAXBUFF));
    }
}
unless(defined(&EOI)) {
    sub EOI () {	0;}
}
unless(defined(&MAX_SELFTEST_FLAG)) {
    sub MAX_SELFTEST_FLAG () {	0;}
}
unless(defined(&WAIT)) {
    sub WAIT () {	1;}
}
unless(defined(&NO_WAIT)) {
    sub NO_WAIT () {	0;}
}
unless(defined(&INT_OPT)) {
    sub INT_OPT () {	 &WAIT;}
}
unless(defined(&POLL_OPT)) {
    sub POLL_OPT () {	 &NO_WAIT;}
}
unless(defined(&MAX_IODC)) {
    sub MAX_IODC () {	16;}
}
unless(defined(&MAX_SW_VERS)) {
    sub MAX_SW_VERS () {	80;}
}
unless(defined(&MAX_ID_DATA)) {
    sub MAX_ID_DATA () {	 &MAX_IODC +  &MAX_SW_VERS +  &MAX_SW_VERS;}
}
unless(defined(&REG_DATA)) {
    sub REG_DATA () {	4;}
}
unless(defined(&MAX_TIMEOUT)) {
    sub MAX_TIMEOUT () {	1800;}
}
unless(defined(&MIN_TIMEOUT)) {
    sub MIN_TIMEOUT () {	1;}
}
unless(defined(&MIN_REG_NUM)) {
    sub MIN_REG_NUM () {	0;}
}
unless(defined(&MAX_REG_NUM)) {
    sub MAX_REG_NUM () {	(((2*  &NBPG) / 4) - 1);}
}
unless(defined(&INVALID_WAIT_OPT)) {
    sub INVALID_WAIT_OPT {
	local($val) = @_;
	eval q(($val !=  &WAIT)  && ($val !=  &NO_WAIT));
    }
}
unless(defined(&WAIT_OPT_ON)) {
    sub WAIT_OPT_ON {
	local($val) = @_;
	eval q(($val ==  &WAIT));
    }
}
unless(defined(&INVALID_INT_POLL_OPT)) {
    sub INVALID_INT_POLL_OPT {
	local($val) = @_;
	eval q(($val !=  &INT_OPT)  && ($val !=  &POLL_OPT));
    }
}
unless(defined(&INVALID_TIMEOUT)) {
    sub INVALID_TIMEOUT {
	local($val) = @_;
	eval q(($val <  &MIN_TIMEOUT) || ($val >  &MAX_TIMEOUT));
    }
}
unless(defined(&SUCCESS)) {
    sub SUCCESS () {	0;}
}
unless(defined(&FAILURE)) {
    sub FAILURE () {	-1;}
}
unless(defined(&ENDCHAIN)) {
    sub ENDCHAIN () {	1;}
}
unless(defined(&DH1_EOC)) {
    sub DH1_EOC () {	0;}
}
unless(defined(&DH1_RESET_CMD)) {
    sub DH1_RESET_CMD () {	1;}
}
unless(defined(&DH1_LOCK_CMD)) {
    sub DH1_LOCK_CMD () {	2;}
}
unless(defined(&DH1_UNLOCK_CMD)) {
    sub DH1_UNLOCK_CMD () {	3;}
}
unless(defined(&DH1_IDENTIFY_CMD)) {
    sub DH1_IDENTIFY_CMD () {	4;}
}
unless(defined(&DH1_READ_REG_CMD)) {
    sub DH1_READ_REG_CMD () {	5;}
}
unless(defined(&DH1_WRITE_REG_CMD)) {
    sub DH1_WRITE_REG_CMD () {	6;}
}
unless(defined(&DH1_HPIB_INPUT_CMD)) {
    sub DH1_HPIB_INPUT_CMD () {	7;}
}
unless(defined(&DH1_HPIB_OUTPUT_CMD)) {
    sub DH1_HPIB_OUTPUT_CMD () {	8;}
}
unless(defined(&DH1_LOOPBACK_CMD)) {
    sub DH1_LOOPBACK_CMD () {	9;}
}
unless(defined(&DH1_STATUS_CMD)) {
    sub DH1_STATUS_CMD () {	10;}
}
unless(defined(&DH1_SELFTEST_CMD)) {
    sub DH1_SELFTEST_CMD () {	11;}
}
unless(defined(&write_reg_t)) {
    sub write_reg_t () {	 &read_reg_t;}
}
unless(defined(&hpib_output_t)) {
    sub hpib_output_t () {	 &hpib_input_t;}
}
unless(defined(&DH1_BUF_FULL)) {
    sub DH1_BUF_FULL () {	0x40;}
}
unless(defined(&DH1_NOT_ENOUGH_SPACE)) {
    sub DH1_NOT_ENOUGH_SPACE () {	0x80;}
}
unless(defined(&DH1_NOT_ENOUGH_DATA)) {
    sub DH1_NOT_ENOUGH_DATA () {	0x100;}
}
unless(defined(&DH1_INVALID_CMD)) {
    sub DH1_INVALID_CMD () {	0x200;}
}
unless(defined(&DH1_UNIMPLEMENTED)) {
    sub DH1_UNIMPLEMENTED () {	0x400;}
}
unless(defined(&DH1_INVALID_REG_OFFSET)) {
    sub DH1_INVALID_REG_OFFSET () {	0x800;}
}
unless(defined(&DH1_INVALID_TIMEOUT)) {
    sub DH1_INVALID_TIMEOUT () {	0x1000;}
}
unless(defined(&DH1_INVALID_WAIT_OPT)) {
    sub DH1_INVALID_WAIT_OPT () {	0x2000;}
}
unless(defined(&DH1_INVALID_INT_POLL_OPT)) {
    sub DH1_INVALID_INT_POLL_OPT () {	0x4000;}
}
unless(defined(&DH1_NOT_LOCKED)) {
    sub DH1_NOT_LOCKED () {	0x8000;}
}
unless(defined(&DH1_LOCKED_BY_OTHER)) {
    sub DH1_LOCKED_BY_OTHER () {	0x10000;}
}
unless(defined(&DH1_ALREADY_LOCKED)) {
    sub DH1_ALREADY_LOCKED () {	0x20000;}
}
unless(defined(&DH1_ALREADY_UNLOCKED)) {
    sub DH1_ALREADY_UNLOCKED () {	0x40000;}
}
unless(defined(&DH1_EARLY_EOC)) {
    sub DH1_EARLY_EOC () {	0x80000;}
}
unless(defined(&DH1_TIMEOUT)) {
    sub DH1_TIMEOUT () {	0x200000;}
}
unless(defined(&DH1_HW_PROBLEM)) {
    sub DH1_HW_PROBLEM () {	0x1000000;}
}
unless(defined(&DH1_SW_PROBLEM)) {
    sub DH1_SW_PROBLEM () {	0x2000000;}
}
unless(defined(&DH1_BAD_CHECKSUM)) {
    sub DH1_BAD_CHECKSUM () {	0x4000000;}
}
unless(defined(&DH1_CARD_NOT_PRESENT)) {
    sub DH1_CARD_NOT_PRESENT () {	0x8000000;}
}
unless(defined(&DH1_POWERFAIL)) {
    sub DH1_POWERFAIL () {	0x10000000;}
}
unless(defined(&DH1_UNEXPECTED_INTERRUPT)) {
    sub DH1_UNEXPECTED_INTERRUPT () {	0x80000000;}
}
unless(defined(&DH1_DIAG_UNEXPLAIN)) {
    sub DH1_DIAG_UNEXPLAIN () {	0x1000;}
}
unless(defined(&DH1_DIAG_SHZM)) {
    sub DH1_DIAG_SHZM () {	0x0800;}
}
unless(defined(&DH1_DIAG_GET)) {
    sub DH1_DIAG_GET () {	0x0400;}
}
unless(defined(&DH1_DIAG_IFC)) {
    sub DH1_DIAG_IFC () {	0x0200;}
}
unless(defined(&DH1_DIAG_PARITY)) {
    sub DH1_DIAG_PARITY () {	0x0100;}
}
unless(defined(&DH1_DIAG_STAT_CHNG)) {
    sub DH1_DIAG_STAT_CHNG () {	0x0080;}
}
unless(defined(&DH1_DIAG_HNDSHK_ABORT)) {
    sub DH1_DIAG_HNDSHK_ABORT () {	0x0040;}
}
unless(defined(&DH1_DIAG_PPOLL)) {
    sub DH1_DIAG_PPOLL () {	0x0020;}
}
unless(defined(&DH1_DIAG_SRQ)) {
    sub DH1_DIAG_SRQ () {	0x0010;}
}
unless(defined(&DH1_DIAG_OUT_AVL)) {
    sub DH1_DIAG_OUT_AVL () {	0x0008;}
}
unless(defined(&DH1_DIAG_IN_AVL)) {
    sub DH1_DIAG_IN_AVL () {	0x0004;}
}
unless(defined(&DH1_DIAG_FIFO_IDL)) {
    sub DH1_DIAG_FIFO_IDL () {	0x0002;}
}
unless(defined(&DH1_DIAG_DCL)) {
    sub DH1_DIAG_DCL () {	0x0001;}
}
unless(defined(&DIAGHPIB1_CMD_CHAIN)) {
    sub DIAGHPIB1_CMD_CHAIN () {	 &_IOW(ord('D'), 0,  &dh1_hdr_t);}
}
1;
