require '_h2ph_pre.ph';

require '../io/ioparams.ph';
unless(defined(&MAX_HEADROOM)) {
    sub MAX_HEADROOM () {	$sizeof{ &dh1_hdr_t};}
}
unless(defined(&MAX_RETRY_COUNT)) {
    sub MAX_RETRY_COUNT () {	12;}
}
unless(defined(&MAX_MSGS_OUTSTANDING)) {
    sub MAX_MSGS_OUTSTANDING () {	5;}
}
unless(defined(&DH1_NUM_SUBQUEUES)) {
    sub DH1_NUM_SUBQUEUES () {	32;}
}
unless(defined(&MY_REV_CODE)) {
    sub MY_REV_CODE () {	1;}
}
unless(defined(&CONFIG_SUBQ)) {
    sub CONFIG_SUBQ () {	1;}
}
unless(defined(&DAMS_BIND_REQ_SUBQ)) {
    sub DAMS_BIND_REQ_SUBQ () {	 &CONFIG_SUBQ;}
}
unless(defined(&MY_BIND_REPLY_SUBQ)) {
    sub MY_BIND_REPLY_SUBQ () {	 &CONFIG_SUBQ;}
}
unless(defined(&LU)) {
    sub LU {
	local($x) = @_;
	eval q(( &minor($x) & 0x000000ff));
    }
}
unless(defined(&REPLY_SUBQ)) {
    sub REPLY_SUBQ () {	4;}
}
unless(defined(&LOCK_REQ_SUBQ)) {
    sub LOCK_REQ_SUBQ () {	1;}
}
unless(defined(&LOCK_REPLY_SUBQ)) {
    sub LOCK_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&UNLOCK_REPLY_SUBQ)) {
    sub UNLOCK_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&RESET_REPLY_SUBQ)) {
    sub RESET_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&ID_REPLY_SUBQ)) {
    sub ID_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&SELFTEST_REPLY_SUBQ)) {
    sub SELFTEST_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&READ_REPLY_SUBQ)) {
    sub READ_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&HPIB_INPUT_REPLY_SUBQ)) {
    sub HPIB_INPUT_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&WRITE_REPLY_SUBQ)) {
    sub WRITE_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&HPIB_OUTPUT_REPLY_SUBQ)) {
    sub HPIB_OUTPUT_REPLY_SUBQ () {	 &REPLY_SUBQ;}
}
unless(defined(&MY_EVENT_SUBQ)) {
    sub MY_EVENT_SUBQ () {	 &REPLY_SUBQ - 1;}
}
unless(defined(&DH1_PRIORITY)) {
    sub DH1_PRIORITY () {	 &PRIBIO;}
}
unless(defined(&LOG_INVALID_STRATEGY_SWITCH)) {
    sub LOG_INVALID_STRATEGY_SWITCH () {	0;}
}
unless(defined(&LOG_INVALID_MSG)) {
    sub LOG_INVALID_MSG () {	1;}
}
unless(defined(&LOG_INVALID_LLIO_ERROR_NUM)) {
    sub LOG_INVALID_LLIO_ERROR_NUM () {	2;}
}
unless(defined(&NOT_CONFIG_OR_PF_MSG)) {
    sub NOT_CONFIG_OR_PF_MSG {
	local($msgtype) = @_;
	eval q(($msgtype !=  &CREATION_MSG  && $msgtype !=  &DO_BIND_REQ_MSG  && $msgtype !=  &BIND_REPLY_MSG  && $msgtype !=  &POWER_ON_REQ_MSG));
    }
}
unless(defined(&INVALID_DIAG_OPTION)) {
    sub INVALID_DIAG_OPTION {
	local($dopt) = @_;
	eval q((($dopt !=  &HW_IDENTIFY)  && ($dopt !=  &HW_SELFTEST)  && ($dopt !=  &HPIB_READ_REG)  && ($dopt !=  &HPIB_WRITE_REG)  && ($dopt !=  &HPIB_INPUT)  && ($dopt !=  &HPIB_OUTPUT)));
    }
}
unless(defined(&INVALID_DIAG_MSG)) {
    sub INVALID_DIAG_MSG () {	-1;}
}
unless(defined(&CURR_CMD)) {
    sub CURR_CMD () {	 ($pda->{cmdbuf_ptr}->{cmd});}
}
unless(defined(&CURR_CMD_INFO)) {
    sub CURR_CMD_INFO () {	 ($pda->{cmdbuf_ptr}->{cmd_info});}
}
unless(defined(&THIS_SELFTEST)) {
    sub THIS_SELFTEST () {	 ($CURR_CMD_INFO->{selftest_struct});}
}
unless(defined(&THIS_ID)) {
    sub THIS_ID () {	 ($CURR_CMD_INFO->{id_struct});}
}
unless(defined(&THIS_READ)) {
    sub THIS_READ () {	 ($CURR_CMD_INFO->{read_reg_struct});}
}
unless(defined(&THIS_WRITE)) {
    sub THIS_WRITE () {	 ($CURR_CMD_INFO->{write_reg_struct});}
}
unless(defined(&THIS_HPIB_INPUT)) {
    sub THIS_HPIB_INPUT () {	 ($CURR_CMD_INFO->{hpib_input_struct});}
}
unless(defined(&THIS_HPIB_OUTPUT)) {
    sub THIS_HPIB_OUTPUT () {	 ($CURR_CMD_INFO->{hpib_output_struct});}
}
unless(defined(&M_HDR)) {
    sub M_HDR () {	 ($msg_ptr->{msg_header});}
}
unless(defined(&M_CREATE)) {
    sub M_CREATE () {	 ($msg_ptr->{u}->{creation_info});}
}
unless(defined(&M_DO_BIND_REQ)) {
    sub M_DO_BIND_REQ () {	 ($msg_ptr->{u}->{do_bind_req});}
}
unless(defined(&M_DO_BIND_REPLY)) {
    sub M_DO_BIND_REPLY () {	 ($msg_ptr->{u}->{do_bind_reply});}
}
unless(defined(&M_BIND_REQ)) {
    sub M_BIND_REQ () {	 ($msg_ptr->{u}->{bind_req});}
}
unless(defined(&M_BIND_REPLY)) {
    sub M_BIND_REPLY () {	 ($msg_ptr->{u}->{bind_reply});}
}
unless(defined(&M_DIAG_REQ)) {
    sub M_DIAG_REQ () {	 ($msg_ptr->{u}->{diag_req});}
}
unless(defined(&M_UTIL_REQ)) {
    sub M_UTIL_REQ () {	 ($msg_ptr->{u}->{diag_req}->{u}->{hw_util_info});}
}
unless(defined(&M_IDENT_REQ)) {
    sub M_IDENT_REQ () {	 ($msg_ptr->{u}->{diag_req}->{u}->{hw_identify_info});}
}
unless(defined(&M_SELFTEST_REQ)) {
    sub M_SELFTEST_REQ () {	 ($msg_ptr->{u}->{diag_req}->{u}->{hw_self_test_info});}
}
unless(defined(&M_DIAG_REPLY)) {
    sub M_DIAG_REPLY () {	 ($msg_ptr->{u}->{diag_reply});}
}
unless(defined(&M_DIAG_EVENT)) {
    sub M_DIAG_EVENT () {	 ($msg_ptr->{u}->{diag_event});}
}
unless(defined(&M_RESET_REQ)) {
    sub M_RESET_REQ () {	 ($msg_ptr->{u}->{reset_req});}
}
unless(defined(&M_RESET_REPLY)) {
    sub M_RESET_REPLY () {	 ($msg_ptr->{u}->{reset_reply});}
}
unless(defined(&M_LOCK_REQ)) {
    sub M_LOCK_REQ () {	 ($msg_ptr->{u}->{lock_req});}
}
unless(defined(&M_LOCK_REPLY)) {
    sub M_LOCK_REPLY () {	 ($msg_ptr->{u}->{lock_reply});}
}
unless(defined(&M_UNLOCK_REQ)) {
    sub M_UNLOCK_REQ () {	 ($msg_ptr->{u}->{unlock_req});}
}
unless(defined(&M_UNLOCK_REPLY)) {
    sub M_UNLOCK_REPLY () {	 ($msg_ptr->{u}->{unlock_reply});}
}
unless(defined(&M_EVENT)) {
    sub M_EVENT () {	 ($msg_ptr->{u}->{dam_event});}
}
unless(defined(&MSG)) {
    sub MSG {
	local($msg_type) = @_;
	eval q( ($mp->{v}->{msg_type}));
    }
}
unless(defined(&MSG_LENGTH)) {
    sub MSG_LENGTH {
	local($msg_type) = @_;
	eval q(($sizeof{ &llio_std_header_type}+$sizeof{$msg_type}));
    }
}
unless(defined(&RECOVERING_FROM_ERROR)) {
    sub RECOVERING_FROM_ERROR {
	local($pda) = @_;
	eval q(( ($pda->{error_handling_flag}) ==  &YES));
    }
}
unless(defined(&ERROR_FLAG_SET)) {
    sub ERROR_FLAG_SET {
	local($pda) = @_;
	eval q(( ($pda->{error_handling_flag}) ==  &YES));
    }
}
unless(defined(&ERROR_OCCURRED)) {
    sub ERROR_OCCURRED {
	local($reply_status,$pda) = @_;
	eval q((($reply_status !=  &SUCCESS) || ( ($pda->{int_occurrence}) !=  &NO)));
    }
}
unless(defined(&INT_OCCURRED)) {
    sub INT_OCCURRED {
	local($pda) = @_;
	eval q(( ($pda->{int_occurrence}) ==  &YES));
    }
}
unless(defined(&CMD_ERR_OCCURRED)) {
    sub CMD_ERR_OCCURRED {
	local($reply_status) = @_;
	eval q(($reply_status !=  &SUCCESS));
    }
}
unless(defined(&CMD_AND_INT_ERROR)) {
    sub CMD_AND_INT_ERROR {
	local($pda) = @_;
	eval q((( ($pda->{cmd_count}) ==  ($pda->{int_cmd_count}))  && ( ($pda->{status}) !=  &SUCCESS)  && ( ($pda->{int_status}) !=  &SUCCESS)));
    }
}
unless(defined(&CMD_ERROR_ONLY)) {
    sub CMD_ERROR_ONLY {
	local($pda) = @_;
	eval q((( ($pda->{status}) !=  &SUCCESS)  && (( ($pda->{int_status}) ==  &SUCCESS) || (( ($pda->{cmd_count}) <  ($pda->{int_cmd_count}))  && ( ($pda->{int_status}) !=  &SUCCESS)) )));
    }
}
unless(defined(&INT_ERROR_ONLY)) {
    sub INT_ERROR_ONLY {
	local($pda) = @_;
	eval q((( ($pda->{int_status}) !=  &SUCCESS)  && (( ($pda->{status}) ==  &SUCCESS) || (( ($pda->{int_cmd_count}) <  ($pda->{cmd_count}))  && ( ($pda->{status}) !=  &SUCCESS)) )));
    }
}
unless(defined(&BYTE_ALIGNED)) {
    sub BYTE_ALIGNED () {	1;}
}
unless(defined(&COPYIN)) {
    sub COPYIN () {	1;}
}
unless(defined(&COPYOUT)) {
    sub COPYOUT () {	-1;}
}
unless(defined(&NULL_PDA)) {
    sub NULL_PDA () {	 0;}
}
unless(defined(&NULL_MSG)) {
    sub NULL_MSG () {	 0;}
}
unless(defined(&DONT_CARE)) {
    sub DONT_CARE () {	0;}
}
unless(defined(&YES)) {
    eval 'sub YES () { &TRUE;}' unless defined(&YES);
}
unless(defined(&NO)) {
    eval 'sub NO () { &FALSE;}' unless defined(&NO);
}
1;
