require '_h2ph_pre.ph';

unless(defined(&NUM_OPENS_PER_LU)) {
    sub NUM_OPENS_PER_LU () {	16;}
}
unless(defined(&OPEN_BITS)) {
    sub OPEN_BITS () {	0xf;}
}
unless(defined(&LOGICAL_UNIT_SHIFT)) {
    sub LOGICAL_UNIT_SHIFT () {	8;}
}
unless(defined(&LOGICAL_UNIT_MASK)) {
    sub LOGICAL_UNIT_MASK () {	0xff;}
}
unless(defined(&DIAG_BIT_MASK)) {
    sub DIAG_BIT_MASK () {	0x800000;}
}
unless(defined(&RESERVED_BITS)) {
    sub RESERVED_BITS {
	local($dev) = @_;
	eval q(($dev & 0x7f00ff));
    }
}
unless(defined(&LU)) {
    sub LU {
	local( $dev ) = @_;
	eval q((( &minor( $dev ) >>  &LOGICAL_UNIT_SHIFT) &  &LOGICAL_UNIT_MASK));
    }
}
unless(defined(&GPIO_DIAG_REQ)) {
    sub GPIO_DIAG_REQ {
	local( $dev ) = @_;
	eval q(( &minor( $dev ) &  &DIAG_BIT_MASK));
    }
}
unless(defined(&SET_MINOR)) {
    sub SET_MINOR {
	local( $dev, $index ) = @_;
	eval q((( &minor( $dev ) & (~( &OPEN_BITS))) | $index));
    }
}
unless(defined(&GET_OPEN_INDEX)) {
    sub GET_OPEN_INDEX {
	local( $dev ) = @_;
	eval q(( &minor( $dev ) &  &OPEN_BITS));
    }
}
1;
