require '_h2ph_pre.ph';

if(defined(&_KERNEL_BUILD)) {
    require '../h/proc_iface.ph';
    require '../h/kthread_iface.ph';
    require '../h/signal.ph';
}
unless(defined(&KERNELSPACE)) {
    eval 'sub KERNELSPACE () {0;}' unless defined(&KERNELSPACE);
}
unless(defined(&LDM_PRIMORDIAL)) {
    sub LDM_PRIMORDIAL () {	-1;}
}
unless(defined(&LDM_CREATED)) {
    sub LDM_CREATED () {	0;}
}
unless(defined(&LDM_BINDING)) {
    sub LDM_BINDING () {	1;}
}
unless(defined(&LDM_NORMAL)) {
    sub LDM_NORMAL () {	2;}
}
unless(defined(&LDM_UNBOUND)) {
    sub LDM_UNBOUND () {	-2;}
}
unless(defined(&POWERFAIL_SUBQ)) {
    sub POWERFAIL_SUBQ () {	 0;}
}
unless(defined(&CONFIGURATION_SUBQ)) {
    sub CONFIGURATION_SUBQ () {	 1;}
}
unless(defined(&DAM_EVENT_SUBQ)) {
    sub DAM_EVENT_SUBQ () {	 1;}
}
unless(defined(&DAM_REPLY_SUBQ)) {
    sub DAM_REPLY_SUBQ () {	 2;}
}
unless(defined(&REQ_SUBQ)) {
    sub REQ_SUBQ () {	 3;}
}
unless(defined(&WAITS_SUBQ)) {
    sub WAITS_SUBQ () {	 4;}
}
unless(defined(&NSUBQS)) {
    sub NSUBQS () {	3;}
}
unless(defined(&Descriptor)) {
    sub Descriptor () {	 ($msg_header->{msg_descriptor});}
}
unless(defined(&Msg_id)) {
    sub Msg_id () {	 ($msg_header->{message_id});}
}
unless(defined(&Transaction)) {
    sub Transaction () {	 ($msg_header->{transaction_num});}
}
unless(defined(&From_port)) {
    sub From_port () {	 ($msg_header->{from_port});}
}
unless(defined(&Bind_reply_status)) {
    sub Bind_reply_status () {	 ($u->{bind_reply}->{reply_status}->{is_ok});}
}
unless(defined(&Do_bind_reply_status)) {
    sub Do_bind_reply_status () {	 ($u->{do_bind_reply}->{reply_status}->{is_ok});}
}
unless(defined(&Do_bind_reply_subsys)) {
    sub Do_bind_reply_subsys () {	 ($u->{do_bind_reply}->{reply_status}->{u}->{subsystem});}
}
unless(defined(&Dam_request_subq)) {
    sub Dam_request_subq () {	 ($u->{bind_reply}->{lm_hi_req_subq});}
}
unless(defined(&Dam_reply_status)) {
    sub Dam_reply_status () {	 ($u->{dam_reply}->{reply_status}->{is_ok});}
}
unless(defined(&Dam_reply_error)) {
    sub Dam_reply_error () {	 ($u->{dam_reply}->{reply_status}->{u}->{error_num});}
}
unless(defined(&Req_cmd_ptr)) {
    sub Req_cmd_ptr () {	 ($u->{dam_req}->{request_parms}->{cmd_ptr});}
}
unless(defined(&Req_cmd_count)) {
    sub Req_cmd_count () {	 ($u->{dam_req}->{request_parms}->{cmd_count});}
}
unless(defined(&Req_cmd_class)) {
    sub Req_cmd_class () {	 ($u->{dam_req}->{request_parms}->{cmd_class});}
}
unless(defined(&Req_data_ptr)) {
    sub Req_data_ptr () {	 ($u->{dam_req}->{request_parms}->{data_ptr});}
}
unless(defined(&Req_data_buffer)) {
    sub Req_data_buffer () {	 ($u->{dam_req}->{request_parms}->{data_ptr}->{u}->{data_vba});}
}
unless(defined(&Req_data_space)) {
    sub Req_data_space () {	 ($u->{dam_req}->{request_parms}->{data_ptr}->{u}->{data_sid});}
}
unless(defined(&Req_data_count)) {
    sub Req_data_count () {	 ($u->{dam_req}->{request_parms}->{data_count});}
}
unless(defined(&Req_data_class)) {
    sub Req_data_class () {	 ($u->{dam_req}->{request_parms}->{data_class});}
}
unless(defined(&Req_status_count)) {
    sub Req_status_count () {	 ($u->{dam_req}->{request_parms}->{status_count});}
}
unless(defined(&Req_dev_address)) {
    sub Req_dev_address () {	 ($u->{dam_req}->{device_number});}
}
unless(defined(&Req_reply_subq)) {
    sub Req_reply_subq () {	 ($u->{dam_req}->{reply_subq});}
}
unless(defined(&Req_transfer_dir)) {
    sub Req_transfer_dir () {	 ($u->{dam_req}->{transfer_dir});}
}
unless(defined(&Req_type)) {
    sub Req_type () {	 ($u->{dam_req}->{request});}
}
unless(defined(&Req_termination_mode)) {
    sub Req_termination_mode () {	 ($u->{dam_req}->{u}->{hpib_req}->{termination_conds});}
}
unless(defined(&Req_match_char)) {
    sub Req_match_char () {	 ($u->{dam_req}->{u}->{hpib_req}->{matched_byte});}
}
unless(defined(&Req_crc)) {
    sub Req_crc () {	 ($u->{dam_req}->{u}->{hpib_req}->{crc});}
}
unless(defined(&Req_fcode)) {
    sub Req_fcode () {	 ($u->{dam_req}->{u}->{da_req});}
}
unless(defined(&Reply_data_residue)) {
    sub Reply_data_residue () {	 ($u->{dam_reply}->{data_residue});}
}
unless(defined(&Reply_data_ptr)) {
    sub Reply_data_ptr () {	 ($u->{dam_reply}->{request_parms}->{data_ptr}->{u}->{data_vba});}
}
unless(defined(&Reply_status)) {
    sub Reply_status () {	 ($p_status->{is_ok});}
}
unless(defined(&Reply_error)) {
    sub Reply_error () {	 ($p_status->{u}->{error_num});}
}
unless(defined(&Diag_opt)) {
    sub Diag_opt () {	 ($p_diag_info->{util_opt});}
}
unless(defined(&Diag_len)) {
    sub Diag_len () {	 ($p_diag_info->{util_len});}
}
unless(defined(&Diag_data_buffer)) {
    sub Diag_data_buffer () {	 ($p_diag_info->{util_buff}->{u}->{data_vba});}
}
unless(defined(&Diag_data_space)) {
    sub Diag_data_space () {	 ($p_diag_info->{util_buff}->{u}->{data_sid});}
}
unless(defined(&Diag_xfer_count)) {
    sub Diag_xfer_count () {	 ($u->{diag_reply}->{transfer_count});}
}
unless(defined(&Sizeof)) {
    sub Sizeof {
	local($x) = @_;
	eval q($sizeof{ &llio_std_header_type}+$sizeof{$x});
    }
}
unless(defined(&HPIB_LDM_REVISION)) {
    sub HPIB_LDM_REVISION () {	2240;}
}
unless(defined(&NO_REPLY)) {
    sub NO_REPLY () {	-1;}
}
if(defined(&_KERNEL)) {
    eval 'sub HAS_BEEN_KILLED {
        local( $p ) = @_;
	    eval q((  &ksigisxsect( (*( &kt_sig( &p_firstthreadp( &p)))),  &deadsigs) ));
    }' unless defined(&HAS_BEEN_KILLED);
    eval 'sub IS_KILLED {
        local( $p ) = @_;
	    eval q(( ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGKILL) || ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGINT) || ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGTERM) || ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGQUIT) ));
    }' unless defined(&IS_KILLED);
    eval 'sub MY_PID () { &p_pid( ($udot->{u_procp}));}' unless defined(&MY_PID);
    eval 'sub GOT_SIGNALLED () {1;}' unless defined(&GOT_SIGNALLED);
}
unless(defined(&F_DAM_LOCKED)) {
    sub F_DAM_LOCKED () {	0x01;}
}
unless(defined(&NO_PPOLL)) {
    sub NO_PPOLL () {	0xff;}
}
unless(defined(&RAW_BUS)) {
    sub RAW_BUS () {	31;}
}
unless(defined(&DISABLE)) {
    sub DISABLE () {	0;}
}
unless(defined(&WAIT)) {
    sub WAIT () {	1;}
}
unless(defined(&NO_WAIT)) {
    sub NO_WAIT () {	0;}
}
unless(defined(&CIC)) {
    sub CIC () {	30;}
}
unless(defined(&LTN)) {
    sub LTN {
	local($x) = @_;
	eval q(($x | 0x20));
    }
}
unless(defined(&TLK)) {
    sub TLK {
	local($x) = @_;
	eval q(($x | 0x40));
    }
}
unless(defined(&UNLISTEN)) {
    sub UNLISTEN () {	 &LTN(31);}
}
unless(defined(&GTL)) {
    sub GTL () {	 0x01;}
}
unless(defined(&PPC)) {
    sub PPC () {	 0x05;}
}
unless(defined(&PPD)) {
    sub PPD () {	 0x70;}
}
unless(defined(&PPE)) {
    sub PPE () {	 0x60;}
}
unless(defined(&SDC)) {
    sub SDC () {	 0x04;}
}
unless(defined(&SPE)) {
    sub SPE () {	 0x18;}
}
unless(defined(&TCT)) {
    sub TCT () {	 0x09;}
}
unless(defined(&TR_UNA)) {
    sub TR_UNA () {	0x10;}
}
unless(defined(&TR_LF)) {
    sub TR_LF () {	0x02;}
}
unless(defined(&TR_EOI)) {
    sub TR_EOI () {	0x01;}
}
unless(defined(&CARD_ADDRESS)) {
    sub CARD_ADDRESS {
	local($x) = @_;
	eval q(($x & 0x1f000000) >> 24);
    }
}
unless(defined(&ST_ONLINE)) {
    sub ST_ONLINE () {	0x80000000;}
}
unless(defined(&ST_MSA)) {
    sub ST_MSA () {	0x00200000;}
}
unless(defined(&ST_FROZEN)) {
    sub ST_FROZEN () {	0x00000100;}
}
unless(defined(&ST_NCC)) {
    sub ST_NCC () {	0x00000080;}
}
unless(defined(&ST_HSD)) {
    sub ST_HSD () {	0x00000040;}
}
unless(defined(&ST_PTY)) {
    sub ST_PTY () {	0x00000020;}
}
unless(defined(&ST_RPO)) {
    sub ST_RPO () {	0x00000008;}
}
unless(defined(&NULL_PDA)) {
    sub NULL_PDA () {	 0;}
}
unless(defined(&NULL_MSG)) {
    sub NULL_MSG () {	 0;}
}
unless(defined(&NULL_DCS)) {
    sub NULL_DCS () {	 0;}
}
unless(defined(&VALID_RAW_SIGS)) {
    sub VALID_RAW_SIGS () {	( &ST_MSA |  &ST_NCC |  &ST_PTY |  &ST_DAT |  &ST_SRQ |  &ST_REN |  &ST_ACTIVE_CTLR |  &ST_TALK |  &ST_LISTEN |  &ST_GET |  &ST_DCL |  &ST_IFC |  &ST_PPOLL);}
}
unless(defined(&VALID_DEV_SIGS)) {
    sub VALID_DEV_SIGS () {	( &ST_SRQ |  &ST_PPOLL);}
}
unless(defined(&HPIB_READ)) {
    sub HPIB_READ () {	 &FCODE_MAX+1;}
}
unless(defined(&HPIB_WRITE)) {
    sub HPIB_WRITE () {	 &FCODE_MAX+2;}
}
unless(defined(&HPIB_CMD)) {
    sub HPIB_CMD () {	 &FCODE_MAX+3;}
}
unless(defined(&D_CTL)) {
    sub D_CTL () {	0x01;}
}
unless(defined(&D_STS)) {
    sub D_STS () {	0x02;}
}
unless(defined(&D_NONE)) {
    sub D_NONE () {	0x00;}
}
unless(defined(&D_CMD)) {
    sub D_CMD () {	0;}
}
unless(defined(&D_DATA)) {
    sub D_DATA () {	1;}
}
unless(defined(&D_TYPE)) {
    sub D_TYPE () {	2;}
}
unless(defined(&D_NEEDS)) {
    sub D_NEEDS () {	3;}
}
unless(defined(&STATUS_TO_MASK)) {
    sub STATUS_TO_MASK {
	local($s, $m) = @_;
	eval q($m = (($s &  &ST_ACTIVE_CTLR ) << 11| ($s & ( &ST_REN| &ST_TALK| &ST_LISTEN| &ST_DAT| &ST_NCC| &ST_PTY| &ST_GET| &ST_IFC)) << 9| ($s & ( &ST_SRQ| &ST_DCL)) << 6| ($s &  &ST_MSA) >> 6));
    }
}
unless(defined(&MASK_TO_STATUS)) {
    sub MASK_TO_STATUS {
	local($m, $s) = @_;
	eval q($s = (($m & 0x00800000) >> 11| ($m & 0x004f6200) >> 9| ($m & 0x00100100) >> 6| ($m & 0x00008000) << 6));
    }
}
unless(defined(&PPOLL_MASK)) {
    sub PPOLL_MASK {
	local($addr) = @_;
	eval q((1<< (23- $addr)));
    }
}
unless(defined(&CLOSE_UNLOCK)) {
    sub CLOSE_UNLOCK () {	 &CLEAR_ALL_LOCKS+1;}
}
1;
