require '_h2ph_pre.ph';

unless(defined(&STATUS)) {
    sub STATUS () {	 ($llio_status->{u}->{error_num});}
}
unless(defined(&KEEP_MSG)) {
    sub KEEP_MSG () {	 &FALSE;}
}
unless(defined(&RELEASE_MSG)) {
    sub RELEASE_MSG () {	 &TRUE;}
}
unless(defined(&MAX_SUBQS)) {
    sub MAX_SUBQS () {	5;}
}
unless(defined(&SUBQ_MASK)) {
    sub SUBQ_MASK () {	 &ELEMENT_OF_32( &PFAIL_SUBQ) |  &ELEMENT_OF_32( &IO_CONFIG_SUBQ) |  &ELEMENT_OF_32( &IO_DIAGNOSTICS_SUBQ);}
}
unless(defined(&MAX_MSGS)) {
    sub MAX_MSGS () {	100;}
}
unless(defined(&MAX_MSG_SIZE)) {
    sub MAX_MSG_SIZE () {	($sizeof{ &msg_type});}
}
unless(defined(&BIND)) {
    sub BIND () {	 ($msg_ptr->{msg_union}->{bind_req_msg});}
}
unless(defined(&BOUND)) {
    sub BOUND () {	 ($msg_ptr->{msg_union}->{bind_reply_msg});}
}
unless(defined(&CREATE)) {
    sub CREATE () {	 ($msg_ptr->{msg_union}->{create_msg});}
}
unless(defined(&DOBIND)) {
    sub DOBIND () {	 ($msg_ptr->{msg_union}->{do_bind_req_msg});}
}
unless(defined(&DOBOUND)) {
    sub DOBOUND () {	 ($msg_ptr->{msg_union}->{do_bind_reply_msg});}
}
unless(defined(&PROBE)) {
    sub PROBE () {	 ($msg_ptr->{msg_union}->{probe_req_msg});}
}
unless(defined(&PROBED)) {
    sub PROBED () {	 ($msg_ptr->{msg_union}->{probe_reply_msg});}
}
unless(defined(&MSG_PTR)) {
    sub MSG_PTR () {	 &msg_ptr;}
}
unless(defined(&HEADER_LEN)) {
    sub HEADER_LEN () {	$sizeof{ &llio_std_header_type};}
}
unless(defined(&HEADER)) {
    sub HEADER () {	 ($msg_ptr->{msg_header});}
}
unless(defined(&MSG_NUM)) {
    sub MSG_NUM () {	 ($HEADER->{msg_descriptor});}
}
unless(defined(&BIND_MSG_LEN)) {
    sub BIND_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &bind_req_type});}
}
unless(defined(&BOUND_MSG_LEN)) {
    sub BOUND_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &bind_reply_type});}
}
unless(defined(&CTRL_MSG_LEN)) {
    sub CTRL_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &cio_ctrl_req_type});}
}
unless(defined(&DB_MSG_LEN)) {
    sub DB_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &do_bind_req_type});}
}
unless(defined(&DBR_MSG_LEN)) {
    sub DBR_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &do_bind_reply_type});}
}
unless(defined(&PROBE_MSG_LEN)) {
    sub PROBE_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &probe_req_type});}
}
unless(defined(&PROBED_MSG_LEN)) {
    sub PROBED_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &probe_reply_type});}
}
unless(defined(&PFAIL_REPLY_LEN)) {
    sub PFAIL_REPLY_LEN () {	 &HEADER_LEN;}
}
unless(defined(&CREATE_MASK)) {
    sub CREATE_MASK () {	 &ELEMENT_OF_32( &MGR_ICS_EXECUTABLE) |  &ELEMENT_OF_32( &MGR_PROC_EXECUTABLE) |  &ELEMENT_OF_32( &MGR_DYNAMIC_DS) |  &ELEMENT_OF_32( &MGR_PROBE);}
}
unless(defined(&ICS_OK)) {
    sub ICS_OK () {	 &ELEMENT_OF_32( &MGR_ICS_EXECUTABLE);}
}
unless(defined(&PROC_OK)) {
    sub PROC_OK () {	 &ELEMENT_OF_32( &MGR_PROC_EXECUTABLE);}
}
unless(defined(&DYNAMIC_OK)) {
    sub DYNAMIC_OK () {	 &ELEMENT_OF_32( &MGR_DYNAMIC_DS);}
}
unless(defined(&PROBE_OK)) {
    sub PROBE_OK () {	 &ELEMENT_OF_32( &MGR_PROBE);}
}
unless(defined(&NUM_MUX4)) {
    sub NUM_MUX4 () {	12;}
}
unless(defined(&NUM_LANMUX_MGR)) {
    sub NUM_LANMUX_MGR () {	4;}
}
unless(defined(&LANMUX_PDA)) {
    sub LANMUX_PDA () {	(* &lanmux_pda_p);}
}
unless(defined(&LANMUX_HANDLE)) {
    sub LANMUX_HANDLE () {	(*( &handle));}
}
unless(defined(&Lanmux_Sema)) {
    sub Lanmux_Sema () {	 ($LANMUX_HANDLE->{lanmux_sema});}
}
unless(defined(&LANMUX_LOCK_ORDER)) {
    sub LANMUX_LOCK_ORDER () {	20;}
}
unless(defined(&LANMUX_LOCK)) {
    sub LANMUX_LOCK () {	 &spinlock( ($LANMUX_HANDLE->{lanmux_lock}));}
}
unless(defined(&LANMUX_UNLOCK)) {
    sub LANMUX_UNLOCK () {	 &spinunlock( ($LANMUX_HANDLE->{lanmux_lock}));}
}
unless(defined(&lanmuxMagic)) {
    sub lanmuxMagic () {	0x02085691;}
}
unless(defined(&LANMUX_MAGIC)) {
    sub LANMUX_MAGIC () {	 ($LANMUX_HANDLE->{magic});}
}
if(defined(&LANMUXDEBUG)) {
    eval 'sub CHECK_MAGIC {
        local($string) = @_;
	    eval q( &if ( &LANMUX_MAGIC !=  &lanmuxMagic)  &panic(\\"string: CHECK_MAGIC failed\\"););
    }' unless defined(&CHECK_MAGIC);
} else {
    eval 'sub CHECK_MAGIC {
        local($string) = @_;
	    eval q();
    }' unless defined(&CHECK_MAGIC);
}
1;
