require '_h2ph_pre.ph';

if(defined(&_KERNEL_BUILD)) {
    require '../h/proc_iface.ph';
    require '../h/kthread_iface.ph';
    require '../h/signal.ph';
}
unless(defined(&LP_RAW)) {
    sub LP_RAW {
	local($x) = @_;
	eval q(( &minor($x) & 0x000008));
    }
}
unless(defined(&LP_CAPSONLY)) {
    sub LP_CAPSONLY {
	local($x) = @_;
	eval q(( &minor($x) & 0x000010));
    }
}
unless(defined(&LP_NOFF)) {
    sub LP_NOFF {
	local($x) = @_;
	eval q(( &minor($x) & 0x000020));
    }
}
unless(defined(&LP_DIAG)) {
    sub LP_DIAG {
	local($x) = @_;
	eval q(( &minor($x) & 0x000080));
    }
}
unless(defined(&LP_EJECT)) {
    sub LP_EJECT {
	local($x) = @_;
	eval q(( &minor($x) & 0x000001));
    }
}
unless(defined(&LP_OLD)) {
    sub LP_OLD {
	local($x) = @_;
	eval q(( &minor($x) & 0x000002));
    }
}
unless(defined(&LP_NOWAIT)) {
    sub LP_NOWAIT {
	local($x) = @_;
	eval q(( &minor($x) & 0x000004));
    }
}
unless(defined(&LP_OPEN)) {
    sub LP_OPEN () {	0x01;}
}
unless(defined(&LP_IO_PENDING)) {
    sub LP_IO_PENDING () {	0x02;}
}
unless(defined(&LP_HOSED)) {
    sub LP_HOSED () {	0x04;}
}
unless(defined(&LP_HAVEBUFS)) {
    sub LP_HAVEBUFS () {	0x08;}
}
unless(defined(&TAB)) {
    sub TAB () {	ord('\t');}
}
unless(defined(&BACKSPACE)) {
    sub BACKSPACE () {	ord('\b');}
}
unless(defined(&FORM_FEED)) {
    sub FORM_FEED () {	ord('\f');}
}
unless(defined(&NEW_LINE)) {
    sub NEW_LINE () {	ord('\n');}
}
unless(defined(&CARRIAGE_RETURN)) {
    sub CARRIAGE_RETURN () {	ord('\r');}
}
unless(defined(&BLANK)) {
    sub BLANK () {	ord(' ');}
}
unless(defined(&CPR_BLOCKSIZE)) {
    sub CPR_BLOCKSIZE () {	992;}
}
unless(defined(&AMG_BLOCKSIZE)) {
    sub AMG_BLOCKSIZE () {	32;}
}
unless(defined(&CENT_BLOCKSIZE)) {
    sub CENT_BLOCKSIZE () {	64;}
}
unless(defined(&MERC_BLOCKSIZE)) {
    sub MERC_BLOCKSIZE () {	1024*8;}
}
unless(defined(&DIAG_BLOCKSIZE)) {
    sub DIAG_BLOCKSIZE () {	1024;}
}
unless(defined(&ONLINE)) {
    sub ONLINE {
	local($x) = @_;
	eval q((($x)-> &p_hwstatus & ( &ELEMENT_OF_32( &GEN_ONLINE))));
    }
}
unless(defined(&BUSY)) {
    sub BUSY {
	local($x) = @_;
	eval q((($x)-> &p_hwstatus & ( &ELEMENT_OF_32( &GEN_DEVICE_BUSY))));
    }
}
unless(defined(&NO_MSG)) {
    sub NO_MSG () {	(0);}
}
unless(defined(&AMIGO_DM)) {
    sub AMIGO_DM {
	local($x) = @_;
	eval q((($x)-> &p_dm_rev == 11));
    }
}
unless(defined(&CIPER_DM)) {
    sub CIPER_DM {
	local($x) = @_;
	eval q((($x)-> &p_dm_rev == 10));
    }
}
unless(defined(&CENT_DM)) {
    sub CENT_DM {
	local($x) = @_;
	eval q((($x)-> &p_dm_rev == 2));
    }
}
unless(defined(&MERC_DM)) {
    sub MERC_DM {
	local($x) = @_;
	eval q((($x)-> &p_dm_rev == 12));
    }
}
unless(defined(&POWERFAIL_SUBQ)) {
    sub POWERFAIL_SUBQ () {	0;}
}
unless(defined(&CONFIG_SUBQ)) {
    sub CONFIG_SUBQ () {	1;}
}
unless(defined(&DM_EVENT_SUBQ)) {
    sub DM_EVENT_SUBQ () {	3;}
}
unless(defined(&DM_REPLY_SUBQ)) {
    sub DM_REPLY_SUBQ () {	4;}
}
unless(defined(&NSUBQS)) {
    sub NSUBQS () {	6;}
}
unless(defined(&LDM_PRIMORDIAL)) {
    sub LDM_PRIMORDIAL () {	-1;}
}
unless(defined(&LDM_CREATED)) {
    sub LDM_CREATED () {	0;}
}
unless(defined(&LDM_BINDING)) {
    sub LDM_BINDING () {	1;}
}
unless(defined(&LDM_NORMAL)) {
    sub LDM_NORMAL () {	2;}
}
unless(defined(&LDM_UNBOUND)) {
    sub LDM_UNBOUND () {	3;}
}
unless(defined(&SEC_10)) {
    sub SEC_10 () {	10000000;}
}
unless(defined(&SEC_HALF)) {
    sub SEC_HALF () {	500000;}
}
if(defined(&_KERNEL)) {
    eval 'sub HAS_BEEN_KILLED {
        local( $p ) = @_;
	    eval q((  &ksigisxsect( (*( &kt_sig( &p_firstthreadp( &p)))),  &deadsigs) ));
    }' unless defined(&HAS_BEEN_KILLED);
    eval 'sub IS_KILLED {
        local( $p ) = @_;
	    eval q(( ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGKILL) || ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGINT) || ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGTERM) || ( &kt_cursig( &p_firstthreadp( &p)) ==  &SIGQUIT) ));
    }' unless defined(&IS_KILLED);
}
unless(defined(&MERC_CLOSE_TOF)) {
    sub MERC_CLOSE_TOF () {	1;}
}
unless(defined(&MERC_CLOSE_FLUSH)) {
    sub MERC_CLOSE_FLUSH () {	2;}
}
unless(defined(&MERC_CLOSE_CLOSE)) {
    sub MERC_CLOSE_CLOSE () {	3;}
}
unless(defined(&MERC_OPEN_TOF)) {
    sub MERC_OPEN_TOF () {	10;}
}
unless(defined(&MERC_OPEN_OPEN)) {
    sub MERC_OPEN_OPEN () {	20;}
}
unless(defined(&MERC_OPEN_STATUS_1)) {
    sub MERC_OPEN_STATUS_1 () {	30;}
}
unless(defined(&MERC_OPEN_STATUS_2)) {
    sub MERC_OPEN_STATUS_2 () {	40;}
}
1;
