require '_h2ph_pre.ph';

require '../io/ioparams.ph';
unless(defined(&SEC_25)) {
    sub SEC_25 () {	25000000;}
}
unless(defined(&DENSITY_FLAG)) {
    sub DENSITY_FLAG () {	0;}
}
unless(defined(&COMPRESSION_FLAG)) {
    sub COMPRESSION_FLAG () {	1;}
}
unless(defined(&POWERFAIL_SUBQ)) {
    sub POWERFAIL_SUBQ () {	0;}
}
unless(defined(&DO_BIND_SUBQ)) {
    sub DO_BIND_SUBQ () {	1;}
}
unless(defined(&DIAG)) {
    sub DIAG () {	2;}
}
unless(defined(&DM_EVENT_SUBQ)) {
    sub DM_EVENT_SUBQ () {	3;}
}
unless(defined(&NSUBQS)) {
    sub NSUBQS () {	5;}
}
unless(defined(&MTLDM_PNUM)) {
    sub MTLDM_PNUM () {	 ($mt->{m_pda}->{mtldm_pnum});}
}
unless(defined(&LM_UNIT)) {
    sub LM_UNIT () {	 ($mt->{m_pda}->{lm_unit});}
}
unless(defined(&HW_PATH_STR)) {
    sub HW_PATH_STR () {	 ($mt->{m_pda}->{hw_path_str});}
}
unless(defined(&DEVICE_INDEX)) {
    sub DEVICE_INDEX () {	((( ($mt->{m_pda}->{dm_stat}->{id})) & 0xff000000) >> 24);}
}
unless(defined(&INQUIRY_DATA)) {
    sub INQUIRY_DATA () {	 ($mt->{m_pda}->{inquiry_info});}
}
unless(defined(&SENSE_DATA)) {
    sub SENSE_DATA () {	 ($mt->{m_pda}->{sense_info});}
}
unless(defined(&GENERIC_STAT)) {
    sub GENERIC_STAT () {	 ($mt->{m_pda}->{dm_stat}->{generic_stat});}
}
unless(defined(&DEV_STAT_MSB)) {
    sub DEV_STAT_MSB () {	 ($mt->{m_pda}->{dm_stat}->{dev_stat_msb});}
}
unless(defined(&DEV_STAT_LSB)) {
    sub DEV_STAT_LSB () {	 ($mt->{m_pda}->{dm_stat}->{dev_stat_lsb});}
}
unless(defined(&RESID)) {
    sub RESID () {	 ($mt->{m_pda}->{dm_stat}->{byte_count});}
}
unless(defined(&b_command)) {
    sub b_command () {	 &b_resid;}
}
unless(defined(&b_repcnt)) {
    sub b_repcnt () {	 &b_bcount;}
}
unless(defined(&NO_CMD)) {
    sub NO_CMD () {	0;}
}
unless(defined(&EOF_CMD)) {
    sub EOF_CMD () {	1;}
}
unless(defined(&FWD_F_CMD)) {
    sub FWD_F_CMD () {	2;}
}
unless(defined(&BSP_F_CMD)) {
    sub BSP_F_CMD () {	3;}
}
unless(defined(&FWD_R_CMD)) {
    sub FWD_R_CMD () {	4;}
}
unless(defined(&BSP_R_CMD)) {
    sub BSP_R_CMD () {	5;}
}
unless(defined(&REW_CMD)) {
    sub REW_CMD () {	6;}
}
unless(defined(&RW_OL_CMD)) {
    sub RW_OL_CMD () {	7;}
}
unless(defined(&GSTAT_CMD)) {
    sub GSTAT_CMD () {	10;}
}
unless(defined(&SET_DENS_CMD)) {
    sub SET_DENS_CMD () {	11;}
}
unless(defined(&SET_IREP_CMD)) {
    sub SET_IREP_CMD () {	12;}
}
unless(defined(&STOP_IREP_CMD)) {
    sub STOP_IREP_CMD () {	13;}
}
unless(defined(&DM_OPEN_CMD)) {
    sub DM_OPEN_CMD () {	14;}
}
unless(defined(&DM_CLOSE_CMD)) {
    sub DM_CLOSE_CMD () {	15;}
}
unless(defined(&MTEOD_CMD)) {
    sub MTEOD_CMD () {	16;}
}
unless(defined(&MTFSS_CMD)) {
    sub MTFSS_CMD () {	17;}
}
unless(defined(&MTBSS_CMD)) {
    sub MTBSS_CMD () {	18;}
}
unless(defined(&MTWSS_CMD)) {
    sub MTWSS_CMD () {	19;}
}
unless(defined(&INQ_CMD)) {
    sub INQ_CMD () {	20;}
}
unless(defined(&XSENSE_CMD)) {
    sub XSENSE_CMD () {	21;}
}
unless(defined(&SET_COMPRS_CMD)) {
    sub SET_COMPRS_CMD () {	22;}
}
unless(defined(&GET_MAX_BLK_SIZE)) {
    sub GET_MAX_BLK_SIZE () {	23;}
}
unless(defined(&DISPLAY_CMD)) {
    sub DISPLAY_CMD () {	24;}
}
unless(defined(&MOVE_MED_CMD)) {
    sub MOVE_MED_CMD () {	25;}
}
unless(defined(&LSSF_INQ_CMD)) {
    sub LSSF_INQ_CMD () {	26;}
}
unless(defined(&ERROR)) {
    sub ERROR () {	1;}
}
unless(defined(&OK)) {
    sub OK () {	0;}
}
unless(defined(&MT_KERNEL)) {
    sub MT_KERNEL () {	0;}
}
unless(defined(&KERNELSPACE)) {
    sub KERNELSPACE () {	0;}
}
unless(defined(&READ_ONLY)) {
    sub READ_ONLY {
	local($x) = @_;
	eval q(((($x) &  &FREAD)  && !(($x) &  &FWRITE)));
    }
}
unless(defined(&WRITE_ONLY)) {
    sub WRITE_ONLY {
	local($x) = @_;
	eval q((!(($x) &  &FREAD)  && (($x) &  &FWRITE)));
    }
}
unless(defined(&EITHER_OK)) {
    sub EITHER_OK {
	local($x) = @_;
	eval q((($x) &  &FREAD| &FWRITE));
    }
}
unless(defined(&LDM_PREINIT)) {
    sub LDM_PREINIT () {	0;}
}
unless(defined(&LDM_BINDING)) {
    sub LDM_BINDING () {	1;}
}
unless(defined(&LDM_UNBOUND)) {
    sub LDM_UNBOUND () {	2;}
}
unless(defined(&LDM_NORMAL)) {
    sub LDM_NORMAL () {	3;}
}
unless(defined(&OPEN)) {
    sub OPEN {
	local($x) = @_;
	eval q(( ($x)-> ($m_state->{open})  ));
    }
}
unless(defined(&OPENING)) {
    sub OPENING {
	local($x) = @_;
	eval q(( ($x)-> ($m_state->{open_in_prog})  ));
    }
}
unless(defined(&WRITTEN_TO)) {
    sub WRITTEN_TO {
	local($x) = @_;
	eval q(( ($x)-> ($m_state->{written_to})  ));
    }
}
unless(defined(&CLOSE_IN_PROG)) {
    sub CLOSE_IN_PROG {
	local($x) = @_;
	eval q(( ($x)-> ($m_state->{close_in_prog})  ));
    }
}
unless(defined(&CNTL_IN_PROG)) {
    sub CNTL_IN_PROG {
	local($x) = @_;
	eval q(( ($x)-> ($m_state->{cntl_in_prog})  ));
    }
}
unless(defined(&isdigit)) {
    sub isdigit {
	local($c) = @_;
	eval q(($c >= ord('0' && c <= '9')));
    }
}
unless(defined(&OPEN_REJECTED)) {
    sub OPEN_REJECTED () {	0x0000000;}
}
unless(defined(&OPEN_BEGUN)) {
    sub OPEN_BEGUN () {	0x0010000;}
}
unless(defined(&OPEN_COMPLETED)) {
    sub OPEN_COMPLETED () {	0x0020000;}
}
unless(defined(&READ_BEGUN)) {
    sub READ_BEGUN () {	0x0030000;}
}
unless(defined(&READ_COMPLETED)) {
    sub READ_COMPLETED () {	0x0040000;}
}
unless(defined(&WRITE_BEGUN)) {
    sub WRITE_BEGUN () {	0x0050000;}
}
unless(defined(&WRITE_COMPLETED)) {
    sub WRITE_COMPLETED () {	0x0060000;}
}
unless(defined(&STRATEGY_BEGUN)) {
    sub STRATEGY_BEGUN () {	0x0070000;}
}
unless(defined(&STRATEGY_COMPLETED)) {
    sub STRATEGY_COMPLETED () {	0x0080000;}
}
unless(defined(&MTSTART_BEGUN)) {
    sub MTSTART_BEGUN () {	0x0090000;}
}
unless(defined(&MTSTART_COMPLETED)) {
    sub MTSTART_COMPLETED () {	0x00a0000;}
}
unless(defined(&MSG_OUT_BEGUN)) {
    sub MSG_OUT_BEGUN () {	0x00b0000;}
}
unless(defined(&MSG_OUT_COMPLETED)) {
    sub MSG_OUT_COMPLETED () {	0x00c0000;}
}
unless(defined(&MT_SEND_BEGUN)) {
    sub MT_SEND_BEGUN () {	0x00d0000;}
}
unless(defined(&MT_SEND_COMPLETED)) {
    sub MT_SEND_COMPLETED () {	0x00e0000;}
}
unless(defined(&IOCTL_CMD_BEGUN)) {
    sub IOCTL_CMD_BEGUN () {	0x00f0000;}
}
unless(defined(&IOCTL_STAT_BEGUN)) {
    sub IOCTL_STAT_BEGUN () {	0x0100000;}
}
unless(defined(&MTCMD_BEGUN)) {
    sub MTCMD_BEGUN () {	0x0110000;}
}
unless(defined(&MTCMD_COMPLETED)) {
    sub MTCMD_COMPLETED () {	0x0120000;}
}
unless(defined(&CLOSE_BEGUN)) {
    sub CLOSE_BEGUN () {	0x0130000;}
}
unless(defined(&CLOSE_EIO)) {
    sub CLOSE_EIO () {	0x0140000;}
}
unless(defined(&CLOSE_OK)) {
    sub CLOSE_OK () {	0x0150000;}
}
unless(defined(&INT_HANDLER)) {
    sub INT_HANDLER () {	0x0160000;}
}
unless(defined(&MT_COMPL_BEGUN)) {
    sub MT_COMPL_BEGUN () {	0x0170000;}
}
unless(defined(&IODONE1)) {
    sub IODONE1 () {	0x0180000;}
}
unless(defined(&IODONE2)) {
    sub IODONE2 () {	0x0190000;}
}
unless(defined(&IODONE3)) {
    sub IODONE3 () {	0x01a0000;}
}
unless(defined(&IODONE4)) {
    sub IODONE4 () {	0x01b0000;}
}
unless(defined(&IODONE5)) {
    sub IODONE5 () {	0x01c0000;}
}
unless(defined(&IODONE6)) {
    sub IODONE6 () {	0x01d0000;}
}
unless(defined(&IODONE7)) {
    sub IODONE7 () {	0x01e0000;}
}
unless(defined(&MT_COMPL_END)) {
    sub MT_COMPL_END () {	0x01f0000;}
}
unless(defined(&IOCTL_COMPLETED)) {
    sub IOCTL_COMPLETED () {	0x0200000;}
}
unless(defined(&QHEAD_rmtbuf)) {
    sub QHEAD_rmtbuf () {	0x0210000;}
}
unless(defined(&QHEAD_cmtbuf)) {
    sub QHEAD_cmtbuf () {	0x0220000;}
}
unless(defined(&QHEAD_smtbuf)) {
    sub QHEAD_smtbuf () {	0x0230000;}
}
unless(defined(&QHEAD_bmtbuf)) {
    sub QHEAD_bmtbuf () {	0x0240000;}
}
unless(defined(&QHEAD_ZERO)) {
    sub QHEAD_ZERO () {	0x0250000;}
}
unless(defined(&QHEAD_BLOCK)) {
    sub QHEAD_BLOCK () {	0x0260000;}
}
unless(defined(&EIO_01)) {
    sub EIO_01 () {	0x0270000;}
}
unless(defined(&EIO_02)) {
    sub EIO_02 () {	0x0280000;}
}
unless(defined(&EIO_03)) {
    sub EIO_03 () {	0x0290000;}
}
unless(defined(&EIO_04)) {
    sub EIO_04 () {	0x02a0000;}
}
unless(defined(&EIO_05)) {
    sub EIO_05 () {	0x02b0000;}
}
unless(defined(&EIO_06)) {
    sub EIO_06 () {	0x02c0000;}
}
unless(defined(&EIO_07)) {
    sub EIO_07 () {	0x02d0000;}
}
unless(defined(&EIO_08)) {
    sub EIO_08 () {	0x02e0000;}
}
unless(defined(&EIO_09)) {
    sub EIO_09 () {	0x02f0000;}
}
unless(defined(&EIO_10)) {
    sub EIO_10 () {	0x0300000;}
}
unless(defined(&EIO_11)) {
    sub EIO_11 () {	0x0310000;}
}
unless(defined(&EIO_12)) {
    sub EIO_12 () {	0x0320000;}
}
unless(defined(&EIO_13)) {
    sub EIO_13 () {	0x0330000;}
}
unless(defined(&EIO_14)) {
    sub EIO_14 () {	0x0340000;}
}
unless(defined(&DIAG_01)) {
    sub DIAG_01 () {	0x0350000;}
}
unless(defined(&DIAG_02)) {
    sub DIAG_02 () {	0x0360000;}
}
unless(defined(&DIAG_03)) {
    sub DIAG_03 () {	0x0370000;}
}
unless(defined(&DIAG_04)) {
    sub DIAG_04 () {	0x0380000;}
}
unless(defined(&DIAG_05)) {
    sub DIAG_05 () {	0x0390000;}
}
unless(defined(&DIAG_06)) {
    sub DIAG_06 () {	0x03a0000;}
}
unless(defined(&DIAG_07)) {
    sub DIAG_07 () {	0x03b0000;}
}
unless(defined(&DIAG_08)) {
    sub DIAG_08 () {	0x03c0000;}
}
unless(defined(&DIAG_09)) {
    sub DIAG_09 () {	0x03d0000;}
}
unless(defined(&DIAG_10)) {
    sub DIAG_10 () {	0x03e0000;}
}
unless(defined(&DIAG_11)) {
    sub DIAG_11 () {	0x03f0000;}
}
unless(defined(&DIAG_12)) {
    sub DIAG_12 () {	0x0400000;}
}
unless(defined(&DIAG_13)) {
    sub DIAG_13 () {	0x0410000;}
}
unless(defined(&DIAG_14)) {
    sub DIAG_14 () {	0x0420000;}
}
unless(defined(&DIAG_15)) {
    sub DIAG_15 () {	0x0430000;}
}
unless(defined(&DIAG_16)) {
    sub DIAG_16 () {	0x0440000;}
}
unless(defined(&DIAG_17)) {
    sub DIAG_17 () {	0x0450000;}
}
unless(defined(&DIAG_18)) {
    sub DIAG_18 () {	0x0460000;}
}
unless(defined(&EOFREC_ERROR1)) {
    sub EOFREC_ERROR1 () {	0x0470000;}
}
unless(defined(&EOFREC_ERROR2)) {
    sub EOFREC_ERROR2 () {	0x0480000;}
}
unless(defined(&EOFREC_ERROR3)) {
    sub EOFREC_ERROR3 () {	0x0490000;}
}
unless(defined(&NO_BLK_SUPT)) {
    sub NO_BLK_SUPT () {	0x04a0000;}
}
unless(defined(&EIO_15)) {
    sub EIO_15 () {	0x04b0000;}
}
unless(defined(&EIO_16)) {
    sub EIO_16 () {	0x04c0000;}
}
unless(defined(&EIO_17)) {
    sub EIO_17 () {	0x04d0000;}
}
unless(defined(&BAD_PROP_TABLE_INDEX)) {
    sub BAD_PROP_TABLE_INDEX () {	0x04e0000;}
}
unless(defined(&BAD_DENSITY_FORMAT_1)) {
    sub BAD_DENSITY_FORMAT_1 () {	0x04f0000;}
}
unless(defined(&BAD_DENSITY_FORMAT_2)) {
    sub BAD_DENSITY_FORMAT_2 () {	0x0500000;}
}
unless(defined(&BAD_DENSITY_FORMAT_3)) {
    sub BAD_DENSITY_FORMAT_3 () {	0x0510000;}
}
unless(defined(&BAD_DENSITY_FORMAT_4)) {
    sub BAD_DENSITY_FORMAT_4 () {	0x0520000;}
}
unless(defined(&BAD_DENSITY_FORMAT_5)) {
    sub BAD_DENSITY_FORMAT_5 () {	0x0530000;}
}
unless(defined(&BAD_DENSITY_FORMAT_6)) {
    sub BAD_DENSITY_FORMAT_6 () {	0x0540000;}
}
unless(defined(&BAD_DENSITY_FORMAT_7)) {
    sub BAD_DENSITY_FORMAT_7 () {	0x0550000;}
}
unless(defined(&BAD_DENSITY_FORMAT_8)) {
    sub BAD_DENSITY_FORMAT_8 () {	0x0560000;}
}
unless(defined(&OPEN_FAILED)) {
    sub OPEN_FAILED () {	0x0570000;}
}
unless(defined(&CLOSE_FAILED)) {
    sub CLOSE_FAILED () {	0x0580000;}
}
1;
