require '_h2ph_pre.ph';

require '../h/proc_iface.ph';
unless(defined(&MUX4_MAJOR)) {
    sub MUX4_MAJOR () {	178;}
}
unless(defined(&MUX4_MASK)) {
    sub MUX4_MASK () {	0xff0000;}
}
unless(defined(&ASSERT)) {
    sub ASSERT {
	local($cond) = @_;
	eval q({});
    }
}
unless(defined(&LD_RINT)) {
    sub LD_RINT () {	(* ($linesw[&ttyp->{t_line]}->{l_rint}));}
}
unless(defined(&LD_XINT)) {
    sub LD_XINT () {	(* ($linesw[&ttyp->{t_line]}->{l_xint}));}
}
unless(defined(&LD_OPEN)) {
    sub LD_OPEN () {	(* ($linesw[&ttyp->{t_line]}->{l_open}));}
}
unless(defined(&LD_CLOSE)) {
    sub LD_CLOSE () {	(* ($linesw[&ttyp->{t_line]}->{l_close}));}
}
unless(defined(&LD_READ)) {
    sub LD_READ () {	(* ($linesw[&ttyp->{t_line]}->{l_read}));}
}
unless(defined(&LD_WRITE)) {
    sub LD_WRITE () {	(* ($linesw[&ttyp->{t_line]}->{l_write}));}
}
unless(defined(&LD_IOCTL)) {
    sub LD_IOCTL () {	(* ($linesw[&ttyp->{t_line]}->{l_ioctl}));}
}
unless(defined(&LD_SELECT)) {
    sub LD_SELECT () {	(* ($linesw[&ttyp->{t_line]}->{l_select}));}
}
unless(defined(&LD_CONTROL)) {
    sub LD_CONTROL () {	(* ($linesw[&ttyp->{t_line]}->{l_control}));}
}
unless(defined(&UIOMOVE)) {
    sub UIOMOVE {
	local( $a1, $p1, $p2, $p3) = @_;
	eval q( &uiomove(($a1), $p1, $p2, $p3));
    }
}
unless(defined(&MUX_BCOPY)) {
    sub MUX_BCOPY {
	local( $f, $t, $cnt) = @_;
	eval q( &bcopy(, , $cnt));
    }
}
unless(defined(&POWER_FAILED)) {
    sub POWER_FAILED {
	local($card) = @_;
	eval q( &io_em_fe( ($card->{hpa})));
    }
}
unless(defined(&WAKEUP)) {
    sub WAKEUP {
	local( $addr) = @_;
	eval q( &wakeup(($addr)));
    }
}
if(defined(&SIMULATOR)) {
    eval 'sub SLEEP {
        local( $addr, $pri) = @_;
	    eval q( &kern_sleep(($addr), $pri));
    }' unless defined(&SLEEP);
    eval 'sub gsignal () { &kern_gsignal;}' unless defined(&gsignal);
    eval 'sub uprintf () { &printf;}' unless defined(&uprintf);
} else {
    eval 'sub SLEEP {
        local( $addr, $pri) = @_;
	    eval q( &sleep(($addr), $pri));
    }' unless defined(&SLEEP);
}
unless(defined(&STATUS)) {
    sub STATUS () {	 ($llio_status->{u}->{error_num});}
}
unless(defined(&PROCNUM)) {
    sub PROCNUM () {	 ($llio_status->{u}->{proc_num});}
}
unless(defined(&SUBSYS)) {
    sub SUBSYS () {	 ($llio_status->{u}->{subsystem});}
}
unless(defined(&KEEP_MSG)) {
    sub KEEP_MSG () {	 &FALSE;}
}
unless(defined(&RELEASE_MSG)) {
    sub RELEASE_MSG () {	 &TRUE;}
}
unless(defined(&DIAG_SUBQ)) {
    sub DIAG_SUBQ () {	 &IO_DIAGNOSTICS_SUBQ;}
}
unless(defined(&DIAG_MSG_LEN)) {
    sub DIAG_MSG_LEN () {	$sizeof{ &diag_event_msg_type};}
}
unless(defined(&BIND_SUBQ)) {
    sub BIND_SUBQ () {	1;}
}
unless(defined(&MY_SUBQ)) {
    sub MY_SUBQ () {	3;}
}
unless(defined(&MAX_SUBQS)) {
    sub MAX_SUBQS () {	5;}
}
unless(defined(&MAX_MSGS)) {
    sub MAX_MSGS () {	10;}
}
unless(defined(&MAX_MSG_SIZE)) {
    sub MAX_MSG_SIZE () {	($sizeof{ &msg_type});}
}
unless(defined(&NOSTAT)) {
    sub NOSTAT () {	0;}
}
unless(defined(&BIND)) {
    sub BIND () {	 ($msg_ptr->{msg_union}->{bind_req_msg});}
}
unless(defined(&BOUND)) {
    sub BOUND () {	 ($msg_ptr->{msg_union}->{bind_reply_msg});}
}
unless(defined(&CREATE)) {
    sub CREATE () {	 ($msg_ptr->{msg_union}->{create_msg});}
}
unless(defined(&DOBIND)) {
    sub DOBIND () {	 ($msg_ptr->{msg_union}->{do_bind_req_msg});}
}
unless(defined(&DOBOUND)) {
    sub DOBOUND () {	 ($msg_ptr->{msg_union}->{do_bind_reply_msg});}
}
unless(defined(&HEADER_LEN)) {
    sub HEADER_LEN () {	$sizeof{ &llio_std_header_type};}
}
unless(defined(&HEADER)) {
    sub HEADER () {	 ($msg_ptr->{msg_header});}
}
unless(defined(&MSG_PTR)) {
    sub MSG_PTR () {	 &msg_ptr;}
}
unless(defined(&MSG_NUM)) {
    sub MSG_NUM () {	 ($HEADER->{msg_descriptor});}
}
unless(defined(&MSG_TRN)) {
    sub MSG_TRN () {	 ($HEADER->{transaction_num});}
}
unless(defined(&MSG_ID)) {
    sub MSG_ID () {	 ($HEADER->{message_id});}
}
unless(defined(&BIND_MSG_LEN)) {
    sub BIND_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &bind_req_type});}
}
unless(defined(&DBR_MSG_LEN)) {
    sub DBR_MSG_LEN () {	( &HEADER_LEN + $sizeof{ &do_bind_reply_type});}
}
unless(defined(&CREATE_MASK)) {
    sub CREATE_MASK () {	 &ELEMENT_OF_32( &MGR_ICS_EXECUTABLE) |  &ELEMENT_OF_32( &MGR_PROC_EXECUTABLE) |  &ELEMENT_OF_32( &MGR_DYNAMIC_DS);}
}
unless(defined(&MUXPANIC)) {
    sub MUXPANIC () {	 &panic;}
}
unless(defined(&reg)) {
    sub reg () {	 &register;}
}
unless(defined(&vol)) {
    sub vol () {	 &volatile;}
}
unless(defined(&DONT_CARE)) {
    sub DONT_CARE () {	0;}
}
unless(defined(&FLAG)) {
    sub FLAG () {	'u_char';}
}
unless(defined(&ENOERROR)) {
    sub ENOERROR () {	0;}
}
unless(defined(&onICS)) {
    sub onICS () {	(! &getistackptr());}
}
unless(defined(&CUR_PID)) {
    sub CUR_PID () {	( &p_pid( ($udot->{u_procp})));}
}
unless(defined(&PF_OR_DIN)) {
    sub PF_OR_DIN () {	-1;}
}
unless(defined(&CHARMASK)) {
    sub CHARMASK () {	0xffff;}
}
unless(defined(&MUXPRI)) {
    sub MUXPRI () {	( &TTIPRI);}
}
unless(defined(&DELAYOK)) {
    sub DELAYOK () {	(( &flag & ( &O_NDELAY |  &O_NONBLOCK)) ==  &FALSE);}
}
unless(defined(&DC1)) {
    sub DC1 () {	0x11;}
}
unless(defined(&DC3)) {
    sub DC3 () {	0x13;}
}
unless(defined(&DIAGEVENT)) {
    sub DIAGEVENT () {	 ($msg_ptr->{diag_event});}
}
unless(defined(&MAXERRVEC)) {
    sub MAXERRVEC () {	5;}
}
unless(defined(&DIAG_DECL)) {
    sub DIAG_DECL () {	 &err_vec_type  $err_vec[ &MAXERRVEC];  &err_vec_type * &err_vec_ptr;;}
}
unless(defined(&CFLAGINIT)) {
    sub CFLAGINIT () {	( &HUPCL |  &CREAD |  &CS8 |  &B300);}
}
unless(defined(&RBUF)) {
    sub RBUF () {	 ($ttyp->{t_rbuf});}
}
unless(defined(&TBUF)) {
    sub TBUF () {	 ($ttyp->{t_tbuf});}
}
unless(defined(&CMD)) {
    sub CMD {
	local($x,$y,$z) = @_;
	eval q( &mux4_docmd(  &PORT, $x, $y, $z,  &lerror));
    }
}
unless(defined(&CMD4)) {
    sub CMD4 {
	local($x,$y) = @_;
	eval q( &mux4_docmd(  &PORT, $x, $y,  &MUX4,  &lerror));
    }
}
unless(defined(&CMDics)) {
    sub CMDics {
	local($x,$y) = @_;
	eval q( &mux4_icscmd(  &PORT, $x, $y));
    }
}
unless(defined(&CLEAR_DIAG_VARS)) {
    sub CLEAR_DIAG_VARS {
	local($hw) = @_;
	eval q(($hw)-> &diag_op =  &FALSE; ($hw)-> &diag_writecnt = 0; ($hw)-> &diag_readcnt = 0; ($hw)-> &diag_read = 0; ($hw)-> &diag_readstatus = 0; ($hw)-> &diag_writestatus = 0;);
    }
}
unless(defined(&SRS_REG_ADDR)) {
    sub SRS_REG_ADDR {
	local( $regindx) = @_;
	eval q((( ($CARD->{hpa})) + $regindx));
    }
}
unless(defined(&PORT_REG_ADDR)) {
    sub PORT_REG_ADDR {
	local( $regset, $regindx) = @_;
	eval q((( ($IO->{outregsetp})) + (16* $regset + $regindx)));
    }
}
unless(defined(&MUX5OPEN_FLAGS)) {
    sub MUX5OPEN_FLAGS () {	( &TTYFS_DEV |  &TTYFS_UNIT |  &TTYFS_SUPER);}
}
unless(defined(&MUX5CLOSE_FLAGS)) {
    sub MUX5CLOSE_FLAGS () {	( &TTYFS_DEV |  &TTYFS_UNIT);}
}
unless(defined(&MUX5READ_FLAGS)) {
    sub MUX5READ_FLAGS () {	( &TTYFS_DEV |  &TTYFS_UNIT |  &TTYFS_GONE);}
}
unless(defined(&MUX5WRITE_FLAGS)) {
    sub MUX5WRITE_FLAGS () {	( &TTYFS_DEV |  &TTYFS_UNIT |  &TTYFS_GONE);}
}
unless(defined(&MUX5IOCTL_FLAGS)) {
    sub MUX5IOCTL_FLAGS () {	( &TTYFS_DEV |  &TTYFS_UNIT |  &TTYFS_GONE);}
}
unless(defined(&TTYFS_DEV)) {
    sub TTYFS_DEV () {	0x01;}
}
unless(defined(&TTYFS_UNIT)) {
    sub TTYFS_UNIT () {	0x02;}
}
unless(defined(&TTYFS_ACC)) {
    sub TTYFS_ACC () {	0x04;}
}
unless(defined(&TTYFS_STATE)) {
    sub TTYFS_STATE () {	0x08;}
}
unless(defined(&TTYFS_OPEN)) {
    sub TTYFS_OPEN () {	0x10;}
}
unless(defined(&TTYFS_GONE)) {
    sub TTYFS_GONE () {	0x20;}
}
unless(defined(&TTYFS_SUPER)) {
    sub TTYFS_SUPER () {	0x40;}
}
unless(defined(&TTYOPEN_FLAGS)) {
    sub TTYOPEN_FLAGS () {	( &TTYFS_DEV |  &TTYFS_UNIT |  &TTYFS_ACC |  &TTYFS_STATE);}
}
unless(defined(&TTYCLOSE_FLAGS)) {
    sub TTYCLOSE_FLAGS () {	( &TTYFS_STATE);}
}
unless(defined(&TTYSELECT_FLAGS)) {
    sub TTYSELECT_FLAGS () {	( &TTYFS_STATE);}
}
unless(defined(&TTYREAD_FLAGS)) {
    sub TTYREAD_FLAGS () {	( &TTYFS_STATE);}
}
unless(defined(&TTYWRITE_FLAGS)) {
    sub TTYWRITE_FLAGS () {	( &TTYFS_STATE);}
}
unless(defined(&TTYIOCTL_FLAGS)) {
    sub TTYIOCTL_FLAGS () {	( &TTYFS_STATE);}
}
unless(defined(&TTYOPTION1_FLAGS)) {
    sub TTYOPTION1_FLAGS () {	( &TTYFS_DEV |  &TTYFS_UNIT |  &TTYFS_ACC);}
}
unless(defined(&TICKLEN)) {
    sub TICKLEN () {	10;}
}
unless(defined(&TPS)) {
    sub TPS () {	(1000/ &TICKLEN);}
}
unless(defined(&LONGPOLL)) {
    sub LONGPOLL () {	3;}
}
unless(defined(&SHORTPOLL)) {
    sub SHORTPOLL () {	1;}
}
unless(defined(&CARDWAIT)) {
    sub CARDWAIT () {	(12* &TPS);}
}
unless(defined(&CNTRLWAIT)) {
    sub CNTRLWAIT () {	(15* &TPS);}
}
unless(defined(&RESETWAIT)) {
    sub RESETWAIT () {	10000000;}
}
unless(defined(&ISDOWN)) {
    sub ISDOWN () {	0;}
}
unless(defined(&ISBROKEN)) {
    sub ISBROKEN () {	1;}
}
unless(defined(&ISRESTORE)) {
    sub ISRESTORE () {	2;}
}
unless(defined(&ISUP)) {
    sub ISUP () {	3;}
}
unless(defined(&MTIMER)) {
    sub MTIMER () {	 ($mdm_timer->{m_timers});}
}
unless(defined(&MTCONNECTDFLT)) {
    sub MTCONNECTDFLT () {	25;}
}
unless(defined(&MTCARRIERDFLT)) {
    sub MTCARRIERDFLT () {	400;}
}
unless(defined(&MTNOACTIVITYDFLT)) {
    sub MTNOACTIVITYDFLT () {	0;}
}
unless(defined(&MTHANGUPDFLT)) {
    sub MTHANGUPDFLT () {	250;}
}
unless(defined(&MTCONNECT)) {
    sub MTCONNECT () {	0;}
}
unless(defined(&MTCARRIER)) {
    sub MTCARRIER () {	1;}
}
unless(defined(&MTNOACTIVITY)) {
    sub MTNOACTIVITY () {	2;}
}
unless(defined(&MTHANGUP)) {
    sub MTHANGUP () {	3;}
}
unless(defined(&MXDSR)) {
    sub MXDSR () {	0x01;}
}
unless(defined(&MXCTS)) {
    sub MXCTS () {	0x02;}
}
unless(defined(&MXDCD)) {
    sub MXDCD () {	0x04;}
}
unless(defined(&MXRI)) {
    sub MXRI () {	0x08;}
}
unless(defined(&MXRTS)) {
    sub MXRTS () {	0x10;}
}
unless(defined(&MXDTR)) {
    sub MXDTR () {	0x20;}
}
unless(defined(&MXDRS)) {
    sub MXDRS () {	0x80;}
}
unless(defined(&PORT0PARMS)) {
    sub PORT0PARMS () {	0x03;}
}
unless(defined(&PORT1PARMS)) {
    sub PORT1PARMS () {	0x83;}
}
unless(defined(&SIMPL)) {
    sub SIMPL () {	0;}
}
unless(defined(&CCITT)) {
    sub CCITT () {	1;}
}
unless(defined(&WAITOPEN)) {
    sub WAITOPEN () {	1;}
}
unless(defined(&ISOPEN)) {
    sub ISOPEN () {	2;}
}
unless(defined(&WAITCLOSE)) {
    sub WAITCLOSE () {	3;}
}
unless(defined(&CHECKOPEN)) {
    sub CHECKOPEN () {	4;}
}
unless(defined(&ACC_NONE)) {
    sub ACC_NONE () {	0;}
}
unless(defined(&ACC_SUCCESS)) {
    sub ACC_SUCCESS () {	1;}
}
unless(defined(&ACC_PENDING)) {
    sub ACC_PENDING () {	2;}
}
unless(defined(&ACC_BLOCKED)) {
    sub ACC_BLOCKED () {	3;}
}
unless(defined(&DIRECT)) {
    sub DIRECT () {	0;}
}
unless(defined(&CALLOUT)) {
    sub CALLOUT () {	1;}
}
unless(defined(&CALLIN)) {
    sub CALLIN () {	2;}
}
unless(defined(&ACC_INVALID)) {
    sub ACC_INVALID () {	3;}
}
unless(defined(&ACC_MASK)) {
    sub ACC_MASK () {	0x3;}
}
unless(defined(&ACC_TYPES_MAX)) {
    sub ACC_TYPES_MAX () {	4;}
}
unless(defined(&SIMPL_DIRECT)) {
    sub SIMPL_DIRECT () {	0;}
}
unless(defined(&SIMPL_CALLOUT)) {
    sub SIMPL_CALLOUT () {	1;}
}
unless(defined(&SIMPL_CALLIN)) {
    sub SIMPL_CALLIN () {	2;}
}
unless(defined(&CCITT_DIRECT)) {
    sub CCITT_DIRECT () {	4;}
}
unless(defined(&CCITT_CALLOUT)) {
    sub CCITT_CALLOUT () {	5;}
}
unless(defined(&CCITT_CALLIN)) {
    sub CCITT_CALLIN () {	6;}
}
unless(defined(&MUX5)) {
    sub MUX5 () {	1;}
}
unless(defined(&ICS)) {
    sub ICS () {	2;}
}
unless(defined(&MUX4)) {
    sub MUX4 () {	3;}
}
unless(defined(&PORT_BUSY)) {
    sub PORT_BUSY () {	23;}
}
unless(defined(&DIAG)) {
    sub DIAG () {	 ($S1->{diag});}
}
unless(defined(&MODE)) {
    sub MODE () {	 ($S1->{mode});}
}
unless(defined(&ACC)) {
    sub ACC () {	 ($S1->{acc});}
}
unless(defined(&MUX_INSTANCE)) {
    sub MUX_INSTANCE () {	 ($S1->{mux_instance});}
}
unless(defined(&PORT_DIAG)) {
    sub PORT_DIAG () {	 ($S1->{port_diag});}
}
unless(defined(&PORT_NUM)) {
    sub PORT_NUM () {	 ($S1->{port_num});}
}
unless(defined(&MACC)) {
    sub MACC () {	 ($S2->{macc});}
}
unless(defined(&UNIT)) {
    sub UNIT () {	 ($unit->{S3});}
}
unless(defined(&flow_out)) {
    sub flow_out () {	 ($flow_chars->{part1}->{flowout});}
}
unless(defined(&flow_in)) {
    sub flow_in () {	 ($flow_chars->{part1}->{flowin});}
}
unless(defined(&do_xoff_out)) {
    sub do_xoff_out () {	 ($flow_chars->{part2}->{doxoffout});}
}
unless(defined(&xoff_out)) {
    sub xoff_out () {	 ($flow_chars->{part2}->{xoffout});}
}
unless(defined(&xon_out)) {
    sub xon_out () {	 ($flow_chars->{part2}->{xonout});}
}
unless(defined(&xon_in)) {
    sub xon_in () {	 ($flow_chars->{part2}->{xonin});}
}
unless(defined(&xoff_in)) {
    sub xoff_in () {	 ($flow_chars->{part2}->{xoffin});}
}
unless(defined(&MAXCNTRLCMDS)) {
    sub MAXCNTRLCMDS () {	32;}
}
unless(defined(&MAX_PARITYERR)) {
    sub MAX_PARITYERR () {	256;}
}
unless(defined(&NUMPORTS)) {
    sub NUMPORTS () {	2;}
}
unless(defined(&MAXDMAREADLEN)) {
    sub MAXDMAREADLEN () {	256;}
}
unless(defined(&READLENREQ)) {
    sub READLENREQ () {	( &MAXDMAREADLEN+4);}
}
unless(defined(&MAXDMAWRITELEN)) {
    sub MAXDMAWRITELEN () {	2048;}
}
unless(defined(&MAXDMAOUTCHARS)) {
    sub MAXDMAOUTCHARS () {	( &MAXDMAWRITELEN-2);}
}
unless(defined(&MAXDMAWRITEBUFS)) {
    sub MAXDMAWRITEBUFS () {	3;}
}
unless(defined(&CMD_CHAIN)) {
    sub CMD_CHAIN () {	2;}
}
unless(defined(&IO_STATUS)) {
    sub IO_STATUS () {	13;}
}
unless(defined(&CCMD_IN)) {
    sub CCMD_IN () {	0;}
}
unless(defined(&CCMD_OUT)) {
    sub CCMD_OUT () {	4;}
}
unless(defined(&CCMD_LINK)) {
    sub CCMD_LINK () {	8;}
}
unless(defined(&RCVFLOW)) {
    sub RCVFLOW () {	0x20;}
}
unless(defined(&XMITXON)) {
    sub XMITXON () {	0x02;}
}
unless(defined(&XMITXOFF)) {
    sub XMITXOFF () {	0x01;}
}
unless(defined(&XMITON)) {
    sub XMITON () {	0;}
}
unless(defined(&XMITOFF)) {
    sub XMITOFF () {	1;}
}
unless(defined(&MB75)) {
    sub MB75 () {	0xbb;}
}
unless(defined(&MB150)) {
    sub MB150 () {	0xaa;}
}
unless(defined(&MB300)) {
    sub MB300 () {	0x99;}
}
unless(defined(&MB600)) {
    sub MB600 () {	0x88;}
}
unless(defined(&MB1200)) {
    sub MB1200 () {	0x77;}
}
unless(defined(&MB2400)) {
    sub MB2400 () {	0x66;}
}
unless(defined(&MB4800)) {
    sub MB4800 () {	0x55;}
}
unless(defined(&MB9600)) {
    sub MB9600 () {	0x44;}
}
unless(defined(&MCS8)) {
    sub MCS8 () {	0x88;}
}
unless(defined(&MNOPAR)) {
    sub MNOPAR () {	0x00;}
}
unless(defined(&MSB1)) {
    sub MSB1 () {	0x11;}
}
unless(defined(&MNOPARM)) {
    sub MNOPARM () {	0;}
}
unless(defined(&DISABLE)) {
    sub DISABLE () {	0;}
}
unless(defined(&ENABLE)) {
    sub ENABLE () {	1;}
}
unless(defined(&HARDWIRED)) {
    sub HARDWIRED () {	0;}
}
unless(defined(&BELL)) {
    sub BELL () {	2;}
}
unless(defined(&ANSWER)) {
    sub ANSWER () {	4;}
}
unless(defined(&ORIGINATE)) {
    sub ORIGINATE () {	8;}
}
unless(defined(&SPECIAL_TYPE)) {
    sub SPECIAL_TYPE () {	0x80;}
}
unless(defined(&INPUT_TYPE)) {
    sub INPUT_TYPE () {	0x3c;}
}
unless(defined(&CHAR_ERR)) {
    sub CHAR_ERR () {	0x03;}
}
unless(defined(&CMD_RESET_HT)) {
    sub CMD_RESET_HT () {	0x305;}
}
unless(defined(&ERR_HARDFAIL)) {
    sub ERR_HARDFAIL () {	17;}
}
unless(defined(&DRAM_PARITY_ERROR)) {
    sub DRAM_PARITY_ERROR () {	0x00500000;}
}
unless(defined(&DRAM_PARITY_PON)) {
    sub DRAM_PARITY_PON () {	0x83080000;}
}
unless(defined(&DRAM_PARITY)) {
    sub DRAM_PARITY () {	0x80180000;}
}
unless(defined(&DRAM_PARITY_OTHER)) {
    sub DRAM_PARITY_OTHER () {	0x81080000;}
}
unless(defined(&SrsApstat)) {
    sub SrsApstat () {	(( ($CARD->{fullspa})  & 0xffffff00))-> &io_register1;}
}
unless(defined(&SrsCmd)) {
    sub SrsCmd () {	 ($CARD->{hpa}->{io_command});}
}
unless(defined(&Spa)) {
    sub Spa () {	 ($CARD->{hpa}->{io_spa});}
}
unless(defined(&SelftestResults)) {
    sub SelftestResults () {	(((( ($CARD->{fullspa})+1)) & 0xffffff00))-> &io_register1;}
}
unless(defined(&CardStatus)) {
    sub CardStatus () {	 ($CARD->{hpa}->{io_status});}
}
unless(defined(&CntrlStatus)) {
    sub CntrlStatus () {	 ($IO->{cntrlregsetp}->{io_status});}
}
unless(defined(&CntrlCmd)) {
    sub CntrlCmd () {	 ($IO->{cntrlregsetp}->{io_command});}
}
unless(defined(&OutCmd)) {
    sub OutCmd () {	 ($IO->{outregsetp}->{io_command});}
}
unless(defined(&OutStatus)) {
    sub OutStatus () {	 ($IO->{outregsetp}->{io_status});}
}
unless(defined(&OutDmaLink)) {
    sub OutDmaLink () {	 ($IO->{outregsetp}->{io_dma_link});}
}
unless(defined(&OutTransActive)) {
    sub OutTransActive () {	 ($IO->{outregsetp}->{io_info});}
}
unless(defined(&InCmd)) {
    sub InCmd () {	 ($IO->{inregsetp}->{io_command});}
}
unless(defined(&InStatus)) {
    sub InStatus () {	 ($IO->{inregsetp}->{io_status});}
}
unless(defined(&InDmaLink)) {
    sub InDmaLink () {	 ($IO->{inregsetp}->{io_dma_link});}
}
unless(defined(&IOStatus)) {
    sub IOStatus () {	 ($io_status->{iostatus});}
}
unless(defined(&Estat)) {
    sub Estat () {	 ($io_status->{b1}->{estat_bits});}
}
unless(defined(&Se)) {
    sub Se () {	 ($io_status->{b1}->{se_bit});}
}
unless(defined(&He)) {
    sub He () {	 ($io_status->{b1}->{he_bit});}
}
unless(defined(&Fe)) {
    sub Fe () {	 ($io_status->{b1}->{fe_bit});}
}
unless(defined(&ReadyBit)) {
    sub ReadyBit () {	 ($io_status->{b1}->{ready_bit});}
}
unless(defined(&ErrBits)) {
    sub ErrBits () {	 ($io_status->{b2}->{err_bits});}
}
unless(defined(&IN_DMA_STATUS)) {
    sub IN_DMA_STATUS () {	( ($IO->{inquadsp}->{cequad}->{io_status}));}
}
unless(defined(&OUT_DMA_STATUS)) {
    sub OUT_DMA_STATUS () {	( ($IO->{outquadsp}->{cequad}->{io_status}));}
}
unless(defined(&HW)) {
    sub HW () {	 &hitp;}
}
unless(defined(&PORT)) {
    sub PORT () {	 &pitp;}
}
unless(defined(&MDM)) {
    sub MDM () {	 &mitp;}
}
unless(defined(&IO)) {
    sub IO () {	 &patp;}
}
unless(defined(&TTY)) {
    sub TTY () {	 &ttyp;}
}
unless(defined(&CARD)) {
    sub CARD () {	 &citp;}
}
unless(defined(&CARD_DECL)) {
    sub CARD_DECL () {	 &register  &muxcit_t * &CARD;}
}
unless(defined(&MDM_DECL)) {
    sub MDM_DECL () {	 &register  &ttymit_t * &MDM;}
}
unless(defined(&IO_DECL)) {
    sub IO_DECL () {	 &register  &ttypat_t * &IO;}
}
unless(defined(&HW_DECL)) {
    sub HW_DECL () {	 &register  &ttyhit_t * &HW;}
}
unless(defined(&PORT_DECL)) {
    sub PORT_DECL () {	 &register  &ttypit_t * &PORT;}
}
unless(defined(&TTY_DECL)) {
    sub TTY_DECL () {	 &register 'struct tty' * &TTY;}
}
unless(defined(&HW_MDM_TTY_DECL)) {
    sub HW_MDM_TTY_DECL () {	 &HW_DECL;  &MDM_DECL;  &TTY_DECL;}
}
unless(defined(&SET_PORT)) {
    sub SET_PORT {
	local($num) = @_;
	eval q( &pitp =  ($CARD->{pit[$num]}));
    }
}
unless(defined(&GET_CARD)) {
    sub GET_CARD {
	local($port) = @_;
	eval q(((($port)-> &muxcit)));
    }
}
unless(defined(&SET_CARD)) {
    sub SET_CARD {
	local($port) = @_;
	eval q( &citp = (($port)-> &muxcit));
    }
}
unless(defined(&SET_HW)) {
    sub SET_HW () {	 &hitp =  ($PORT->{hit});}
}
unless(defined(&SET_MDM)) {
    sub SET_MDM () {	 &mitp =  ($PORT->{hit}->{mit});}
}
unless(defined(&SET_IO)) {
    sub SET_IO () {	 &patp =  ($PORT->{pat});}
}
unless(defined(&SET_TTY)) {
    sub SET_TTY () {	 &ttyp =  ($PORT->{tty});}
}
unless(defined(&SET_HW_MDM_TTY)) {
    sub SET_HW_MDM_TTY () {	 &SET_HW;  &SET_MDM;  &SET_TTY;}
}
unless(defined(&GET_CARD_VIA_DEV)) {
    sub GET_CARD_VIA_DEV {
	local( $dev ) = @_;
	eval q( &sio_get_pda( $dev,  &mux4_info ));
    }
}
unless(defined(&CARD_INSTANCE)) {
    sub CARD_INSTANCE () {	( ($PORT->{muxcit}->{mux_instance}));}
}
unless(defined(&CARD_GONE)) {
    sub CARD_GONE () {	(! ($PORT->{muxcit}->{ok}));}
}
unless(defined(&MAXE)) {
    sub MAXE () {	2048;}
}
if(defined(&MUX4EVENT)) {
    eval 'sub EVT {
        local($X) = @_;
	    eval q( &if  &mux4_logevent(  &PORT, ($X) << 24););
    }' unless defined(&EVT);
    eval 'sub EVT4 {
        local($A, $B, $C, $D) = @_;
	    eval q( &if  &mux4_logevent(  &PORT, ($A) << 24| ($B) << 16| ($C) << 8| ($D)););
    }' unless defined(&EVT4);
} else {
    eval 'sub EVT {
        local($X) = @_;
	    eval q();
    }' unless defined(&EVT);
    eval 'sub EVT4 {
        local($A, $B, $C, $D) = @_;
	    eval q();
    }' unless defined(&EVT4);
}
if(defined(&SIMULATOR)) {
    eval 'sub readreg {
        local( $regaddr, $retvar) = @_;
	    eval q(($retvar =  &nio_xread( $regaddr)));
    }' unless defined(&readreg);
    eval 'sub writereg {
        local( $regaddr, $value) = @_;
	    eval q( &nio_xwrite($regaddr, $value));
    }' unless defined(&writereg);
} else {
    eval 'sub readreg {
        local( $regaddr, $retvar) = @_;
	    eval q(($retvar = * $regaddr));
    }' unless defined(&readreg);
    eval 'sub writereg {
        local( $regaddr, $value) = @_;
	    eval q((* ($regaddr) = $value));
    }' unless defined(&writereg);
}
unless(defined(&fix_ioparm)) {
    sub fix_ioparm {
	local($x) = @_;
	eval q(($x << 4| $x));
    }
}
unless(defined(&wait_unblocked)) {
    sub wait_unblocked () {	( &mux4_wait_not_blocked(  &PORT,  &unit));}
}
unless(defined(&set_bufp)) {
    sub set_bufp {
	local( $buf) = @_;
	eval q( ($buf->{c_ptr}) + ( ($buf->{c_size}) -  ($buf->{c_count})));
    }
}
unless(defined(&open_done)) {
    sub open_done () {	 &mux4_relopen(  &PORT);  ($HW->{acc[&unit}->{ACC]}->{pcnt})--;  &splx(  &save_spl);;}
}
unless(defined(&get_flow)) {
    sub get_flow {
	local( $fc1, $fc2) = @_;
	eval q((($fc1 == $fc2 || $fc1 == 0xff || $fc2 == 0xff) ? ($fc1 == 0xff ? $fc2 : $fc1) : 0xff));
    }
}
unless(defined(&PORT_NOTREADY)) {
    sub PORT_NOTREADY () {	( &Estat ==  &PORT_BUSY ||  &CARD_GONE || ( &IOStatus ==  &PF_OR_DIN  &&  &POWER_FAILED( &GET_CARD( &PORT))));}
}
unless(defined(&DIAG_PORT_READY)) {
    sub DIAG_PORT_READY () {	( ($CARD->{ok})  && ! ($HW->{aborted})  && ! &POWER_FAILED( &CARD));}
}
unless(defined(&make_mux_dev)) {
    sub make_mux_dev {
	local( $cardp, $portp, $mdmt ) = @_;
	eval q( &makedev(  &MUX4_MAJOR, ($cardp)-> &mux_instance << 16| (($portp) - ($cardp)-> &pit) << 8| $mdmt ));
    }
}
unless(defined(&GOOD_READ)) {
    sub GOOD_READ () {	( &IOStatus == 0x2640);}
}
unless(defined(&ABORTED_WRITE)) {
    sub ABORTED_WRITE () {	( &IOStatus == 0x2640);}
}
unless(defined(&SOFT)) {
    sub SOFT () {	1;}
}
unless(defined(&HARD)) {
    sub HARD () {	2;}
}
eval("sub ERR_NONE () { 0; }") unless defined(&ERR_NONE);
eval("sub ERR_IN_DMA () { 1; }") unless defined(&ERR_IN_DMA);
eval("sub ERR_OUT_DMA () { 2; }") unless defined(&ERR_OUT_DMA);
eval("sub ERR_FE1 () { 3; }") unless defined(&ERR_FE1);
eval("sub ERR_FE2 () { 4; }") unless defined(&ERR_FE2);
eval("sub ERR_HE () { 5; }") unless defined(&ERR_HE);
eval("sub ERR_QUEUE () { 6; }") unless defined(&ERR_QUEUE);
eval("sub ERR_DIAG () { 7; }") unless defined(&ERR_DIAG);
eval("sub ERR_FEHE () { 8; }") unless defined(&ERR_FEHE);
eval("sub ERR_CARDFAIL () { 9; }") unless defined(&ERR_CARDFAIL);
eval("sub ERR_RYERR () { 10; }") unless defined(&ERR_RYERR);
eval("sub ERR_RY () { 11; }") unless defined(&ERR_RY);
eval("sub ERR_PARITY () { 12; }") unless defined(&ERR_PARITY);
eval("sub NX_CLEAR () { 3; }") unless defined(&NX_CLEAR);
eval("sub NX_RESET () { 5; }") unless defined(&NX_RESET);
eval("sub NX_CHARINTERVAL () { 65; }") unless defined(&NX_CHARINTERVAL);
eval("sub NX_WRITECHAR () { 81; }") unless defined(&NX_WRITECHAR);
eval("sub NX_SETFLOW () { 82; }") unless defined(&NX_SETFLOW);
eval("sub NX_SETSTOP () { 83; }") unless defined(&NX_SETSTOP);
eval("sub NX_SETSTART () { 84; }") unless defined(&NX_SETSTART);
eval("sub NX_XMITCTL () { 85; }") unless defined(&NX_XMITCTL);
eval("sub NX_RCVRCTL () { 86; }") unless defined(&NX_RCVRCTL);
eval("sub NX_BREAKOFF () { 87; }") unless defined(&NX_BREAKOFF);
eval("sub NX_BREAKON () { 88; }") unless defined(&NX_BREAKON);
eval("sub NX_SETCSIZE () { 89; }") unless defined(&NX_SETCSIZE);
eval("sub NX_SETSTOPB () { 90; }") unless defined(&NX_SETSTOPB);
eval("sub NX_SETPARITY () { 91; }") unless defined(&NX_SETPARITY);
eval("sub NX_SETBAUD () { 92; }") unless defined(&NX_SETBAUD);
eval("sub NX_FLUSHOUT () { 94; }") unless defined(&NX_FLUSHOUT);
eval("sub NX_OCTARTPOLL () { 96; }") unless defined(&NX_OCTARTPOLL);
eval("sub NX_CLOSE () { 119; }") unless defined(&NX_CLOSE);
eval("sub NX_OPEN () { 120; }") unless defined(&NX_OPEN);
eval("sub NX_DCDTIMER () { 121; }") unless defined(&NX_DCDTIMER);
eval("sub NX_NATIMER () { 122; }") unless defined(&NX_NATIMER);
eval("sub NX_CONTIMER () { 123; }") unless defined(&NX_CONTIMER);
eval("sub NX_WRITEMODEM () { 124; }") unless defined(&NX_WRITEMODEM);
eval("sub NX_READMODEM () { 126; }") unless defined(&NX_READMODEM);
eval("sub NX_SETMTYPE () { 127; }") unless defined(&NX_SETMTYPE);
eval("sub DI_NORMAL () { 0; }") unless defined(&DI_NORMAL);
eval("sub DI_SPECIAL () { 1; }") unless defined(&DI_SPECIAL);
eval("sub DI_BREAK () { 2; }") unless defined(&DI_BREAK);
eval("sub DI_MODEM () { 3; }") unless defined(&DI_MODEM);
eval("sub DI_CONNECT () { 4; }") unless defined(&DI_CONNECT);
eval("sub DI_STATUS () { 8; }") unless defined(&DI_STATUS);
eval("sub CSPARTIAL () { 1; }") unless defined(&CSPARTIAL);
eval("sub CSREADY () { 2; }") unless defined(&CSREADY);
eval("sub CSBELL () { 3; }") unless defined(&CSBELL);
eval("sub CSORIGINATE () { 4; }") unless defined(&CSORIGINATE);
eval("sub CSANSWER () { 5; }") unless defined(&CSANSWER);
eval("sub CSTIMEOUT () { 6; }") unless defined(&CSTIMEOUT);
eval("sub CSCOLLISION () { 7; }") unless defined(&CSCOLLISION);
eval("sub OCTART_RPT () { 0; }") unless defined(&OCTART_RPT);
eval("sub INFLUSH_RPT () { 1; }") unless defined(&INFLUSH_RPT);
eval("sub TM_RESET () { 1; }") unless defined(&TM_RESET);
1;
