require '_h2ph_pre.ph';

unless(defined(&_DMA_INCLUDED)) {
    eval 'sub _DMA_INCLUDED () {1;}' unless defined(&_DMA_INCLUDED);
    if(defined(&_KERNEL_BUILD)) {
	require '../h/types.ph';
	require '../h/uio.ph';
	require '../machine/pa_cache.ph';
    } else {
	require 'sys/types.ph';
	require 'sys/uio.ph';
	require 'machine/pa_cache.ph';
    }
    eval 'sub IO_READ () {0x1;}' unless defined(&IO_READ);
    eval 'sub IO_SYNC_FORCPU () { &IO_READ;}' unless defined(&IO_SYNC_FORCPU);
    eval 'sub IO_WRITE () {0x2;}' unless defined(&IO_WRITE);
    eval 'sub IO_SYNC_FORDEV () { &IO_WRITE;}' unless defined(&IO_SYNC_FORDEV);
    eval 'sub IO_RDWR () { &IO_WRITE;}' unless defined(&IO_RDWR);
    eval 'sub IO_ALWAYS () {0x8;}' unless defined(&IO_ALWAYS);
    eval 'sub IO_MODIFIED () {0x10;}' unless defined(&IO_MODIFIED);
    eval 'sub IO_ACCESSED () {0x20;}' unless defined(&IO_ACCESSED);
    eval 'sub IO_CONDITIONAL () {0x0;}' unless defined(&IO_CONDITIONAL);
    eval 'sub IO_PREFETCHED () {0x40;}' unless defined(&IO_PREFETCHED);
    eval 'sub IO_NO_SYNC () {0x10000;}' unless defined(&IO_NO_SYNC);
    eval 'sub IO_SYNC_MEM () {0x20000;}' unless defined(&IO_SYNC_MEM);
    eval 'sub IO_SAFE () {0x2;}' unless defined(&IO_SAFE);
    eval 'sub IO_LOCK () {0x4;}' unless defined(&IO_LOCK);
    eval 'sub IO_UPDATE () {0x20;}' unless defined(&IO_UPDATE);
    eval 'sub IO_SEQ_ENB () {0x40;}' unless defined(&IO_SEQ_ENB);
    eval 'sub IO_NO_SEQ () {0x8000;}' unless defined(&IO_NO_SEQ);
    eval 'sub IO_SEMA () {0x1000;}' unless defined(&IO_SEMA);
    eval 'sub IO_IGN_ALIGNMENT () {0x2000;}' unless defined(&IO_IGN_ALIGNMENT);
    eval 'sub IO_CONTIGUOUS () {0x4000;}' unless defined(&IO_CONTIGUOUS);
    eval 'sub IO_INTERLEAVED_DMA () {0x1;}' unless defined(&IO_INTERLEAVED_DMA);
    eval 'sub IO_NONINTERLEAVED_DMA () {0x2;}' unless defined(&IO_NONINTERLEAVED_DMA);
    eval 'sub IO_DEBUG_DMA () {0x4;}' unless defined(&IO_DEBUG_DMA);
    eval 'sub PHYSICAL () {-1;}' unless defined(&PHYSICAL);
    eval 'sub MAX_CACHE_LINE_SIZE () {64;}' unless defined(&MAX_CACHE_LINE_SIZE);
    eval 'sub CACHE_LINE_INDEX {
        local($ptr) = @_;
	    eval q((( ($ptr)) & ( &MAX_CACHE_LINE_SIZE-1)));
    }' unless defined(&CACHE_LINE_INDEX);
    eval 'sub CACHE_LINE_ALIGNED {
        local($ptr) = @_;
	    eval q(( &CACHE_LINE_INDEX($ptr) == 0));
    }' unless defined(&CACHE_LINE_ALIGNED);
    eval 'sub PAGE_INDEX {
        local($ptr) = @_;
	    eval q((( ($ptr)) & ( &NBPG-1)));
    }' unless defined(&PAGE_INDEX);
    eval 'sub FORCED_SYNC {
        local($Hints) = @_;
	    eval q((($Hints) &IO_SYNC_MEM));
    }' unless defined(&FORCED_SYNC);
    eval 'sub COHERENT_IO_ENABLED () {
        eval q(( &coherent_io_enabled));
    }' unless defined(&COHERENT_IO_ENABLED);
    eval 'sub D_PREFETCH_ENABLED () {
        eval q(( &purge_after_inbound_dma));
    }' unless defined(&D_PREFETCH_ENABLED);
    eval 'sub SYNC_ON_PREFETCH_ONLY {
        local($Hints) = @_;
	    eval q((($Hints) &IO_PREFETCHED));
    }' unless defined(&SYNC_ON_PREFETCH_ONLY);
    eval 'sub FLUSH_OR_PURGE_ENABLED {
        local($Hints) = @_;
	    eval q(( &FORCED_SYNC($Hints) || (! &COHERENT_IO_ENABLED()  && ( &D_PREFETCH_ENABLED() || ! &SYNC_ON_PREFETCH_ONLY($Hints)))));
    }' unless defined(&FLUSH_OR_PURGE_ENABLED);
    eval 'sub dma_sync {
        local($Addr_Type,$Addr,$Length,$Hints) = @_;
	    eval q({  &if ( &FLUSH_OR_PURGE_ENABLED  && ( &IO_SYNC_FORDEV| &IO_SYNC_FORCPU)) {  &if (( &IO_ACCESSED| &IO_MODIFIED| &IO_ALWAYS)) {  &if ( &IO_SYNC_FORDEV) {  &if ( &IO_ACCESSED)  &fdcache_conditionally( $Addr_Type, $Addr, $Length,  &c_accessed);  &else  &if ( &IO_MODIFIED)  &fdcache_conditionally( $Addr_Type, $Addr, $Length,  &c_modified);  &else  &fdcache_conditionally( $Addr_Type, $Addr, $Length,  &c_always); }  &else  &if ( &IO_SYNC_FORCPU) {  &if ( &IO_ACCESSED)  &pdcache_conditionally( $Addr_Type, $Addr, $Length,  &c_accessed);  &else  &if ( &IO_MODIFIED)  &pdcache_conditionally( $Addr_Type, $Addr, $Length,  &c_modified);  &else  &pdcache_conditionally( $Addr_Type, $Addr, $Length,  &c_always); } }  &else {  &if ( &IO_SYNC_FORDEV)  &fdcache($Addr_Type,$Addr, $Length);  &else  &if ( &IO_SYNC_FORCPU)  &pdcache($Addr_Type,$Addr, $Length); }  &if (! (($Hints) &IO_NO_SYNC))  &SYNC() }  &else  &if (! (($Hints) &IO_NO_SYNC))  &DMASyncCache(); });
    }' unless defined(&dma_sync);
    if(defined(&GROSS_AND_TEMPORARY_PCXU_HACK)) {
	eval 'sub DMASyncCachelineForDev {
	    local($Addr_Type,$Addr,$Length,$Hints) = @_;
    	    eval q({  &if {  &register  &Ofst = $Addr;  &register  &r0 = 0;  &_asm(\\"SYNC\\");  &_asm(\\"FDC\\", &r0,0, &Ofst); } });
	}' unless defined(&DMASyncCachelineForDev);
	eval 'sub DMASyncCachelineForCPU {
	    local($Addr_Type,$Addr,$Length,$Hints) = @_;
    	    eval q({  &if {  &register  &Ofst = $Addr;  &register  &r0 = 0;  &_asm(\\"SYNC\\");  &_asm(\\"PDC\\", &r0,0, &Ofst); } });
	}' unless defined(&DMASyncCachelineForCPU);
    } else {
	eval 'sub DMASyncCachelineForDev {
	    local($Addr_Type,$Addr,$Length,$Hints) = @_;
    	    eval q({  &if {  &register  &Ofst = $Addr;  &register  &r0 = 0;  &_asm(\\"FDC\\", &r0,0, &Ofst); } });
	}' unless defined(&DMASyncCachelineForDev);
	eval 'sub DMASyncCachelineForCPU {
	    local($Addr_Type,$Addr,$Length,$Hints) = @_;
    	    eval q({  &if {  &register  &Ofst = $Addr;  &register  &r0 = 0;  &_asm(\\"PDC\\", &r0,0, &Ofst); } });
	}' unless defined(&DMASyncCachelineForCPU);
    }
    eval 'sub DMASyncForDev {
        local($Addr_Type,$Addr,$Length,$Hints) = @_;
	    eval q({  &if {  &FDCACHE_BY_ROTE($Addr_Type,$Addr,$Length)  &if (! (($Hints) &IO_NO_SYNC))  &SYNC() }  &else  &CacheSyncConditional($Hints); });
    }' unless defined(&DMASyncForDev);
    eval 'sub DMASyncForDevConditional () { &DMASyncForDevModified;}' unless defined(&DMASyncForDevConditional);
    eval 'sub DMASyncForDevModified {
        local($Addr_Type,$Addr,$Length,$Hints) = @_;
	    eval q({  &if {  &FDCACHE_CONDITIONALLY($Addr_Type,$Addr, $Length, &c_modified)  &if (! (($Hints) &IO_NO_SYNC))  &SYNC() }  &else  &CacheSyncConditional($Hints); });
    }' unless defined(&DMASyncForDevModified);
    eval 'sub DMASyncForCPU {
        local($Addr_Type,$Addr,$Length,$Hints) = @_;
	    eval q({  &if {  &PDCACHE_BY_ROTE($Addr_Type,$Addr,$Length)  &if (! (($Hints) &IO_NO_SYNC))  &SYNC() }  &else  &CacheSyncConditional($Hints); });
    }' unless defined(&DMASyncForCPU);
    eval 'sub DMASyncForCPUConditional () { &DMASyncForCPUAccessed;}' unless defined(&DMASyncForCPUConditional);
    eval 'sub DMASyncForCPUAccessed {
        local($Addr_Type,$Addr,$Length,$Hints) = @_;
	    eval q({  &if {  &PDCACHE_CONDITIONALLY($Addr_Type,$Addr, $Length, &c_accessed)  &if (! (($Hints) &IO_NO_SYNC))  &SYNC() }  &else  &CacheSyncConditional($Hints); });
    }' unless defined(&DMASyncForCPUAccessed);
    eval 'sub DMASyncCache () {
        eval q({  &_asm(\\"SYNCDMA\\"); });
    }' unless defined(&DMASyncCache);
    eval 'sub CacheSyncConditional {
        local($Hints) = @_;
	    eval q({  &if (! (($Hints) &IO_NO_SYNC))  &DMASyncCache(); });
    }' unless defined(&CacheSyncConditional);
    eval 'sub MAX_CCIO_TRANSLATIONS () {2;}' unless defined(&MAX_CCIO_TRANSLATIONS);
    eval 'sub init_map_context {
        local($map) = @_;
	    eval q({ \'int\'  &i; ($map)-> &index = -1;  &for ( &i = 0;  &i <  &MAX_CCIO_TRANSLATIONS;  &i++) ($map)-> $context[ &i] = ( &void *)-1; });
    }' unless defined(&init_map_context);
    eval 'sub wsio_dma_alloc {
        local($Isc,$Iova) = @_;
	    eval q((* ($Isc->{map_funcs}->{dma_alloc}))( ($Isc->{map_funcs}->{arg}),$Iova));
    }' unless defined(&wsio_dma_alloc);
    eval 'sub wsio_dma_free {
        local($Isc,$Iova,$Addr) = @_;
	    eval q((* ($Isc->{map_funcs}->{dma_free}))( ($Isc->{map_funcs}->{arg}),$Iova,$Addr));
    }' unless defined(&wsio_dma_free);
    eval 'sub wsio_fastmap {
        local($Isc,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((* ($Isc->{map_funcs}->{fastmap})) ( ($Isc->{map_funcs}->{arg}),$Range_type,$Host_range,$Io_range));
    }' unless defined(&wsio_fastmap);
    eval 'sub wsio_get_pva {
        local($Isc,$Iova) = @_;
	    eval q((* ($Isc->{map_funcs}->{get_pva}))( ($Isc->{map_funcs}->{arg}),$Iova));
    }' unless defined(&wsio_get_pva);
    eval 'sub wsio_map {
        local($Isc,$Map_cb,$Hints,$Range_type,$Host_range,$Io_range) = @_;
	    eval q(((($Hints) &  &IO_CONTIGUOUS) == 0? (* ($Isc->{map_funcs}->{map}))( ($Isc->{map_funcs}->{arg}), $Map_cb,$Hints,$Range_type,$Host_range,$Io_range) : (* ($Isc->{map_funcs}->{map_contiguous}))( ($Isc->{map_funcs}->{arg}), $Map_cb,$Hints,$Range_type,$Host_range,$Io_range) ));
    }' unless defined(&wsio_map);
    eval 'sub wsio_remap {
        local($Isc,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((* ($Isc->{map_funcs}->{remap})) ( ($Isc->{map_funcs}->{arg}),$Range_type,$Host_range,$Io_range));
    }' unless defined(&wsio_remap);
    eval 'sub wsio_set_attributes {
        local($Isc,$Attributes) = @_;
	    eval q((* ($Isc->{map_funcs}->{set_attributes})) ( ($Isc->{map_funcs}), ($Isc->{map_funcs}->{arg}),$Attributes));
    }' unless defined(&wsio_set_attributes);
    eval 'sub wsio_sync_busses {
        local($Isc,$Hints) = @_;
	    eval q((( ($Isc->{map_funcs}->{sync_busses})) ? (* ($Isc->{map_funcs}->{sync_busses})) ( ($Isc->{map_funcs}->{shmem_arg}),$Hints) : 0));
    }' unless defined(&wsio_sync_busses);
    eval 'sub wsio_shared_mem_lock {
        local($Isc) = @_;
	    eval q((* ($Isc->{map_funcs}->{shmem_lock}))( ($Isc->{map_funcs}->{shmem_arg})));
    }' unless defined(&wsio_shared_mem_lock);
    eval 'sub wsio_shared_mem_unlock {
        local($Isc) = @_;
	    eval q((* ($Isc->{map_funcs}->{shmem_unlock}))( ($Isc->{map_funcs}->{shmem_arg})));
    }' unless defined(&wsio_shared_mem_unlock);
    eval 'sub wsio_unmap {
        local($Isc,$Io_range) = @_;
	    eval q((* ($Isc->{map_funcs}->{unmap}))( ($Isc->{map_funcs}->{arg}),$Io_range));
    }' unless defined(&wsio_unmap);
    if(defined(&_IOSERV_INCLUDED)) {
	eval 'sub SIO_MAP_FUNC {
	    local($x) = @_;
    	    eval q(( ($Msg_control->{port_index[$x]}->{map_funcs})));
	}' unless defined(&SIO_MAP_FUNC);
    } else {
	eval 'sub SIO_MAP_FUNC {
	    local($x) = @_;
    	    eval q(( &sio_get_map_funcs($x)));
	}' unless defined(&SIO_MAP_FUNC);
    }
    eval 'sub sio_dma_alloc {
        local($Port_num,$Iova) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &dma_alloc)( &SIO_MAP_FUNC($Port_num)-> &arg,$Iova));
    }' unless defined(&sio_dma_alloc);
    eval 'sub sio_f_dma_alloc {
        local($Fn,$Iova) = @_;
	    eval q((* ($Fn->{dma_alloc}))( ($Fn->{arg}),$Iova));
    }' unless defined(&sio_f_dma_alloc);
    eval 'sub sio_dma_free {
        local($Port_num,$Iova,$Addr) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &dma_free) ( &SIO_MAP_FUNC($Port_num)-> &arg,$Iova,$Addr));
    }' unless defined(&sio_dma_free);
    eval 'sub sio_f_dma_free {
        local($Fn,$Iova,$Addr) = @_;
	    eval q((* ($Fn->{dma_free}))( ($Fn->{arg}),$Iova,$Addr));
    }' unless defined(&sio_f_dma_free);
    eval 'sub sio_fastmap {
        local($Port_num,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &fastmap) ( &SIO_MAP_FUNC($Port_num)-> &arg,$Range_type,$Host_range,$Io_range));
    }' unless defined(&sio_fastmap);
    eval 'sub sio_f_fastmap {
        local($Fn,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((* ($Fn->{fastmap}))( ($Fn->{arg}),$Range_type,$Host_range,$Io_range));
    }' unless defined(&sio_f_fastmap);
    eval 'sub sio_get_pva {
        local($Port_num,$Iova) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &get_pva)( &SIO_MAP_FUNC($Port_num)-> &arg,$Iova));
    }' unless defined(&sio_get_pva);
    eval 'sub sio_f_get_pva {
        local($Fn,$Iova) = @_;
	    eval q((* ($Fn->{get_pva}))( ($Fn->{arg}),$Iova));
    }' unless defined(&sio_f_get_pva);
    eval 'sub sio_map {
        local($Port_num,$Map_cb,$Hints,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((($Hints &  &IO_CONTIGUOUS) == 0? (* &SIO_MAP_FUNC($Port_num)-> &map)( &SIO_MAP_FUNC($Port_num)-> &arg, $Map_cb,$Hints,$Range_type,$Host_range,$Io_range) : (* &SIO_MAP_FUNC($Port_num)-> &map_contiguous) ( &SIO_MAP_FUNC($Port_num)-> &arg, $Map_cb,$Hints,$Range_type,$Host_range,$Io_range) ));
    }' unless defined(&sio_map);
    eval 'sub sio_f_map {
        local($Fn,$Map_cb,$Hints,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((($Hints &  &IO_CONTIGUOUS) == 0? (* ($Fn->{map}))( ($Fn->{arg}),$Map_cb,$Hints,$Range_type,$Host_range,$Io_range): (* ($Fn->{map_contiguous}))( ($Fn->{arg}),$Map_cb,$Hints,$Range_type, $Host_range, $Io_range) ));
    }' unless defined(&sio_f_map);
    eval 'sub sio_remap {
        local($Port_num,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &remap) ( &SIO_MAP_FUNC($Port_num)-> &arg,$Range_type,$Host_range,$Io_range));
    }' unless defined(&sio_remap);
    eval 'sub sio_f_remap {
        local($Fn,$Range_type,$Host_range,$Io_range) = @_;
	    eval q((* ($Fn->{remap}))( ($Fn->{arg}),$Range_type,$Host_range,$Io_range));
    }' unless defined(&sio_f_remap);
    eval 'sub SIO_MAP_FUNC_PTR {
        local($x) = @_;
	    eval q(( &sio_get_map_funcs_ptr($x)));
    }' unless defined(&SIO_MAP_FUNC_PTR);
    eval 'sub sio_set_attributes {
        local($Port_num,$Attributes) = @_;
	    eval q({ (* &SIO_MAP_FUNC($Port_num)-> &set_attributes) ( &SIO_MAP_FUNC_PTR($Port_num),  &SIO_MAP_FUNC($Port_num)-> &arg,$Attributes); });
    }' unless defined(&sio_set_attributes);
    eval 'sub sio_shared_mem_lock {
        local($Port_num) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &shmem_lock)( &SIO_MAP_FUNC($Port_num)-> &shmem_arg));
    }' unless defined(&sio_shared_mem_lock);
    eval 'sub sio_shared_mem_unlock {
        local($Port_num) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &shmem_unlock) ( &SIO_MAP_FUNC($Port_num)-> &shmem_arg));
    }' unless defined(&sio_shared_mem_unlock);
    eval 'sub sio_unmap {
        local($Port_num,$Io_range) = @_;
	    eval q((* &SIO_MAP_FUNC($Port_num)-> &unmap)( &SIO_MAP_FUNC($Port_num)-> &arg,$Io_range));
    }' unless defined(&sio_unmap);
    eval 'sub sio_f_unmap {
        local($Fn,$Io_range) = @_;
	    eval q((* ($Fn->{unmap}))( ($Fn->{arg}),$Io_range));
    }' unless defined(&sio_f_unmap);
}
1;
