require '_h2ph_pre.ph';

unless(defined(&_SYS_EISA_INCLUDED)) {
    eval 'sub _SYS_EISA_INCLUDED () {1;}' unless defined(&_SYS_EISA_INCLUDED);
    unless(defined(&_SYS_STDSYMS_INCLUDED)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/stdsyms.ph';
	} else {
	    require 'sys/stdsyms.ph';
	}
    }
    if(defined(&_KERNEL_BUILD)) {
	require '../wsio/timeout.ph';
	require '../h/spinlock.ph';
	require '../h/param.ph';
	require '../io/dma.ph';
	require '../io/ioparams.ph';
    } else {
	require 'sys/timeout.ph';
	require 'sys/spinlock.ph';
	require 'sys/param.ph';
	require 'sys/dma.ph';
	require 'sys/ioparams.ph';
    }
    eval 'sub EISA1 () {0;}' unless defined(&EISA1);
    eval 'sub ISR_IS_MP_SAFE () {0x1;}' unless defined(&ISR_IS_MP_SAFE);
    eval 'sub SNAKES_EISA_BUS () {0x76;}' unless defined(&SNAKES_EISA_BUS);
    eval 'sub WAX_EISA_BUS () {0x90;}' unless defined(&WAX_EISA_BUS);
    eval 'sub EISA1_BASE_ADDR () {0xfc000000;}' unless defined(&EISA1_BASE_ADDR);
    eval 'sub EISA1_IOMAP_ADDR () {0xfc100000;}' unless defined(&EISA1_IOMAP_ADDR);
    eval 'sub EISA1_IOMAP_ADDR_OFFSET () {0x00100000;}' unless defined(&EISA1_IOMAP_ADDR_OFFSET);
    eval 'sub EISA1_MG_REG_BASE () {0xfc010000;}' unless defined(&EISA1_MG_REG_BASE);
    eval 'sub EISA1_MG_REG_BASE_OFFSET () {0x00010000;}' unless defined(&EISA1_MG_REG_BASE_OFFSET);
    eval 'sub EISA1_IACK_REG () {0xfc01f000;}' unless defined(&EISA1_IACK_REG);
    eval 'sub EISA1_IACK_REG_OFFSET () {0x0001f000;}' unless defined(&EISA1_IACK_REG_OFFSET);
    eval 'sub NUM_EISA_BUSES () {1;}' unless defined(&NUM_EISA_BUSES);
    eval 'sub EISA1_NUM_SLOTS_MAX () {8;}' unless defined(&EISA1_NUM_SLOTS_MAX);
    eval 'sub SHORT_TERM_ENTRY () {0;}' unless defined(&SHORT_TERM_ENTRY);
    eval 'sub LONG_TERM_ENTRY () {1;}' unless defined(&LONG_TERM_ENTRY);
    eval 'sub COBRA_ESB_ID () {0x22f0c000;}' unless defined(&COBRA_ESB_ID);
    eval 'sub CORAL_ESB_ID () {0x22f0c010;}' unless defined(&CORAL_ESB_ID);
    eval 'sub TWAYS_ESB_ID () {0x22f0c020;}' unless defined(&TWAYS_ESB_ID);
    eval 'sub MACE_ESB_ID () {0x22f0c031;}' unless defined(&MACE_ESB_ID);
    eval 'sub EISA1_MIN () {0x40;}' unless defined(&EISA1_MIN);
    eval 'sub EISA_REG_PAGE () {0xfff;}' unless defined(&EISA_REG_PAGE);
    eval 'sub EISA_MAXPHYS () {(4*1024*1024);}' unless defined(&EISA_MAXPHYS);
    eval 'sub valid_eisa_sc {
        local($sc) = @_;
	    eval q((((($sc) & 0xf0) ==  &EISA1_MIN)  && ((($sc) & 0xf) > 0)  && ((($sc) & 0xf) <=  &eisa1_num_slots)));
    }' unless defined(&valid_eisa_sc);
    eval 'sub CARD_ID_OFFSET () {0xc80;}' unless defined(&CARD_ID_OFFSET);
    eval 'sub CARD_CONTROL_OFFSET () {0xc84;}' unless defined(&CARD_CONTROL_OFFSET);
    eval 'sub EISA_CARD_ENABLE () {0x1;}' unless defined(&EISA_CARD_ENABLE);
    eval 'sub IOCHKERR () {0x2;}' unless defined(&IOCHKERR);
    eval 'sub IOCHKRESET () {0x4;}' unless defined(&IOCHKRESET);
    eval 'sub NUM_DMA_CH_PER_BUS () {8;}' unless defined(&NUM_DMA_CH_PER_BUS);
    eval 'sub NUM_IRQ_PER_BUS () {16;}' unless defined(&NUM_IRQ_PER_BUS);
    eval 'sub NUM_IRQ_PER_BUS () {16;}' unless defined(&NUM_IRQ_PER_BUS);
    if(defined(&OLD_STUFF)) {
    }
    eval 'sub HAS_IOCHKERR () {0x1;}' unless defined(&HAS_IOCHKERR);
    eval 'sub INITIALIZED () {0x2;}' unless defined(&INITIALIZED);
    eval 'sub INIT_ERROR () {0x4;}' unless defined(&INIT_ERROR);
    eval 'sub IS_ISA_CARD () {0x8;}' unless defined(&IS_ISA_CARD);
    eval 'sub DMA_ISA () {0x1;}' unless defined(&DMA_ISA);
    eval 'sub DMA_TYPEA () {0x2;}' unless defined(&DMA_TYPEA);
    eval 'sub DMA_TYPEB () {0x4;}' unless defined(&DMA_TYPEB);
    eval 'sub DMA_BURST () {0x8;}' unless defined(&DMA_BURST);
    eval 'sub DMA_TYPEC () { &DMA_BURST;}' unless defined(&DMA_TYPEC);
    eval 'sub DMA_DEMAND () {0x10;}' unless defined(&DMA_DEMAND);
    eval 'sub DMA_SINGLE () {0x20;}' unless defined(&DMA_SINGLE);
    eval 'sub DMA_BLOCK () {0x40;}' unless defined(&DMA_BLOCK);
    eval 'sub DMA_CASCADE () {0x80;}' unless defined(&DMA_CASCADE);
    eval 'sub DMA_8BYTE () {0x100;}' unless defined(&DMA_8BYTE);
    eval 'sub DMA_16WORD () {0x200;}' unless defined(&DMA_16WORD);
    eval 'sub DMA_16BYTE () {0x400;}' unless defined(&DMA_16BYTE);
    eval 'sub DMA_32BYTE () {0x800;}' unless defined(&DMA_32BYTE);
    eval 'sub DMA_READ () {0x1000;}' unless defined(&DMA_READ);
    eval 'sub DMA_WRITE () {0x2000;}' unless defined(&DMA_WRITE);
    eval 'sub DMA_SKIP_IOMAP () {0x4000;}' unless defined(&DMA_SKIP_IOMAP);
    eval 'sub ISA_CHANNEL_MASK () {0xf;}' unless defined(&ISA_CHANNEL_MASK);
    eval 'sub ADDR_CHAIN () {0x1;}' unless defined(&ADDR_CHAIN);
    eval 'sub NO_CHECK () {0x2;}' unless defined(&NO_CHECK);
    eval 'sub NO_ALLOC_CHAIN () {0x4;}' unless defined(&NO_ALLOC_CHAIN);
    eval 'sub EISA_BYTE_ENABLE () {0x8;}' unless defined(&EISA_BYTE_ENABLE);
    eval 'sub NO_WAIT () {0x10;}' unless defined(&NO_WAIT);
    eval 'sub USER_PHYS () {0x20;}' unless defined(&USER_PHYS);
    eval 'sub PAGELETS () {0x100;}' unless defined(&PAGELETS);
    eval 'sub UNSUPPORTED_FLAG () {-1;}' unless defined(&UNSUPPORTED_FLAG);
    eval 'sub RESOURCE_UNAVAILABLE () {-2;}' unless defined(&RESOURCE_UNAVAILABLE);
    eval 'sub BUF_ALIGN_ERROR () {-3;}' unless defined(&BUF_ALIGN_ERROR);
    eval 'sub MEMORY_ALLOC_FAILED () {-4;}' unless defined(&MEMORY_ALLOC_FAILED);
    eval 'sub TRANSFER_SIZE () {-5;}' unless defined(&TRANSFER_SIZE);
    eval 'sub INVALID_OPTIONS_FLAGS () {-6;}' unless defined(&INVALID_OPTIONS_FLAGS);
    eval 'sub ILLEGAL_CHANNEL () {-7;}' unless defined(&ILLEGAL_CHANNEL);
    eval 'sub NULL_CHAINPTR () {-8;}' unless defined(&NULL_CHAINPTR);
    eval 'sub BUFLET_ALLOC_FAILED () {-9;}' unless defined(&BUFLET_ALLOC_FAILED);
    eval 'sub BUS_MASTER_DMA () {-1;}' unless defined(&BUS_MASTER_DMA);
    eval 'sub COUNT_BCD () {0x1;}' unless defined(&COUNT_BCD);
    eval 'sub MODE_0 () {0x0;}' unless defined(&MODE_0);
    eval 'sub MODE_1 () {0x2;}' unless defined(&MODE_1);
    eval 'sub MODE_2 () {0x4;}' unless defined(&MODE_2);
    eval 'sub MODE_3 () {0x6;}' unless defined(&MODE_3);
    eval 'sub MODE_4 () {0x8;}' unless defined(&MODE_4);
    eval 'sub MODE_5 () {0xa;}' unless defined(&MODE_5);
    eval 'sub COUNTER_LATCH () {0x0;}' unless defined(&COUNTER_LATCH);
    eval 'sub RW_LEAST () {0x10;}' unless defined(&RW_LEAST);
    eval 'sub RW_MOST () {0x20;}' unless defined(&RW_MOST);
    eval 'sub RW_BOTH () {0x30;}' unless defined(&RW_BOTH);
    eval 'sub COUNTER_0_SELECT () {0x0;}' unless defined(&COUNTER_0_SELECT);
    eval 'sub COUNTER_1_SELECT () {0x40;}' unless defined(&COUNTER_1_SELECT);
    eval 'sub COUNTER_2_SELECT () {0x80;}' unless defined(&COUNTER_2_SELECT);
    eval 'sub READ_BACK () {0xc0;}' unless defined(&READ_BACK);
    eval 'sub ICW1 () {0x10;}' unless defined(&ICW1);
    eval 'sub LTIM () {0x8;}' unless defined(&LTIM);
    eval 'sub ADI () {0x4;}' unless defined(&ADI);
    eval 'sub SNGL () {0x2;}' unless defined(&SNGL);
    eval 'sub ICW4_USED () {0x1;}' unless defined(&ICW4_USED);
    eval 'sub EISA1_MASTER_VECTOR () {0x00;}' unless defined(&EISA1_MASTER_VECTOR);
    eval 'sub EISA1_SLAVE_VECTOR () {0x08;}' unless defined(&EISA1_SLAVE_VECTOR);
    eval 'sub SLAVE () {0x2;}' unless defined(&SLAVE);
    eval 'sub MASTER () {0x4;}' unless defined(&MASTER);
    eval 'sub SFNM () {0x10;}' unless defined(&SFNM);
    eval 'sub BUF () {0x8;}' unless defined(&BUF);
    eval 'sub M () {- &S 0x4;}' unless defined(&M);
    eval 'sub AEOI () {0x2;}' unless defined(&AEOI);
    eval 'sub uPM () {0x1;}' unless defined(&uPM);
    eval 'sub CMD_IRQ0 () {0x0;}' unless defined(&CMD_IRQ0);
    eval 'sub CMD_IRQ1 () {0x1;}' unless defined(&CMD_IRQ1);
    eval 'sub CMD_IRQ2 () {0x2;}' unless defined(&CMD_IRQ2);
    eval 'sub CMD_IRQ3 () {0x3;}' unless defined(&CMD_IRQ3);
    eval 'sub CMD_IRQ4 () {0x4;}' unless defined(&CMD_IRQ4);
    eval 'sub CMD_IRQ5 () {0x5;}' unless defined(&CMD_IRQ5);
    eval 'sub CMD_IRQ6 () {0x6;}' unless defined(&CMD_IRQ6);
    eval 'sub CMD_IRQ7 () {0x7;}' unless defined(&CMD_IRQ7);
    eval 'sub CMD_IRQ8 () {0x0;}' unless defined(&CMD_IRQ8);
    eval 'sub CMD_IRQ9 () {0x1;}' unless defined(&CMD_IRQ9);
    eval 'sub CMD_IRQ10 () {0x2;}' unless defined(&CMD_IRQ10);
    eval 'sub CMD_IRQ11 () {0x3;}' unless defined(&CMD_IRQ11);
    eval 'sub CMD_IRQ12 () {0x4;}' unless defined(&CMD_IRQ12);
    eval 'sub CMD_IRQ13 () {0x5;}' unless defined(&CMD_IRQ13);
    eval 'sub CMD_IRQ14 () {0x6;}' unless defined(&CMD_IRQ14);
    eval 'sub CMD_IRQ15 () {0x7;}' unless defined(&CMD_IRQ15);
    eval 'sub NS_EOI () {0x20;}' unless defined(&NS_EOI);
    eval 'sub SP_EOI () {0x60;}' unless defined(&SP_EOI);
    eval 'sub SP_NOP () {0x40;}' unless defined(&SP_NOP);
    eval 'sub SET_PRIORITY () {0xc0;}' unless defined(&SET_PRIORITY);
    eval 'sub OCW3 () {0x8;}' unless defined(&OCW3);
    eval 'sub READ_ISR () {0x3;}' unless defined(&READ_ISR);
    eval 'sub READ_IRR () {0x2;}' unless defined(&READ_IRR);
    eval 'sub PARITY_DISABLED () {0x4;}' unless defined(&PARITY_DISABLED);
    eval 'sub IOCHK_DISABLED () {0x8;}' unless defined(&IOCHK_DISABLED);
    eval 'sub IOCHK_NMI () {0x40;}' unless defined(&IOCHK_NMI);
    eval 'sub PARITY_NMI () {0x80;}' unless defined(&PARITY_NMI);
    eval 'sub RESET_SYSTEM_BUS () {0x1;}' unless defined(&RESET_SYSTEM_BUS);
    eval 'sub SW_ENABLED () {0x2;}' unless defined(&SW_ENABLED);
    eval 'sub FAILSAFE_ENABLED () {0x4;}' unless defined(&FAILSAFE_ENABLED);
    eval 'sub BUS_TO_ENABLED () {0x8;}' unless defined(&BUS_TO_ENABLED);
    eval 'sub SW_NMI () {0x20;}' unless defined(&SW_NMI);
    eval 'sub BUS_TO_NMI () {0x40;}' unless defined(&BUS_TO_NMI);
    eval 'sub FAILSAFE_NMI () {0x80;}' unless defined(&FAILSAFE_NMI);
    eval 'sub CHANNEL_0_SELECT () {0x0;}' unless defined(&CHANNEL_0_SELECT);
    eval 'sub CHANNEL_1_SELECT () {0x1;}' unless defined(&CHANNEL_1_SELECT);
    eval 'sub CHANNEL_2_SELECT () {0x2;}' unless defined(&CHANNEL_2_SELECT);
    eval 'sub CHANNEL_3_SELECT () {0x3;}' unless defined(&CHANNEL_3_SELECT);
    eval 'sub CHANNEL_4_SELECT () {0x0;}' unless defined(&CHANNEL_4_SELECT);
    eval 'sub CHANNEL_5_SELECT () {0x1;}' unless defined(&CHANNEL_5_SELECT);
    eval 'sub CHANNEL_6_SELECT () {0x2;}' unless defined(&CHANNEL_6_SELECT);
    eval 'sub CHANNEL_7_SELECT () {0x3;}' unless defined(&CHANNEL_7_SELECT);
    eval 'sub ADDR_MODE_MASK () {0xc;}' unless defined(&ADDR_MODE_MASK);
    eval 'sub BYTE_8BIT () {0x0;}' unless defined(&BYTE_8BIT);
    eval 'sub WORD_16BIT () {0x4;}' unless defined(&WORD_16BIT);
    eval 'sub BYTE_32BIT () {0x8;}' unless defined(&BYTE_32BIT);
    eval 'sub BYTE_16BIT () {0xc;}' unless defined(&BYTE_16BIT);
    eval 'sub CYCLE_TIMING_MASK () {0x30;}' unless defined(&CYCLE_TIMING_MASK);
    eval 'sub ISA_TIMING () {0x00;}' unless defined(&ISA_TIMING);
    eval 'sub TYPEA_TIMING () {0x10;}' unless defined(&TYPEA_TIMING);
    eval 'sub TYPEB_TIMING () {0x20;}' unless defined(&TYPEB_TIMING);
    eval 'sub TYPEC_TIMING () {0x30;}' unless defined(&TYPEC_TIMING);
    eval 'sub BURST () { &TYPEC_TIMING;}' unless defined(&BURST);
    eval 'sub TC_INPUT () {0x40;}' unless defined(&TC_INPUT);
    eval 'sub STOP_DISABLED () {0x80;}' unless defined(&STOP_DISABLED);
    eval 'sub MODE_MASK () {0x0c;}' unless defined(&MODE_MASK);
    eval 'sub DISABLE_CHAINING () {0x0;}' unless defined(&DISABLE_CHAINING);
    eval 'sub ENABLE_CHAINING () {0x4;}' unless defined(&ENABLE_CHAINING);
    eval 'sub START_CHAINING () {0x8;}' unless defined(&START_CHAINING);
    eval 'sub ON_CHAIN_TERMINATION () {0x10;}' unless defined(&ON_CHAIN_TERMINATION);
    eval 'sub CHANNEL_0_ENABLED () {0x1;}' unless defined(&CHANNEL_0_ENABLED);
    eval 'sub CHANNEL_1_ENABLED () {0x2;}' unless defined(&CHANNEL_1_ENABLED);
    eval 'sub CHANNEL_2_ENABLED () {0x4;}' unless defined(&CHANNEL_2_ENABLED);
    eval 'sub CHANNEL_3_ENABLED () {0x8;}' unless defined(&CHANNEL_3_ENABLED);
    eval 'sub CHANNEL_5_ENABLED () {0x20;}' unless defined(&CHANNEL_5_ENABLED);
    eval 'sub CHANNEL_6_ENABLED () {0x40;}' unless defined(&CHANNEL_6_ENABLED);
    eval 'sub CHANNEL_7_ENABLED () {0x80;}' unless defined(&CHANNEL_7_ENABLED);
    eval 'sub CHANNEL_0_IRQ13 () {0x1;}' unless defined(&CHANNEL_0_IRQ13);
    eval 'sub CHANNEL_1_IRQ13 () {0x2;}' unless defined(&CHANNEL_1_IRQ13);
    eval 'sub CHANNEL_2_IRQ13 () {0x4;}' unless defined(&CHANNEL_2_IRQ13);
    eval 'sub CHANNEL_3_IRQ13 () {0x8;}' unless defined(&CHANNEL_3_IRQ13);
    eval 'sub CHANNEL_5_IRQ13 () {0x20;}' unless defined(&CHANNEL_5_IRQ13);
    eval 'sub CHANNEL_6_IRQ13 () {0x40;}' unless defined(&CHANNEL_6_IRQ13);
    eval 'sub CHANNEL_7_IRQ13 () {0x80;}' unless defined(&CHANNEL_7_IRQ13);
    eval 'sub DISABLE_ALL_CHANNELS () {0x4;}' unless defined(&DISABLE_ALL_CHANNELS);
    eval 'sub ROTATING_PRIORITY () {0x10;}' unless defined(&ROTATING_PRIORITY);
    eval 'sub DRQ_LOW () {0x40;}' unless defined(&DRQ_LOW);
    eval 'sub DAK_HIGH () {0x80;}' unless defined(&DAK_HIGH);
    eval 'sub TRANSFER_TYPE_MASK () {0xc;}' unless defined(&TRANSFER_TYPE_MASK);
    eval 'sub VERIFY_TRANSFER () {0x0;}' unless defined(&VERIFY_TRANSFER);
    eval 'sub READ_TRANSFER () {0x4;}' unless defined(&READ_TRANSFER);
    eval 'sub WRITE_TRANSFER () {0x8;}' unless defined(&WRITE_TRANSFER);
    eval 'sub ENABLE_AUTO_INIT () {0x10;}' unless defined(&ENABLE_AUTO_INIT);
    eval 'sub DECREMENT_ADDR () {0x20;}' unless defined(&DECREMENT_ADDR);
    eval 'sub CHANNEL_MODE_MASK () {0xc0;}' unless defined(&CHANNEL_MODE_MASK);
    eval 'sub DEMAND_MODE () {0x0;}' unless defined(&DEMAND_MODE);
    eval 'sub SINGLE_MODE () {0x40;}' unless defined(&SINGLE_MODE);
    eval 'sub BLOCK_MODE () {0x80;}' unless defined(&BLOCK_MODE);
    eval 'sub CASCADE_MODE () {0xc0;}' unless defined(&CASCADE_MODE);
    eval 'sub REQUEST_DMA () {0x4;}' unless defined(&REQUEST_DMA);
    eval 'sub SET_MASK () {0x4;}' unless defined(&SET_MASK);
    eval 'sub SET_CHANNEL0_MASK () {0x1;}' unless defined(&SET_CHANNEL0_MASK);
    eval 'sub SET_CHANNEL1_MASK () {0x2;}' unless defined(&SET_CHANNEL1_MASK);
    eval 'sub SET_CHANNEL2_MASK () {0x4;}' unless defined(&SET_CHANNEL2_MASK);
    eval 'sub SET_CHANNEL3_MASK () {0x8;}' unless defined(&SET_CHANNEL3_MASK);
    eval 'sub SET_CHANNEL4_MASK () {0x1;}' unless defined(&SET_CHANNEL4_MASK);
    eval 'sub SET_CHANNEL5_MASK () {0x2;}' unless defined(&SET_CHANNEL5_MASK);
    eval 'sub SET_CHANNEL6_MASK () {0x4;}' unless defined(&SET_CHANNEL6_MASK);
    eval 'sub SET_CHANNEL7_MASK () {0x8;}' unless defined(&SET_CHANNEL7_MASK);
    eval 'sub CHANNEL0_TC () {0x1;}' unless defined(&CHANNEL0_TC);
    eval 'sub CHANNEL1_TC () {0x2;}' unless defined(&CHANNEL1_TC);
    eval 'sub CHANNEL2_TC () {0x4;}' unless defined(&CHANNEL2_TC);
    eval 'sub CHANNEL3_TC () {0x8;}' unless defined(&CHANNEL3_TC);
    eval 'sub CHANNEL0_REQUEST () {0x10;}' unless defined(&CHANNEL0_REQUEST);
    eval 'sub CHANNEL1_REQUEST () {0x20;}' unless defined(&CHANNEL1_REQUEST);
    eval 'sub CHANNEL2_REQUEST () {0x40;}' unless defined(&CHANNEL2_REQUEST);
    eval 'sub CHANNEL3_REQUEST () {0x80;}' unless defined(&CHANNEL3_REQUEST);
    eval 'sub CHANNEL4_TC () {0x1;}' unless defined(&CHANNEL4_TC);
    eval 'sub CHANNEL5_TC () {0x2;}' unless defined(&CHANNEL5_TC);
    eval 'sub CHANNEL6_TC () {0x4;}' unless defined(&CHANNEL6_TC);
    eval 'sub CHANNEL7_TC () {0x8;}' unless defined(&CHANNEL7_TC);
    eval 'sub CHANNEL4_REQUEST () {0x10;}' unless defined(&CHANNEL4_REQUEST);
    eval 'sub CHANNEL5_REQUEST () {0x20;}' unless defined(&CHANNEL5_REQUEST);
    eval 'sub CHANNEL6_REQUEST () {0x40;}' unless defined(&CHANNEL6_REQUEST);
    eval 'sub CHANNEL7_REQUEST () {0x80;}' unless defined(&CHANNEL7_REQUEST);
    eval 'sub dma0_command () { &dma0_status;}' unless defined(&dma0_command);
    eval 'sub dma1_command () { &dma1_status;}' unless defined(&dma1_command);
    eval 'sub dma0_chaining_mode () { &dma_int_pending;}' unless defined(&dma0_chaining_mode);
    eval 'sub dma_chaining_status () { &dma1_chaining_mode;}' unless defined(&dma_chaining_status);
    eval 'sub int1_ocw2 () { &int1_icw1;}' unless defined(&int1_ocw2);
    eval 'sub int1_ocw3 () { &int1_icw1;}' unless defined(&int1_ocw3);
    eval 'sub int1_icw2 () { &int1_int_mask_reg;}' unless defined(&int1_icw2);
    eval 'sub int1_icw3 () { &int1_int_mask_reg;}' unless defined(&int1_icw3);
    eval 'sub int1_icw4 () { &int1_int_mask_reg;}' unless defined(&int1_icw4);
    eval 'sub int2_ocw2 () { &int2_icw1;}' unless defined(&int2_ocw2);
    eval 'sub int2_ocw3 () { &int2_icw1;}' unless defined(&int2_ocw3);
    eval 'sub int2_icw2 () { &int2_int_mask_reg;}' unless defined(&int2_icw2);
    eval 'sub int2_icw3 () { &int2_int_mask_reg;}' unless defined(&int2_icw3);
    eval 'sub int2_icw4 () { &int2_int_mask_reg;}' unless defined(&int2_icw4);
    eval 'sub int1_isr () { &int1_icw1;}' unless defined(&int1_isr);
    eval 'sub int1_irr () { &int1_icw1;}' unless defined(&int1_irr);
    eval 'sub int2_isr () { &int2_icw1;}' unless defined(&int2_isr);
    eval 'sub int2_irr () { &int2_icw1;}' unless defined(&int2_irr);
    eval 'sub inb {
        local($addr) = @_;
	    eval q(*($addr));
    }' unless defined(&inb);
    eval 'sub outb {
        local($addr, $value) = @_;
	    eval q((*(($addr)) = ($value)));
    }' unless defined(&outb);
    eval 'sub outs {
        local($addr, $value) = @_;
	    eval q((*(($addr)) = ((($value) >> 8) + ((($value)&0xff) << 8))));
    }' unless defined(&outs);
    eval 'sub outl {
        local($addr, $value) = @_;
	    eval q((*() = ((($value)>>24) + ((($value)&0xff0000)>>8) + ((($value)&0xff00)<<8) + ((($value)&0xff)<<24))));
    }' unless defined(&outl);
}
1;
