require '_h2ph_pre.ph';

unless(defined(&_SYS_FCNTL_INCLUDED)) {
    eval 'sub _SYS_FCNTL_INCLUDED () {1;}' unless defined(&_SYS_FCNTL_INCLUDED);
    if(defined(&_KERNEL_BUILD)) {
	require '../h/stdsyms.ph';
    } else {
	require 'sys/stdsyms.ph';
    }
    if(defined( &_INCLUDE_XOPEN_SOURCE_EXTENDED) || defined( &_INCLUDE_POSIX_SOURCE)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/types.ph';
	} else {
	    require 'sys/types.ph';
	}
    }
    if(defined(&_INCLUDE_POSIX_SOURCE)) {
	eval 'sub F_DUPFD () {0;}' unless defined(&F_DUPFD);
	eval 'sub F_GETFD () {1;}' unless defined(&F_GETFD);
	eval 'sub F_SETFD () {2;}' unless defined(&F_SETFD);
	eval 'sub F_GETFL () {3;}' unless defined(&F_GETFL);
	eval 'sub F_SETFL () {4;}' unless defined(&F_SETFL);
	if(!defined( &_FILE64)) {
	    eval 'sub F_GETLK () {5;}' unless defined(&F_GETLK);
	    eval 'sub F_SETLK () {6;}' unless defined(&F_SETLK);
	    eval 'sub F_SETLKW () {7;}' unless defined(&F_SETLKW);
	} else {
	    eval 'sub F_GETLK () {8;}' unless defined(&F_GETLK);
	    eval 'sub F_SETLK () {9;}' unless defined(&F_SETLK);
	    eval 'sub F_SETLKW () {10;}' unless defined(&F_SETLKW);
	}
	if(defined( &_LARGEFILE64_SOURCE) || defined( &_KERNEL)) {
	    eval 'sub F_GETLK64 () {8;}' unless defined(&F_GETLK64);
	    eval 'sub F_SETLK64 () {9;}' unless defined(&F_SETLK64);
	    eval 'sub F_SETLKW64 () {10;}' unless defined(&F_SETLKW64);
	}
	if(defined(&_INCLUDE_XOPEN_SOURCE_EXTENDED)) {
	    eval 'sub F_GETOWN () {11;}' unless defined(&F_GETOWN);
	    eval 'sub F_SETOWN () {12;}' unless defined(&F_SETOWN);
	}
	eval 'sub FD_CLOEXEC () {1;}' unless defined(&FD_CLOEXEC);
	eval 'sub F_RDLCK () {01;}' unless defined(&F_RDLCK);
	eval 'sub F_WRLCK () {02;}' unless defined(&F_WRLCK);
	eval 'sub F_UNLCK () {03;}' unless defined(&F_UNLCK);
	if(defined ( &_POSIX1_SOURCE) || defined( &_XPG4)) {
	    unless(defined(&SEEK_SET)) {
		eval 'sub SEEK_SET () {0;}' unless defined(&SEEK_SET);
		eval 'sub SEEK_CUR () {1;}' unless defined(&SEEK_CUR);
		eval 'sub SEEK_END () {2;}' unless defined(&SEEK_END);
	    }
	}
	eval 'sub O_RDONLY () {0000000;}' unless defined(&O_RDONLY);
	eval 'sub O_WRONLY () {0000001;}' unless defined(&O_WRONLY);
	eval 'sub O_RDWR () {0000002;}' unless defined(&O_RDWR);
	eval 'sub O_ACCMODE () {0000003;}' unless defined(&O_ACCMODE);
	eval 'sub O_CREAT () {0000400;}' unless defined(&O_CREAT);
	eval 'sub O_TRUNC () {0001000;}' unless defined(&O_TRUNC);
	eval 'sub O_EXCL () {0002000;}' unless defined(&O_EXCL);
	eval 'sub O_NOCTTY () {0400000;}' unless defined(&O_NOCTTY);
	eval 'sub O_APPEND () {0000010;}' unless defined(&O_APPEND);
	eval 'sub O_NONBLOCK () {0200000;}' unless defined(&O_NONBLOCK);
	if(defined(&_INCLUDE_XOPEN_SOURCE)) {
	    eval 'sub O_SYNC () {0100000;}' unless defined(&O_SYNC);
	}
	if(defined(&_INCLUDE_HPUX_SOURCE)) {
	    eval 'sub O_NDELAY () {0000004;}' unless defined(&O_NDELAY);
	    eval 'sub FSYNC () { &O_SYNC;}' unless defined(&FSYNC);
	    eval 'sub O_SYNCIO () { &O_SYNC;}' unless defined(&O_SYNCIO);
	    eval 'sub FSYNCIO () { &FSYNC;}' unless defined(&FSYNCIO);
	    eval 'sub O_DSYNC () {01000000;}' unless defined(&O_DSYNC);
	    eval 'sub FDSYNC () { &O_DSYNC;}' unless defined(&FDSYNC);
	    eval 'sub O_RSYNC () {02000000;}' unless defined(&O_RSYNC);
	    eval 'sub FRSYNC () { &O_RSYNC;}' unless defined(&FRSYNC);
	    eval 'sub READSYNC {
	        local($openflags) = @_;
    		eval q(((($openflags) &  &FRSYNC)  && (($openflags) & ( &FDSYNC| &FSYNC))));
	    }' unless defined(&READSYNC);
	}
	if(defined(&_INCLUDE_HPUX_SOURCE)) {
	    eval 'sub O_BLKSEEK () {0000100;}' unless defined(&O_BLKSEEK);
	    eval 'sub FBLKSEEK () { &O_BLKSEEK;}' unless defined(&FBLKSEEK);
	}
	eval 'sub O_LARGEFILE () {04000;}' unless defined(&O_LARGEFILE);
	if(defined(&_INCLUDE_HPUX_SOURCE)) {
	    eval 'sub FLARGEFILE () { &O_LARGEFILE;}' unless defined(&FLARGEFILE);
	}
	if(defined ( &_POSIX1_SOURCE) || defined( &_XPG4)) {
	    unless(defined(&S_IRWXU)) {
		eval 'sub S_ISUID () {0004000;}' unless defined(&S_ISUID);
		eval 'sub S_ISGID () {0002000;}' unless defined(&S_ISGID);
		eval 'sub S_IRWXU () {0000700;}' unless defined(&S_IRWXU);
		eval 'sub S_IRUSR () {0000400;}' unless defined(&S_IRUSR);
		eval 'sub S_IWUSR () {0000200;}' unless defined(&S_IWUSR);
		eval 'sub S_IXUSR () {0000100;}' unless defined(&S_IXUSR);
		eval 'sub S_IRWXG () {0000070;}' unless defined(&S_IRWXG);
		eval 'sub S_IRGRP () {0000040;}' unless defined(&S_IRGRP);
		eval 'sub S_IWGRP () {0000020;}' unless defined(&S_IWGRP);
		eval 'sub S_IXGRP () {0000010;}' unless defined(&S_IXGRP);
		eval 'sub S_IRWXO () {0000007;}' unless defined(&S_IRWXO);
		eval 'sub S_IROTH () {0000004;}' unless defined(&S_IROTH);
		eval 'sub S_IWOTH () {0000002;}' unless defined(&S_IWOTH);
		eval 'sub S_IXOTH () {0000001;}' unless defined(&S_IXOTH);
	    }
	}
	if(!defined( &_KERNEL)) {
	    eval 'sub __flock () { &flock;}' unless defined(&__flock);
	    require 'sys/_flock_body.ph';
	    undef(&__flock) if defined(&__flock);
	    if(defined( &_LARGEFILE64_SOURCE)) {
		eval 'sub __flock () { &flock64;}' unless defined(&__flock);
		eval 'sub off_t () { &off64_t;}' unless defined(&off_t);
		require 'sys/_flock_body.ph';
		undef(&off_t) if defined(&off_t);
		undef(&__flock) if defined(&__flock);
	    }
	} else {
	    eval 'sub __flock () { &flock64;}' unless defined(&__flock);
	    eval 'sub off_t () { &off64_t;}' unless defined(&off_t);
	    require '_flock_body.ph';
	    undef(&off_t) if defined(&off_t);
	    undef(&__flock) if defined(&__flock);
	    eval 'sub __flock () { &flock32;}' unless defined(&__flock);
	    eval 'sub off_t () { &off32_t;}' unless defined(&off_t);
	    require '_flock_body.ph';
	    undef(&off_t) if defined(&off_t);
	    undef(&__flock) if defined(&__flock);
	    eval 'sub __flock () { &k_flock;}' unless defined(&__flock);
	    eval 'sub off_t () { &k_off_t;}' unless defined(&off_t);
	    require '_flock_body.ph';
	    undef(&off_t) if defined(&off_t);
	    undef(&__flock) if defined(&__flock);
	}
	unless(defined(&_KERNEL)) {
	    if(defined(&__cplusplus)) {
	    }
	    if(defined(&_PROTOTYPES)) {
		unless(defined(&_FILE64)) {
		}
		if(defined( &_LARGEFILE64_SOURCE)) {
		}
	    } else {
		if(defined( &_LARGEFILE64_SOURCE)) {
		}
	    }
	    if(defined( &_FILE64)) {
		unless(defined(&__cplusplus)) {
		    if(defined(&__STDC_EXT__)) {
		    } else {
		    }
		} else {
		}
	    }
	    if(defined(&__cplusplus)) {
	    }
	}
    }
    if(defined(&_UNSUPPORTED)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/_fcntl.ph';
	} else {
	    require '.unsupp/sys/_fcntl.ph';
	}
    }
}
1;
