require '_h2ph_pre.ph';

unless(defined(&_SYS_FS_INCLUDED)) {
    eval 'sub _SYS_FS_INCLUDED () {1;}' unless defined(&_SYS_FS_INCLUDED);
    eval 'sub BBSIZE () {8192;}' unless defined(&BBSIZE);
    eval 'sub SBSIZE () {8192;}' unless defined(&SBSIZE);
    eval 'sub BBLOCK () {((0));}' unless defined(&BBLOCK);
    eval 'sub SBLOCK () {(( &BBLOCK +  &BBSIZE /  &DEV_BSIZE));}' unless defined(&SBLOCK);
    eval 'sub NRPOS () {8;}' unless defined(&NRPOS);
    eval 'sub MAXIPG () {2048;}' unless defined(&MAXIPG);
    eval 'sub UFS_MAXDEVBLK () {0x0ffffffe;}' unless defined(&UFS_MAXDEVBLK);
    eval 'sub UFS_MAXFSBLK {
        local($fs) = @_;
	    eval q( &dbtofsb(($fs),  &UFS_MAXDEVBLK));
    }' unless defined(&UFS_MAXFSBLK);
    eval 'sub MINBSIZE () {4096;}' unless defined(&MINBSIZE);
    eval 'sub MAXCPG () {32;}' unless defined(&MAXCPG);
    eval 'sub MAXFRAG () {8;}' unless defined(&MAXFRAG);
    unless(defined(&NBBY)) {
	eval 'sub NBBY () {8;}' unless defined(&NBBY);
    }
    eval 'sub MAXMNTLEN () {512;}' unless defined(&MAXMNTLEN);
    eval 'sub MAXCSBUFS () {32;}' unless defined(&MAXCSBUFS);
    eval 'sub FS_MAGIC () {0x011954;}' unless defined(&FS_MAGIC);
    eval 'sub FS_MAGIC_LFN () {0x095014;}' unless defined(&FS_MAGIC_LFN);
    eval 'sub FD_FSMAGIC () {0x195612;}' unless defined(&FD_FSMAGIC);
    eval 'sub FD_FSMAGIC_2 () {0x05231994;}' unless defined(&FD_FSMAGIC_2);
    eval 'sub FS_MAGIC_SEC () {0x612195;}' unless defined(&FS_MAGIC_SEC);
    eval 'sub UFS_VALID_FS_MAGIC {
        local($fs) = @_;
	    eval q(((($fs)-> &fs_magic ==  &FS_MAGIC) || (($fs)-> &fs_magic ==  &FS_MAGIC_LFN) || (($fs)-> &fs_magic ==  &FD_FSMAGIC) || (($fs)-> &fs_magic ==  &FD_FSMAGIC_2)));
    }' unless defined(&UFS_VALID_FS_MAGIC);
    eval 'sub FSF_LFN () {0x1;}' unless defined(&FSF_LFN);
    eval 'sub FSF_B1 () {0x2;}' unless defined(&FSF_B1);
    eval 'sub FSF_LARGEFILES () {0x2;}' unless defined(&FSF_LARGEFILES);
    eval 'sub FSF_LARGEUIDS () {0x4;}' unless defined(&FSF_LARGEUIDS);
    eval 'sub FSF_KNOWN () {( &FSF_LFN| &FSF_LARGEFILES| &FSF_LARGEUIDS);}' unless defined(&FSF_KNOWN);
    eval 'sub FSF_UNKNOWN {
        local($bits) = @_;
	    eval q((($bits) & ~( &FSF_KNOWN)));
    }' unless defined(&FSF_UNKNOWN);
    eval 'sub IS_LFN_FS {
        local($ip) = @_;
	    eval q(((($ip)-> ($i_fs->{fs_magic}) ==  &FS_MAGIC_LFN) || (($ip)-> ($i_fs->{fs_featurebits}) &  &FSF_LFN)));
    }' unless defined(&IS_LFN_FS);
    eval 'sub UFS_LFN_FS {
        local($fs) = @_;
	    eval q(((($fs)-> &fs_magic ==  &FS_MAGIC_LFN) || (($fs)-> &fs_featurebits &  &FSF_LFN)));
    }' unless defined(&UFS_LFN_FS);
    eval 'sub FS_CLEAN () {0x17;}' unless defined(&FS_CLEAN);
    eval 'sub FS_OK () {0x53;}' unless defined(&FS_OK);
    eval 'sub FS_NOTOK () {0x31;}' unless defined(&FS_NOTOK);
    eval 'sub FS_INSTALL () {0x80;}' unless defined(&FS_INSTALL);
    eval 'sub FS_QCLEAN () {0x01;}' unless defined(&FS_QCLEAN);
    eval 'sub FS_QOK () {0x02;}' unless defined(&FS_QOK);
    eval 'sub FS_QNOTOK () {0x03;}' unless defined(&FS_QNOTOK);
    eval 'sub FS_QMASK () {0x03;}' unless defined(&FS_QMASK);
    eval 'sub FS_QFLAG {
        local($p) = @_;
	    eval q((($p)-> &fs_flags &  &FS_QMASK));
    }' unless defined(&FS_QFLAG);
    eval 'sub FS_QSET {
        local($p,$val) = @_;
	    eval q((($p)-> &fs_flags &= ~ &FS_QMASK, ($p)-> &fs_flags |= ($val)));
    }' unless defined(&FS_QSET);
    eval 'sub FS_OPTTIME () {0;}' unless defined(&FS_OPTTIME);
    eval 'sub FS_OPTSPACE () {1;}' unless defined(&FS_OPTSPACE);
    eval 'sub fs_cs {
        local($fs, $indx) = @_;
	    eval q( $fs_csp[0][$indx]);
    }' unless defined(&fs_cs);
    eval 'sub UFS_TUNEFS () { &_IOW(ord(\'u\'), 0, \'struct ufs_livetunefs\');}' unless defined(&UFS_TUNEFS);
    eval 'sub MAXBPC () {( &SBSIZE - $sizeof{\'struct fs\'});}' unless defined(&MAXBPC);
    eval 'sub CG_MAGIC () {0x090255;}' unless defined(&CG_MAGIC);
    eval 'sub MAXBPG {
        local($fs) = @_;
	    eval q(( &fragstoblks(($fs), ( &NBBY * (($fs)-> &fs_bsize - ($sizeof{\'struct cg\'}))))));
    }' unless defined(&MAXBPG);
    eval 'sub fsbtodb {
        local($fs, $b) = @_;
	    eval q((($b) << ($fs)-> &fs_fsbtodb));
    }' unless defined(&fsbtodb);
    eval 'sub dbtofsb {
        local($fs, $b) = @_;
	    eval q((($b) >> ($fs)-> &fs_fsbtodb));
    }' unless defined(&dbtofsb);
    eval 'sub cgbase {
        local($fs, $c) = @_;
	    eval q(((($fs)-> &fs_fpg * ($c))));
    }' unless defined(&cgbase);
    eval 'sub cgstart {
        local($fs, $c) = @_;
	    eval q(( &cgbase($fs, $c) + ($fs)-> &fs_cgoffset * (($c) & ~(($fs)-> &fs_cgmask))));
    }' unless defined(&cgstart);
    eval 'sub cgsblock {
        local($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_sblkno));
    }' unless defined(&cgsblock);
    eval 'sub cgtod {
        local($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_cblkno));
    }' unless defined(&cgtod);
    eval 'sub cgimin {
        local($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_iblkno));
    }' unless defined(&cgimin);
    eval 'sub cgdmin {
        local($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_dblkno));
    }' unless defined(&cgdmin);
    eval 'sub dtog {
        local($fs, $d) = @_;
	    eval q((($d) / ($fs)-> &fs_fpg));
    }' unless defined(&dtog);
    eval 'sub dtogd {
        local($fs, $d) = @_;
	    eval q((($d) % ($fs)-> &fs_fpg));
    }' unless defined(&dtogd);
    eval 'sub blkmap {
        local($fs, $map, $loc) = @_;
	    eval q(((($map)[($loc) /  &NBBY] >> (($loc) & ( &NBBY-1))) & (0xff >> ( &NBBY - ($fs)-> &fs_frag))));
    }' unless defined(&blkmap);
    eval 'sub cbtocylno {
        local($fs, $bno) = @_;
	    eval q((($bno) *  &NSPF($fs) / ($fs)-> &fs_spc));
    }' unless defined(&cbtocylno);
    eval 'sub cbtorpos {
        local($fs, $bno) = @_;
	    eval q((($bno) *  &NSPF($fs) % ($fs)-> &fs_nsect *  &NRPOS / ($fs)-> &fs_nsect));
    }' unless defined(&cbtorpos);
    eval 'sub blkoff {
        local($fs, $loc) = @_;
	    eval q((($loc) & ~($fs)-> &fs_bmask));
    }' unless defined(&blkoff);
    eval 'sub fragoff {
        local($fs, $loc) = @_;
	    eval q((($loc) & ~($fs)-> &fs_fmask));
    }' unless defined(&fragoff);
    eval 'sub lblkno {
        local($fs, $loc) = @_;
	    eval q((($loc) >> ($fs)-> &fs_bshift));
    }' unless defined(&lblkno);
    eval 'sub numfrags {
        local($fs, $loc) = @_;
	    eval q((($loc) >> ($fs)-> &fs_fshift));
    }' unless defined(&numfrags);
    eval 'sub blkroundup {
        local($fs, $size) = @_;
	    eval q(((($size) + ($fs)-> &fs_bsize - 1) & ($fs)-> &fs_bmask));
    }' unless defined(&blkroundup);
    eval 'sub fragroundup {
        local($fs, $size) = @_;
	    eval q(((($size) + ($fs)-> &fs_fsize - 1) & ($fs)-> &fs_fmask));
    }' unless defined(&fragroundup);
    eval 'sub fragstoblks {
        local($fs, $frags) = @_;
	    eval q((($frags) >> ($fs)-> &fs_fragshift));
    }' unless defined(&fragstoblks);
    eval 'sub blkstofrags {
        local($fs, $blks) = @_;
	    eval q((($blks) << ($fs)-> &fs_fragshift));
    }' unless defined(&blkstofrags);
    eval 'sub fragnum {
        local($fs, $fsb) = @_;
	    eval q((($fsb) & (($fs)-> &fs_frag - 1)));
    }' unless defined(&fragnum);
    eval 'sub blknum {
        local($fs, $fsb) = @_;
	    eval q((($fsb) &~ (($fs)-> &fs_frag - 1)));
    }' unless defined(&blknum);
    eval 'sub freespace {
        local($fs, $percentreserved) = @_;
	    eval q(( &blkstofrags(, -> ($fs_cstotal->{cs_nbfree})) + -> ($fs_cstotal->{cs_nffree}) - ((($fs)-> &fs_dsize * ($percentreserved) / 100))));
    }' unless defined(&freespace);
    eval 'sub blksize {
        local($fs, $ip, $lbn) = @_;
	    eval q(((($lbn) >=  &NDADDR || ($ip)-> &i_size >= (($lbn) + 1) << ($fs)-> &fs_bshift) ? ($fs)-> &fs_bsize : ( &fragroundup($fs,  &blkoff($fs, ($ip)-> &i_size)))));
    }' unless defined(&blksize);
    eval 'sub dblksize {
        local($fs, $dip, $lbn) = @_;
	    eval q(((($lbn) >=  &NDADDR || ($dip)-> &di_size >= (($lbn) + 1) << ($fs)-> &fs_bshift) ? ($fs)-> &fs_bsize : ( &fragroundup($fs,  &blkoff($fs, ($dip)-> &di_size)))));
    }' unless defined(&dblksize);
    eval 'sub NSPB {
        local($fs) = @_;
	    eval q((($fs)-> &fs_nspf << ($fs)-> &fs_fragshift));
    }' unless defined(&NSPB);
    eval 'sub NSPF {
        local($fs) = @_;
	    eval q((($fs)-> &fs_nspf));
    }' unless defined(&NSPF);
}
1;
