require '_h2ph_pre.ph';

unless(defined(&_SYS_INODE_INCLUDED)) {
    eval 'sub _SYS_INODE_INCLUDED () {1;}' unless defined(&_SYS_INODE_INCLUDED);
    unless(defined(&_SYS_STDSYMS_INCLUDED)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/stdsyms.ph';
	} else {
	    require 'sys/stdsyms.ph';
	}
    }
    if(defined(&_KERNEL_BUILD)) {
	require '../h/sem_beta.ph';
	require '../h/types.ph';
    } else {
	require 'sys/sem_beta.ph';
	require 'sys/types.ph';
    }
    unless(defined(&_KERNEL_BUILD)) {
	require 'sys/vnode.ph';
    }
    if(defined(&_KERNEL_BUILD)) {
	require '../h/acl.ph';
    } else {
	require 'sys/acl.ph';
    }
    eval 'sub NDADDR () {12;}' unless defined(&NDADDR);
    eval 'sub NIADDR () {3;}' unless defined(&NIADDR);
    eval 'sub MAX_FASTLINK_SIZE () {(( &NDADDR +  &NIADDR) * $sizeof{ &daddr_t});}' unless defined(&MAX_FASTLINK_SIZE);
    eval 'sub IC_FASTLINK () {0x00000001;}' unless defined(&IC_FASTLINK);
    eval 'sub IC_LARGEUIDS () {0x00000002;}' unless defined(&IC_LARGEUIDS);
    eval 'sub ICC_LARGEUIDS () { &IC_LARGEUIDS;}' unless defined(&ICC_LARGEUIDS);
    eval 'sub _GET_IC_UID {
        local($IC) = @_;
	    eval q(((($IC). &ic_uid_msb << 16| ($IC). &ic_uid_lsb)));
    }' unless defined(&_GET_IC_UID);
    eval 'sub _GET_IC_GID {
        local($IC) = @_;
	    eval q(((($IC). &ic_gid_msb << 16| ($IC). &ic_gid_lsb)));
    }' unless defined(&_GET_IC_GID);
    eval 'sub _SET_IC_UID {
        local($IC, $UID) = @_;
	    eval q(($IC). &ic_uid_msb = ($UID) >> 16, ($IC). &ic_uid_lsb = ($UID) & 0xffff);
    }' unless defined(&_SET_IC_UID);
    eval 'sub _SET_IC_GID {
        local($IC, $GID) = @_;
	    eval q(($IC). &ic_gid_msb = ($GID) >> 16, ($IC). &ic_gid_lsb = ($GID) & 0xffff);
    }' unless defined(&_SET_IC_GID);
    eval 'sub _GET_I_UID {
        local($IP) = @_;
	    eval q( &_GET_IC_UID(($IP)-> ($i_icun->{i_ic})));
    }' unless defined(&_GET_I_UID);
    eval 'sub _GET_I_GID {
        local($IP) = @_;
	    eval q( &_GET_IC_GID(($IP)-> ($i_icun->{i_ic})));
    }' unless defined(&_GET_I_GID);
    eval 'sub _SET_I_UID {
        local($IP, $UID) = @_;
	    eval q( &_SET_IC_UID(($IP)-> ($i_icun->{i_ic}), $UID));
    }' unless defined(&_SET_I_UID);
    eval 'sub _SET_I_GID {
        local($IP, $GID) = @_;
	    eval q( &_SET_IC_GID(($IP)-> ($i_icun->{i_ic}), $GID));
    }' unless defined(&_SET_I_GID);
    eval 'sub _GET_ICC_ACL_UID {
        local($ICC, $N) = @_;
	    eval q((((($ICC). ($icc_acl_msb[$N]->{uid_byte1}) << 24) | (($ICC). ($icc_acl_lsb[$N]->{uid_byte2}) << 16) | (($ICC). ($icc_acl_lsb[$N]->{uid_byte3}) << 8) | (($ICC). ($icc_acl_lsb[$N]->{uid_byte4})))));
    }' unless defined(&_GET_ICC_ACL_UID);
    eval 'sub _GET_ICC_ACL_GID {
        local($ICC, $N) = @_;
	    eval q((((($ICC). ($icc_acl_msb[$N]->{gid_byte1}) << 24) | (($ICC). ($icc_acl_msb[$N]->{gid_byte2}) << 16) | (($ICC). ($icc_acl_lsb[$N]->{gid_byte3}) << 8) | (($ICC). ($icc_acl_lsb[$N]->{gid_byte4})))));
    }' unless defined(&_GET_ICC_ACL_GID);
    eval 'sub _GET_ICC_ACL_MODE {
        local($ICC, $N) = @_;
	    eval q(($ICC). ($icc_acl_lsb[$N]->{mode}));
    }' unless defined(&_GET_ICC_ACL_MODE);
    eval 'sub _SET_ICC_ACL_UID {
        local($ICC, $N, $UID) = @_;
	    eval q(($ICC). ($icc_acl_msb[$N]->{uid_byte1}) = ($UID) >> 24, ($ICC). ($icc_acl_lsb[$N]->{uid_byte2}) = (($UID) >> 16) & 0xff, ($ICC). ($icc_acl_lsb[$N]->{uid_byte3}) = (($UID) >> 8) & 0xff, ($ICC). ($icc_acl_lsb[$N]->{uid_byte4}) = ($UID) & 0xff);
    }' unless defined(&_SET_ICC_ACL_UID);
    eval 'sub _SET_ICC_ACL_GID {
        local($ICC, $N, $GID) = @_;
	    eval q(($ICC). ($icc_acl_msb[$N]->{gid_byte1}) = ($GID) >> 24, ($ICC). ($icc_acl_msb[$N]->{gid_byte2}) = (($GID) >> 16) & 0xff, ($ICC). ($icc_acl_lsb[$N]->{gid_byte3}) = (($GID) >> 8) & 0xff, ($ICC). ($icc_acl_lsb[$N]->{gid_byte4}) = ($GID) & 0xff);
    }' unless defined(&_SET_ICC_ACL_GID);
    eval 'sub _SET_ICC_ACL_MODE {
        local($ICC, $N, $MODE) = @_;
	    eval q(($ICC). ($icc_acl_lsb[$N]->{mode}) = $MODE);
    }' unless defined(&_SET_ICC_ACL_MODE);
    eval 'sub _GET_I_ACL_UID {
        local($CIP, $N) = @_;
	    eval q( &_GET_ICC_ACL_UID(($CIP)-> ($i_icun->{i_icc}), $N));
    }' unless defined(&_GET_I_ACL_UID);
    eval 'sub _GET_I_ACL_GID {
        local($CIP, $N) = @_;
	    eval q( &_GET_ICC_ACL_GID(($CIP)-> ($i_icun->{i_icc}), $N));
    }' unless defined(&_GET_I_ACL_GID);
    eval 'sub _GET_I_ACL_MODE {
        local($CIP, $N) = @_;
	    eval q( &_GET_ICC_ACL_MODE(($CIP)-> ($i_icun->{i_icc}), $N));
    }' unless defined(&_GET_I_ACL_MODE);
    eval 'sub _SET_I_ACL_UID {
        local($CIP, $N, $UID) = @_;
	    eval q( &_SET_ICC_ACL_UID(($CIP)-> ($i_icun->{i_icc}), $N, $UID));
    }' unless defined(&_SET_I_ACL_UID);
    eval 'sub _SET_I_ACL_GID {
        local($CIP, $N, $GID) = @_;
	    eval q( &_SET_ICC_ACL_GID(($CIP)-> ($i_icun->{i_icc}), $N, $GID));
    }' unless defined(&_SET_I_ACL_GID);
    eval 'sub _SET_I_ACL_MODE {
        local($CIP, $N, $MODE) = @_;
	    eval q( &_SET_ICC_ACL_MODE(($CIP)-> ($i_icun->{i_icc}), $N, $MODE));
    }' unless defined(&_SET_I_ACL_MODE);
    eval 'sub MAKE_OLD_ID {
        local($ID) = @_;
	    eval q(((($ID) & 0xffff)));
    }' unless defined(&MAKE_OLD_ID);
    if(defined( &_KERNEL) || defined( &_FILE64) || defined( &_LARGEFILE64_SOURCE)) {
    } else {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub i_mode () { ($i_icun->{i_ic}->{ic_mode});}' unless defined(&i_mode);
    eval 'sub i_nlink () { ($i_icun->{i_ic}->{ic_nlink});}' unless defined(&i_nlink);
    eval 'sub i_uid_lsb () { ($i_icun->{i_ic}->{ic_uid_lsb});}' unless defined(&i_uid_lsb);
    eval 'sub i_gid_lsb () { ($i_icun->{i_ic}->{ic_gid_lsb});}' unless defined(&i_gid_lsb);
    eval 'sub i_uid_msb () { ($i_icun->{i_ic}->{ic_uid_msb});}' unless defined(&i_uid_msb);
    eval 'sub i_gid_msb () { ($i_icun->{i_ic}->{ic_gid_msb});}' unless defined(&i_gid_msb);
    if(defined( &_KERNEL) || defined( &_FILE64) || defined( &_LARGEFILE64_SOURCE)) {
	eval 'sub i_size () { ($i_icun->{i_ic}->{ic_size});}' unless defined(&i_size);
    } else {
	eval 'sub i_size () { ($i_icun->{i_ic}->{ic_size}->{val[1]});}' unless defined(&i_size);
    }
    eval 'sub i_db () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_db});}' unless defined(&i_db);
    eval 'sub i_ib () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_ib});}' unless defined(&i_ib);
    eval 'sub i_atime () { ($i_icun->{i_ic}->{ic_atime});}' unless defined(&i_atime);
    eval 'sub i_mtime () { ($i_icun->{i_ic}->{ic_mtime});}' unless defined(&i_mtime);
    eval 'sub i_ctime () { ($i_icun->{i_ic}->{ic_ctime});}' unless defined(&i_ctime);
    eval 'sub i_symlink () { ($i_icun->{i_ic}->{ic_un2}->{ic_symlink});}' unless defined(&i_symlink);
    eval 'sub i_flags () { ($i_icun->{i_ic}->{ic_flags});}' unless defined(&i_flags);
    eval 'sub i_blocks () { ($i_icun->{i_ic}->{ic_blocks});}' unless defined(&i_blocks);
    eval 'sub i_device () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_db[0]});}' unless defined(&i_device);
    eval 'sub i_gen () { ($i_icun->{i_ic}->{ic_gen});}' unless defined(&i_gen);
    eval 'sub i_lastr () { ($i_un->{if_lastr});}' unless defined(&i_lastr);
    eval 'sub i_socket () { ($i_un->{is_socket});}' unless defined(&i_socket);
    eval 'sub i_forw () { $i_chain[0];}' unless defined(&i_forw);
    eval 'sub i_back () { $i_chain[1];}' unless defined(&i_back);
    eval 'sub i_freef () { ($i_fr->{if_freef});}' unless defined(&i_freef);
    eval 'sub i_freeb () { ($i_fr->{if_freeb});}' unless defined(&i_freeb);
    eval 'sub i_frptr () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_fifo}->{if_frptr});}' unless defined(&i_frptr);
    eval 'sub i_fwptr () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_fifo}->{if_fwptr});}' unless defined(&i_fwptr);
    eval 'sub i_frcnt () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_fifo}->{if_frcnt});}' unless defined(&i_frcnt);
    eval 'sub i_fwcnt () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_fifo}->{if_fwcnt});}' unless defined(&i_fwcnt);
    eval 'sub i_fflag () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_fifo}->{if_fflag});}' unless defined(&i_fflag);
    eval 'sub i_fifosize () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_fifo}->{if_fifosize});}' unless defined(&i_fifosize);
    eval 'sub i_fifo () { ($i_icun->{i_ic}->{ic_un2}->{ic_reg}->{ic_un}->{ic_fifo});}' unless defined(&i_fifo);
    eval 'sub i_contin () { ($i_icun->{i_ic}->{ic_contin});}' unless defined(&i_contin);
    eval 'sub i_acl_lsb () { ($i_icun->{i_icc}->{icc_acl_lsb});}' unless defined(&i_acl_lsb);
    eval 'sub i_acl_msb () { ($i_icun->{i_icc}->{icc_acl_msb});}' unless defined(&i_acl_msb);
    eval 'sub i_ciflags () { ($i_icun->{i_icc}->{icc_ciflags});}' unless defined(&i_ciflags);
    if(defined(&_KERNEL)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../ufs/ino.ph';
	} else {
	    require 'sys/ino.ph';
	}
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub ILOCKED () {0x1;}' unless defined(&ILOCKED);
    eval 'sub ISHARED () {0x2;}' unless defined(&ISHARED);
    eval 'sub IPAUSED () {0x4;}' unless defined(&IPAUSED);
    eval 'sub IWANT () {0x10;}' unless defined(&IWANT);
    eval 'sub IUPD () {0x2;}' unless defined(&IUPD);
    eval 'sub IACC () {0x4;}' unless defined(&IACC);
    eval 'sub ITEXT () {0x20;}' unless defined(&ITEXT);
    eval 'sub ICHG () {0x40;}' unless defined(&ICHG);
    eval 'sub IREF () {0x400;}' unless defined(&IREF);
    eval 'sub IRENAME () {0x1000;}' unless defined(&IRENAME);
    eval 'sub IACLEXISTS () {0x2000;}' unless defined(&IACLEXISTS);
    eval 'sub IPURGED () {0x4000;}' unless defined(&IPURGED);
    eval 'sub ISYNCLOCKED () {0x10000;}' unless defined(&ISYNCLOCKED);
    eval 'sub ISYNC () {0x20000;}' unless defined(&ISYNC);
    eval 'sub IDUXMNT () {0x40000;}' unless defined(&IDUXMNT);
    eval 'sub ISYNCWANT () {0x80000;}' unless defined(&ISYNCWANT);
    eval 'sub IDUXMRT () {0x100000;}' unless defined(&IDUXMRT);
    eval 'sub IBUFVALID () {0x200000;}' unless defined(&IBUFVALID);
    eval 'sub IPAGEVALID () {0x400000;}' unless defined(&IPAGEVALID);
    eval 'sub IOPEN () {0x800000;}' unless defined(&IOPEN);
    eval 'sub IFRAG () {0x01000000;}' unless defined(&IFRAG);
    eval 'sub IHARD () {0x2000000;}' unless defined(&IHARD);
    eval 'sub INOFLUSH () {0x4000000;}' unless defined(&INOFLUSH);
    unless(defined(&IF_MI_DEV)) {
	eval 'sub IF_MI_DEV () {0x08000000;}' unless defined(&IF_MI_DEV);
    }
    eval 'sub IFRAGSYNC () {0x10000000;}' unless defined(&IFRAGSYNC);
    eval 'sub IFMT () {0170000;}' unless defined(&IFMT);
    eval 'sub IFIFO () {0010000;}' unless defined(&IFIFO);
    eval 'sub IFCHR () {0020000;}' unless defined(&IFCHR);
    eval 'sub IFDIR () {0040000;}' unless defined(&IFDIR);
    eval 'sub IFBLK () {0060000;}' unless defined(&IFBLK);
    eval 'sub IFCONT () {0070000;}' unless defined(&IFCONT);
    eval 'sub IFREG () {0100000;}' unless defined(&IFREG);
    eval 'sub IFNWK () {0110000;}' unless defined(&IFNWK);
    eval 'sub IFLNK () {0120000;}' unless defined(&IFLNK);
    eval 'sub IFSOCK () {0140000;}' unless defined(&IFSOCK);
    eval 'sub ISUID () {04000;}' unless defined(&ISUID);
    eval 'sub ISGID () {02000;}' unless defined(&ISGID);
    eval 'sub IENFMT () {02000;}' unless defined(&IENFMT);
    eval 'sub ISVTX () {01000;}' unless defined(&ISVTX);
    eval 'sub IREAD () {0400;}' unless defined(&IREAD);
    eval 'sub IWRITE () {0200;}' unless defined(&IWRITE);
    eval 'sub IEXEC () {0100;}' unless defined(&IEXEC);
    eval 'sub IFIR () {01;}' unless defined(&IFIR);
    eval 'sub IFIW () {02;}' unless defined(&IFIW);
    eval 'sub PIPSIZ () {8192;}' unless defined(&PIPSIZ);
    eval 'sub FSEL_COLL () {01;}' unless defined(&FSEL_COLL);
    if(defined(&_KERNEL)) {
	eval 'sub VTOI {
	    local($VP) = @_;
    	    eval q((($VP)-> &v_data));
	}' unless defined(&VTOI);
	eval 'sub ITOV {
	    local($IP) = @_;
    	    eval q((($IP)-> &i_vnode));
	}' unless defined(&ITOV);
	eval 'sub IFTOVT {
	    local($M) = @_;
    	    eval q((((($M) &IFMT) ==  &IFNWK)? &VFNWK:(((($M) &IFMT) ==  &IFIFO)? &VFIFO:( $iftovt_tab[((($M) &  &IFMT)) >> 13]))));
	}' unless defined(&IFTOVT);
	eval 'sub VTTOIF {
	    local($T) = @_;
    	    eval q(( $vttoif_tab[($T)]));
	}' unless defined(&VTTOIF);
	eval 'sub MAKEIMODE {
	    local($T, $M) = @_;
    	    eval q(( &VTTOIF($T) | ($M)));
	}' unless defined(&MAKEIMODE);
	eval 'sub ESAME () {(-1);}' unless defined(&ESAME);
	eval 'sub EREMOVE () {(-2);}' unless defined(&EREMOVE);
	eval 'sub ERENAME () {(-3);}' unless defined(&ERENAME);
	eval 'sub EPATHCONF_NONAME () {(-4);}' unless defined(&EPATHCONF_NONAME);
	eval 'sub OWNER_CR {
	    local($CR, $IP) = @_;
    	    eval q(((($CR)-> &cr_uid ==  &_GET_I_UID($IP)? 0: ( &suser()? 0:  ($u->{u_error})))));
	}' unless defined(&OWNER_CR);
	eval("sub DE_CREATE () { 0; }") unless defined(&DE_CREATE);
	eval("sub DE_LINK () { 1; }") unless defined(&DE_LINK);
	eval("sub DE_RENAME () { 2; }") unless defined(&DE_RENAME);
	eval 'sub ITID_ICS () {-3;}' unless defined(&ITID_ICS);
	eval 'sub ITID_UNOWNED () {-2;}' unless defined(&ITID_UNOWNED);
	eval 'sub ITID_SHARED () {-1;}' unless defined(&ITID_SHARED);
    }
}
1;
