require '_h2ph_pre.ph';

unless(defined(&NOERR)) {
    sub NOERR () {	0;}
}
unless(defined(&EPARAM)) {
    sub EPARAM () {	1;}
}
unless(defined(&ECOMB)) {
    sub ECOMB () {	2;}
}
unless(defined(&ETRANS)) {
    sub ETRANS () {	3;}
}
unless(defined(&EMASTER)) {
    sub EMASTER () {	4;}
}
unless(defined(&EDEVICE)) {
    sub EDEVICE () {	5;}
}
unless(defined(&EOFFOPEN)) {
    sub EOFFOPEN () {	6;}
}
unless(defined(&ESECONDOPEN)) {
    sub ESECONDOPEN () {	7;}
}
unless(defined(&EREIMOPEN)) {
    sub EREIMOPEN () {	8;}
}
unless(defined(&EDRIVER)) {
    sub EDRIVER () {	9;}
}
unless(defined(&EOFFON)) {
    sub EOFFON () {	10;}
}
unless(defined(&EDEVPRI)) {
    sub EDEVPRI () {	11;}
}
unless(defined(&EDEVSEC)) {
    sub EDEVSEC () {	12;}
}
unless(defined(&EDEVICES)) {
    sub EDEVICES () {	13;}
}
unless(defined(&EINMIRPRI)) {
    sub EINMIRPRI () {	14;}
}
unless(defined(&EINMIRSEC)) {
    sub EINMIRSEC () {	15;}
}
unless(defined(&EPRINOTON)) {
    sub EPRINOTON () {	16;}
}
unless(defined(&ESECNOTOFF)) {
    sub ESECNOTOFF () {	17;}
}
unless(defined(&ENOTABLE)) {
    sub ENOTABLE () {	18;}
}
unless(defined(&EROOTSWAP)) {
    sub EROOTSWAP () {	19;}
}
unless(defined(&ENOTMIRROR)) {
    sub ENOTMIRROR () {	20;}
}
unless(defined(&ENOTATOMIC)) {
    sub ENOTATOMIC () {	21;}
}
unless(defined(&ENOMIRRORLOG)) {
    sub ENOMIRRORLOG () {	22;}
}
unless(defined(&EREIMFAILED)) {
    sub EREIMFAILED () {	23;}
}
unless(defined(&FLAG_CLEAN)) {
    sub FLAG_CLEAN () {	1;}
}
unless(defined(&FLAG_BITMAP)) {
    sub FLAG_BITMAP () {	2;}
}
unless(defined(&FLAG_FAILURE)) {
    sub FLAG_FAILURE () {	4;}
}
unless(defined(&FLAG_CONFIG)) {
    sub FLAG_CONFIG () {	16;}
}
unless(defined(&FLAG_NOREIM)) {
    sub FLAG_NOREIM () {	32;}
}
unless(defined(&PRI_MI)) {
    sub PRI_MI () {	8;}
}
unless(defined(&SEC_MI)) {
    sub SEC_MI () {	64;}
}
unless(defined(&SSTATE)) {
    sub SSTATE () {	1;}
}
unless(defined(&GSTATE)) {
    sub GSTATE () {	2;}
}
unless(defined(&MSTATE)) {
    sub MSTATE () {	3;}
}
unless(defined(&STUNE)) {
    sub STUNE () {	4;}
}
unless(defined(&GTUNE)) {
    sub GTUNE () {	5;}
}
unless(defined(&MIR_UNCONFIG)) {
    sub MIR_UNCONFIG () {	0;}
}
unless(defined(&MIR_OFFLINE)) {
    sub MIR_OFFLINE () {	1;}
}
unless(defined(&MIR_REIMAGE)) {
    sub MIR_REIMAGE () {	2;}
}
unless(defined(&MIR_ONLINE)) {
    sub MIR_ONLINE () {	3;}
}
unless(defined(&STATE_PAIR)) {
    sub STATE_PAIR {
	local($ms,$ss) = @_;
	eval q((($ms << 2) | $ss));
    }
}
unless(defined(&PAIR_TO_P)) {
    sub PAIR_TO_P {
	local($pair) = @_;
	eval q(($pair >> 2));
    }
}
unless(defined(&PAIR_TO_S)) {
    sub PAIR_TO_S {
	local($pair) = @_;
	eval q(($pair & 3));
    }
}
unless(defined(&ON_ON)) {
    sub ON_ON () {	 &STATE_PAIR( &MIR_ONLINE,  &MIR_ONLINE);}
}
unless(defined(&ON_OFF)) {
    sub ON_OFF () {	 &STATE_PAIR( &MIR_ONLINE,  &MIR_OFFLINE);}
}
unless(defined(&OFF_ON)) {
    sub OFF_ON () {	 &STATE_PAIR( &MIR_OFFLINE,  &MIR_ONLINE);}
}
unless(defined(&ON_REIM)) {
    sub ON_REIM () {	 &STATE_PAIR( &MIR_ONLINE,  &MIR_REIMAGE);}
}
unless(defined(&REIM_ON)) {
    sub REIM_ON () {	 &STATE_PAIR( &MIR_REIMAGE,  &MIR_ONLINE);}
}
unless(defined(&UN_UN)) {
    sub UN_UN () {	 &STATE_PAIR( &MIR_UNCONFIG,  &MIR_UNCONFIG);}
}
unless(defined(&INV_MR)) {
    sub INV_MR () {	-1;}
}
unless(defined(&_IOWRM)) {
    sub _IOWRM {
	local($x,$y) = @_;
	eval q(( &IOC_INOUT | ($x << 8) | $y));
    }
}
unless(defined(&CIOC_MIRROR)) {
    sub CIOC_MIRROR () {	 &_IOWRM(ord('d'),32);}
}
unless(defined(&DEV_REIMAGE_MASK)) {
    sub DEV_REIMAGE_MASK () {	0x400000;}
}
unless(defined(&DEV_BACKUP_MASK)) {
    sub DEV_BACKUP_MASK () {	0x200000;}
}
unless(defined(&MIRCONFIG_MAJ)) {
    sub MIRCONFIG_MAJ () {	48;}
}
unless(defined(&MIRCONFIG_MIN)) {
    sub MIRCONFIG_MIN () {	0;}
}
unless(defined(&MAX_PAIRCOUNT)) {
    sub MAX_PAIRCOUNT () {	900;}
}
unless(defined(&mir_state_size)) {
    sub mir_state_size {
	local($pairs) = @_;
	eval q(($sizeof{'struct mir_state'} + (($pairs)-1)*$sizeof{'struct pair'}));
    }
}
1;
