require '_h2ph_pre.ph';

unless(defined(&_SYS_MP_INCLUDED)) {
    eval 'sub _SYS_MP_INCLUDED () {1;}' unless defined(&_SYS_MP_INCLUDED);
    unless(defined(&_SYS_TYPES_INCLUDED)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/types.ph';
	} else {
	    require 'sys/types.ph';
	}
    }
    if(defined(&_KERNEL_BUILD)) {
	require '../machine/mp.ph';
	require '../h/assert.ph';
	require '../h/vmmeter.ph';
	require '../h/netstatistic.ph';
	require '../h/spinlock.ph';
	require '../h/ki_calls.ph';
	require '../h/mpctl.ph';
    } else {
	require 'machine/mp.ph';
	require 'sys/vmmeter.ph';
	require 'sys/netstatistic.ph';
	require 'sys/spinlock.ph';
	require 'sys/ki_calls.ph';
	require 'sys/mpctl.ph';
    }
    if(defined(&_KERNEL)) {
	eval 'sub FAST_PROT_ENTRIES () {128;}' unless defined(&FAST_PROT_ENTRIES);
	unless(defined(&LOCORE)) {
	}
	eval 'sub NQS () {160;}' unless defined(&NQS);
	eval 'sub MPCNTR {
	    local($arg) = @_;
    	    eval q(((  &GETPPDP($arg))-> &mpcntrs));
	}' unless defined(&MPCNTR);
	eval 'sub CNTR {
	    local($arg) = @_;
    	    eval q(((  &GETPPDP($arg))-> &cnt));
	}' unless defined(&CNTR);
	eval 'sub NO_IVA_PER_PROC_DATA () {1;}' unless defined(&NO_IVA_PER_PROC_DATA);
	eval 'sub DYNAMIC_MPINFO () {1;}' unless defined(&DYNAMIC_MPINFO);
	if(!defined( &__STDC_32_MODE__)) {
	} else {
	}
	if(defined(&__BTT)) {
	}
	eval 'sub RUNQ_LOCK_FOR_SPU {
	    local($spu) = @_;
    	    eval q(( ($mpproc_info[$spu]->{mp_rq}->{run_queue_lock})));
	}' unless defined(&RUNQ_LOCK_FOR_SPU);
	eval 'sub MY_RUNQ_LOCK {
	    local($t) = @_;
    	    eval q((((($t)-> &kt_schedpolicy ==  &SCHED_TIMESHARE) || (($t)-> &kt_schedpolicy ==  &SCHED_RTPRIO)) ?  &RUNQ_LOCK_FOR_SPU(($t)-> &kt_spu) :  ($r$tsched_info->{r$ts_lock})));
	}' unless defined(&MY_RUNQ_LOCK);
	eval 'sub MP_RUNQ_LOCK {
	    local($T, $LOCKPP) = @_;
    	    eval q( &MP_SPINLOCK((*($LOCKPP) =  &MY_RUNQ_LOCK($T))));
	}' unless defined(&MP_RUNQ_LOCK);
	eval 'sub runq_lock {
	    local($T, $LOCKPP) = @_;
    	    eval q( &spinlock((*($LOCKPP) =  &MY_RUNQ_LOCK($T))));
	}' unless defined(&runq_lock);
	eval 'sub MP_RUNQ_LOCK_USAV {
	    local($T, $LOCKPP, $CONTEXT) = @_;
    	    eval q( &MP_SPINLOCK_USAV((*($LOCKPP) =  &MY_RUNQ_LOCK($T)), ($CONTEXT)));
	}' unless defined(&MP_RUNQ_LOCK_USAV);
	eval 'sub SETCURPRI {
	    local($pri, $reg_temp) = @_;
    	    eval q({ &_MFCTL( &CR_PPDP, $reg_temp); (($reg_temp))-> &iva_curpri=$pri; });
	}' unless defined(&SETCURPRI);
	eval 'sub GETCURPRI {
	    local($reg_temp) = @_;
    	    eval q(( &_MFCTL( &CR_PPDP, $reg_temp), (($reg_temp))-> &iva_curpri));
	}' unless defined(&GETCURPRI);
	eval 'sub GETPROCINDEX {
	    local($reg_temp) = @_;
    	    eval q(( &_MFCTL( &CR_PPDP, $reg_temp), ($reg_temp)-> &procindex));
	}' unless defined(&GETPROCINDEX);
	eval 'sub GETNOKTHREAD {
	    local($reg_temp) = @_;
    	    eval q(( &_MFCTL( &CR_PPDP, $reg_temp), ($reg_temp)-> &iva_nothread));
	}' unless defined(&GETNOKTHREAD);
	eval 'sub SETNOKTHREAD {
	    local($thread, $reg_temp) = @_;
    	    eval q({ &_MFCTL( &CR_PPDP, $reg_temp); ($reg_temp)-> &iva_nothread=$thread; });
	}' unless defined(&SETNOKTHREAD);
	eval 'sub GETTHREADP {
	    local($reg_temp) = @_;
    	    eval q(( &_MFCTL( &CR_PPDP, $reg_temp), (($reg_temp))-> &threadp));
	}' unless defined(&GETTHREADP);
	eval 'sub SETTHREADP {
	    local($thread, $reg_temp) = @_;
    	    eval q({ &_MFCTL( &CR_PPDP, $reg_temp); ($reg_temp)-> &threadp=$thread; });
	}' unless defined(&SETTHREADP);
	eval 'sub GETTSDP {
	    local($reg_temp) = @_;
    	    eval q(( &_MFCTL( &CR_PPDP, $reg_temp), (($reg_temp))-> &tsdp));
	}' unless defined(&GETTSDP);
	eval 'sub SETTSDP {
	    local($threaddp, $reg_temp) = @_;
    	    eval q({ &_MFCTL( &CR_PPDP, $reg_temp); ($reg_temp)-> &tsdp=$threaddp; });
	}' unless defined(&SETTSDP);
	eval 'sub GETPPDP {
	    local($reg_temp) = @_;
    	    eval q(( &_MFCTL( &CR_PPDP, $reg_temp), $reg_temp));
	}' unless defined(&GETPPDP);
	eval 'sub GETMP_ID {
	    local($reg_temp) = @_;
    	    eval q( &GETPPDP($reg_temp));
	}' unless defined(&GETMP_ID);
	eval 'sub GETUSID {
	    local($reg_temp) = @_;
    	    eval q(( &_MFCTL( &CR_PPDP, $reg_temp), (($reg_temp))-> &uareasid));
	}' unless defined(&GETUSID);
	eval 'sub SETUSID {
	    local($usid, $reg_temp) = @_;
    	    eval q({ &_MFCTL( &CR_PPDP, $reg_temp); ($reg_temp)-> &uareasid=$usid; });
	}' unless defined(&SETUSID);
	eval 'sub ISTACKPTR () { &getistackptr();}' unless defined(&ISTACKPTR);
	eval 'sub getmp_id () {
	    eval q( &getppdp());
	}' unless defined(&getmp_id);
	eval 'sub getppdp_data () {
	    eval q( &getppdp());
	}' unless defined(&getppdp_data);
	eval 'sub MP_MONARCH_INDEX () {0;}' unless defined(&MP_MONARCH_INDEX);
	eval 'sub get_monarch_hpa () {
	    eval q(( ($mpproc_info[&MP_MONARCH_INDEX]->{prochpa})));
	}' unless defined(&get_monarch_hpa);
	eval 'sub get_my_hpa () {
	    eval q(( &getproc_info()-> &prochpa));
	}' unless defined(&get_my_hpa);
	eval 'sub ON_ICS () {( &ISTACKPTR == 0);}' unless defined(&ON_ICS);
	eval 'sub IN_PROCESS_CONTEXT () {(! &getnoproc()  && ! &ON_ICS);}' unless defined(&IN_PROCESS_CONTEXT);
	eval 'sub SET_RUNRUN {
	    local($t) = @_;
    	    eval q(( ($mpproc_info[(t)->{k$t_spu]}->{runrun}->{s}->{advisory})=1));
	}' unless defined(&SET_RUNRUN);
    }
    unless(defined(&_KERNEL)) {
	eval 'sub GETNUMSPUS () {
	    eval q( &syscall( &SYS_MPCTL,  &MPC_GETNUMSPUS));
	}' unless defined(&GETNUMSPUS);
	eval 'sub GETFIRSTSPU () {
	    eval q( &syscall( &SYS_MPCTL,  &MPC_GETFIRSTSPU));
	}' unless defined(&GETFIRSTSPU);
	eval 'sub GETNEXTSPU {
	    local($spu) = @_;
    	    eval q( &syscall( &SYS_MPCTL,  &MPC_GETNEXTSPU, $spu));
	}' unless defined(&GETNEXTSPU);
	eval 'sub GETCURRENTSPU () {
	    eval q( &syscall( &SYS_MPCTL,  &MPC_GETCURRENTSPU));
	}' unless defined(&GETCURRENTSPU);
	eval 'sub SETPROCESS {
	    local($sgid, $pid) = @_;
    	    eval q( &syscall( &SYS_MPCTL,  &MPC_SETPROCESS, $sgid, $pid));
	}' unless defined(&SETPROCESS);
    }
}
1;
