require '_h2ph_pre.ph';

unless(defined(&_SYS_PARAM_INCLUDED)) {
    eval 'sub _SYS_PARAM_INCLUDED () {1;}' unless defined(&_SYS_PARAM_INCLUDED);
    unless(defined(&_SYS_STDSYMS_INCLUDED)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/stdsyms.ph';
	} else {
	    require 'sys/stdsyms.ph';
	}
    }
    if(defined(&_KERNEL_BUILD)) {
	unless(defined(&LOCORE)) {
	    require '../h/types.ph';
	}
	require '../machine/param.ph';
	require '../h/time.ph';
	require '../machine/spl.ph';
    } else {
	require 'sys/types.ph';
	require 'machine/param.ph';
	require 'sys/time.ph';
	require 'machine/spl.ph';
    }
    eval 'sub led0 () {0x01;}' unless defined(&led0);
    eval 'sub led1 () {0x02;}' unless defined(&led1);
    eval 'sub led2 () {0x04;}' unless defined(&led2);
    eval 'sub led3 () {0x08;}' unless defined(&led3);
    eval 'sub KERN_OK_LED () {0x10;}' unless defined(&KERN_OK_LED);
    eval 'sub DISK_DRV_LED () {0x20;}' unless defined(&DISK_DRV_LED);
    eval 'sub LAN_RCV_LED () {0x40;}' unless defined(&LAN_RCV_LED);
    eval 'sub LAN_XMIT_LED () {0x80;}' unless defined(&LAN_XMIT_LED);
    eval 'sub MAXINT () {0x7fffffff;}' unless defined(&MAXINT);
    unless(defined(&KERNELSPACE)) {
	eval 'sub KERNELSPACE () {0;}' unless defined(&KERNELSPACE);
    }
    eval 'sub MAXCOMLEN () {14;}' unless defined(&MAXCOMLEN);
    eval 'sub NOFILE () {60;}' unless defined(&NOFILE);
    eval 'sub TWO_GIG () {2147483648;}' unless defined(&TWO_GIG);
    eval 'sub MAX_SMALL_FILE_BITS () {32;}' unless defined(&MAX_SMALL_FILE_BITS);
    eval 'sub MAX_LARGE_FILE_BITS () {42;}' unless defined(&MAX_LARGE_FILE_BITS);
    eval 'sub MAX_SMALL_FILE () {0x7fffffff;}' unless defined(&MAX_SMALL_FILE);
    eval 'sub MAX_LARGE_FILE () {0xffffffffff;}' unless defined(&MAX_LARGE_FILE);
    if(defined( &_LARGEFILE64_SOURCE) || defined( &_KERNEL)) {
	eval 'sub MAX_LOCK32_SIZE () {( &MAX_SMALL_FILE + 1);}' unless defined(&MAX_LOCK32_SIZE);
	eval 'sub MAX_LOCK64_SIZE () {( &MAX_LARGE_FILE + 1);}' unless defined(&MAX_LOCK64_SIZE);
    }
    if(!defined( &_KERNEL)) {
	if(defined( &_FILE64)) {
	    eval 'sub MAX_LOCK_SIZE () {( &MAX_LARGE_FILE+1);}' unless defined(&MAX_LOCK_SIZE);
	} else {
	    eval 'sub MAX_LOCK_SIZE () {( &MAX_SMALL_FILE+1);}' unless defined(&MAX_LOCK_SIZE);
	}
    }
    eval 'sub MAXPID () {30000;}' unless defined(&MAXPID);
    eval 'sub MAXTID () {30000;}' unless defined(&MAXTID);
    eval 'sub MAXUID () { &MAXINT;}' unless defined(&MAXUID);
    eval 'sub OLD_MAXUID () {60000;}' unless defined(&OLD_MAXUID);
    unless(defined(&UID_NOBODY)) {
	eval 'sub UID_NOBODY () {-2;}' unless defined(&UID_NOBODY);
    }
    eval 'sub OLD_UID_NOBODY () {65534;}' unless defined(&OLD_UID_NOBODY);
    eval 'sub MAXLINK () {0x7fff;}' unless defined(&MAXLINK);
    unless(defined(&MAX_CNODE)) {
	eval 'sub MAX_CNODE () {255;}' unless defined(&MAX_CNODE);
    }
    eval 'sub MAXHOSTNAMELEN () {64;}' unless defined(&MAXHOSTNAMELEN);
    if((defined(&NBPG) ? &NBPG : 0)==4096) {
	eval 'sub SSIZE () {2;}' unless defined(&SSIZE);
	eval 'sub SINCR () {2;}' unless defined(&SINCR);
    } else {
	eval 'sub SSIZE () {4;}' unless defined(&SSIZE);
	eval 'sub SINCR () {4;}' unless defined(&SINCR);
    }
    eval 'sub UAREA () {0x7ffe6000;}' unless defined(&UAREA);
    eval 'sub KSTACKADDR () {( &UAREA+$sizeof{\'struct user\'}-$sizeof{ &double});}' unless defined(&KSTACKADDR);
    eval 'sub TOPKSTACK () {( &UAREA+ &UPAGES* &NBPG);}' unless defined(&TOPKSTACK);
    eval 'sub USRSTACK () {0x7b03a000;}' unless defined(&USRSTACK);
    eval 'sub USRSTACKMAX () { &UAREA;}' unless defined(&USRSTACKMAX);
    eval 'sub CANBSIZ () {256;}' unless defined(&CANBSIZ);
    eval 'sub HZ () { &CLK_TCK;}' unless defined(&HZ);
    if(defined(&_INCLUDE_XOPEN_SOURCE_EXTENDED)) {
	if(!defined( &_KERNEL)  && defined ( &_XPG4_EXTENDED)) {
	    eval 'sub MAX_ALARM () {((0x7fffffff /  &HZ));}' unless defined(&MAX_ALARM);
	    eval 'sub MAX_VTALARM () {((0x7fffffff));}' unless defined(&MAX_VTALARM);
	    eval 'sub MAX_PROF () {((0x7fffffff));}' unless defined(&MAX_PROF);
	} else {
	    eval 'sub MAX_ALARM () {((0x7fffffff /  &HZ));}' unless defined(&MAX_ALARM);
	    eval 'sub MAX_VTALARM () {(0x7fffffff);}' unless defined(&MAX_VTALARM);
	    eval 'sub MAX_PROF () {(0x7fffffff);}' unless defined(&MAX_PROF);
	}
    }
    eval 'sub MAX_VT_ALARM () {( &MAX_VTALARM);}' unless defined(&MAX_VT_ALARM);
    if(defined(&_KERNEL)) {
	eval 'sub USEC_PER_CLK_TCK () {(1000000/ &HZ);}' unless defined(&USEC_PER_CLK_TCK);
    }
    eval 'sub NCARGS () {20480;}' unless defined(&NCARGS);
    eval 'sub PMASK () {0xffff;}' unless defined(&PMASK);
    eval 'sub PCATCH () {0x10000;}' unless defined(&PCATCH);
    eval 'sub PRTSCHEDBASE () {0;}' unless defined(&PRTSCHEDBASE);
    eval 'sub MAX_RTSCHED_PRI () {512;}' unless defined(&MAX_RTSCHED_PRI);
    eval 'sub PRTBASE () {( &PRTSCHEDBASE +  &MAX_RTSCHED_PRI);}' unless defined(&PRTBASE);
    eval 'sub PTIMESHARE () {( &PRTBASE + 128);}' unless defined(&PTIMESHARE);
    eval 'sub PSWP () {(0+ &PTIMESHARE);}' unless defined(&PSWP);
    eval 'sub PMEM () {(0+ &PTIMESHARE);}' unless defined(&PMEM);
    eval 'sub PRIRWLOCK () {(5+ &PTIMESHARE);}' unless defined(&PRIRWLOCK);
    eval 'sub PRIBETA () {(6+ &PTIMESHARE);}' unless defined(&PRIBETA);
    eval 'sub PRIALPHA () {(7+ &PTIMESHARE);}' unless defined(&PRIALPHA);
    eval 'sub PRISYNC () {(8+ &PTIMESHARE);}' unless defined(&PRISYNC);
    eval 'sub PINOD () {(10+ &PTIMESHARE);}' unless defined(&PINOD);
    eval 'sub PRIBIO () {(20+ &PTIMESHARE);}' unless defined(&PRIBIO);
    eval 'sub PRIUBA () {(24+ &PTIMESHARE);}' unless defined(&PRIUBA);
    eval 'sub PLLIO () {(24+ &PTIMESHARE);}' unless defined(&PLLIO);
    eval 'sub PZERO () {(25+ &PTIMESHARE);}' unless defined(&PZERO);
    eval 'sub IPCPRI () {(25+ &PTIMESHARE);}' unless defined(&IPCPRI);
    eval 'sub PPIPE () {(26+ &PTIMESHARE);}' unless defined(&PPIPE);
    eval 'sub PVFS () {(27+ &PTIMESHARE);}' unless defined(&PVFS);
    eval 'sub PWAIT () {(30+ &PTIMESHARE);}' unless defined(&PWAIT);
    eval 'sub PLOCK () {(35+ &PTIMESHARE);}' unless defined(&PLOCK);
    eval 'sub PSLEP () {(40+ &PTIMESHARE);}' unless defined(&PSLEP);
    eval 'sub PUSER () {(50+ &PTIMESHARE);}' unless defined(&PUSER);
    eval 'sub PMAX_TIMESHARE () {(127+ &PTIMESHARE);}' unless defined(&PMAX_TIMESHARE);
    eval 'sub PNOT_REALTIME () {(0x7fff);}' unless defined(&PNOT_REALTIME);
    eval 'sub NZERO () {20;}' unless defined(&NZERO);
    eval 'sub MAXNICE () {(2*  &NZERO - 1);}' unless defined(&MAXNICE);
    eval 'sub MINNICE () {0;}' unless defined(&MINNICE);
    eval 'sub NBPW () {$sizeof{\'int\'};}' unless defined(&NBPW);
    eval 'sub NBTSPW () {( &NBBY* &NBPW);}' unless defined(&NBTSPW);
    eval 'sub BSIZE () { &DEV_BSIZE;}' unless defined(&BSIZE);
    eval 'sub BSHIFT () { &DEV_BSHIFT;}' unless defined(&BSHIFT);
    eval 'sub NINDIR {
        local($fs) = @_;
	    eval q((($fs)-> &fs_nindir));
    }' unless defined(&NINDIR);
    eval 'sub INOPB {
        local($fs) = @_;
	    eval q((($fs)-> &fs_inopb));
    }' unless defined(&INOPB);
    eval 'sub INOPF {
        local($fs) = @_;
	    eval q((($fs)-> &fs_inopb >> ($fs)-> &fs_fragshift));
    }' unless defined(&INOPF);
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    eval 'sub CMASK () {0;}' unless defined(&CMASK);
    eval 'sub CDLIMIT () {0x1fffffff;}' unless defined(&CDLIMIT);
    eval 'sub NODEV () {(-1);}' unless defined(&NODEV);
    eval 'sub SWDEF () {(-2);}' unless defined(&SWDEF);
    eval 'sub ROOTINO () {(2);}' unless defined(&ROOTINO);
    eval 'sub LOSTFOUNDINO () {( &ROOTINO + 1);}' unless defined(&LOSTFOUNDINO);
    eval 'sub PC_PRIV_MASK () {3;}' unless defined(&PC_PRIV_MASK);
    eval 'sub PC_PRIV_KERN () {0;}' unless defined(&PC_PRIV_KERN);
    eval 'sub PC_PRIV_USER () {3;}' unless defined(&PC_PRIV_USER);
    eval 'sub USERMODE {
        local($pc) = @_;
	    eval q(((($pc) &  &PC_PRIV_MASK) !=  &PC_PRIV_KERN));
    }' unless defined(&USERMODE);
    eval 'sub lobyte {
        local($X) = @_;
	    eval q((($X)[1]));
    }' unless defined(&lobyte);
    eval 'sub hibyte {
        local($X) = @_;
	    eval q((($X)[0]));
    }' unless defined(&hibyte);
    eval 'sub loword {
        local($X) = @_;
	    eval q((($X)[1]));
    }' unless defined(&loword);
    eval 'sub hiword {
        local($X) = @_;
	    eval q((($X)[0]));
    }' unless defined(&hiword);
    eval 'sub NGROUPS () {20;}' unless defined(&NGROUPS);
    eval 'sub NOGROUP () {(( &gid_t) -1);}' unless defined(&NOGROUP);
    if(defined(&_KERNEL)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/signal.ph';
	} else {
	    require 'sys/signal.ph';
	}
    }
    eval 'sub ISSIG_MP {
        local($t) = @_;
	    eval q(((($t)-> &kt_cursig) || ((! &ksigisempty(($t)-> &kt_sig))  && (($t)-> ($k$t_procp->{p_flag})& &STRC || ( &ksigxsectinv(($t)-> &kt_sig, ($t)-> &kt_sigmask))) ));
    }' unless defined(&ISSIG_MP);
    eval 'sub ISSIG_SLEEP {
        local($t,$ret) = @_;
	    eval q(((( ($t->{k$t_suspendcnt})) || ((! &ksigisempty(($t)-> &kt_sig))  && (($t)-> ($k$t_procp->{p_flag})& &STRC || ( &ksigxsectinv(($t)-> &kt_sig, ($t)-> &kt_sigmask)))))  && ( &thread_unlock($t), $ret =  &issig( &KT_NOT_CLEAN_PT),  &thread_lock($t),$ret) ));
    }' unless defined(&ISSIG_SLEEP);
    eval 'sub ISSIG {
        local($t) = @_;
	    eval q((( ($t->{k$t_suspendcnt}) || (!( &ksigisempty(($t)-> &kt_sig))  && (($t)-> ($k$t_procp->{p_flag})& &STRC || ( &ksigxsectinv(($t)-> &kt_sig,($t)-> &kt_sigmask)))))  &&  &issig( &KT_NOT_CLEAN_PT) ));
    }' unless defined(&ISSIG);
    unless(defined(&NBBY)) {
	eval 'sub NBBY () {8;}' unless defined(&NBBY);
    }
    eval 'sub MAXBSIZE () {65536;}' unless defined(&MAXBSIZE);
    unless(defined(&DEV_BSIZE)) {
	eval 'sub DEV_BSIZE () {1024;}' unless defined(&DEV_BSIZE);
	eval 'sub DEV_BSHIFT () {10;}' unless defined(&DEV_BSHIFT);
	eval 'sub DEV_BMASK () {( &DEV_BSIZE-1);}' unless defined(&DEV_BMASK);
    }
    eval 'sub BLKDEV_IOSIZE () {2048;}' unless defined(&BLKDEV_IOSIZE);
    eval 'sub BLKDEV_IOSHIFT () {11;}' unless defined(&BLKDEV_IOSHIFT);
    eval 'sub BLKDEV_IOMASK () {( &BLKDEV_IOSIZE-1);}' unless defined(&BLKDEV_IOMASK);
    if(!defined( &__STDC_32_MODE__)) {
	eval 'sub btodb {
	    local($bytes) = @_;
    	    eval q(( &sizeof ==  &sizeof? ( >>  &DEV_BSHIFT): (($bytes) >>  &DEV_BSHIFT)));
	}' unless defined(&btodb);
    } else {
	eval 'sub btodb {
	    local($bytes) = @_;
    	    eval q((($bytes) >>  &DEV_BSHIFT));
	}' unless defined(&btodb);
    }
    eval 'sub dbtob {
        local($db) = @_;
	    eval q((($db) <<  &DEV_BSHIFT));
    }' unless defined(&dbtob);
    if(!defined( &_KERNEL)) {
	if(defined(&_FILE64)) {
	    eval 'sub dbtoo {
	        local($db) = @_;
    		eval q((($db) <<  &DEV_BSHIFT));
	    }' unless defined(&dbtoo);
	} else {
	    eval 'sub dbtoo {
	        local($db) = @_;
    		eval q((($db) <<  &DEV_BSHIFT));
	    }' unless defined(&dbtoo);
	}
    }
    eval 'sub btodbup {
        local($bytes) = @_;
	    eval q(((($bytes) + ( &DEV_BSIZE-1)) >>  &DEV_BSHIFT));
    }' unless defined(&btodbup);
    eval 'sub bdbtofsb {
        local($bn) = @_;
	    eval q((($bn) / ( &BLKDEV_IOSIZE/ &DEV_BSIZE)));
    }' unless defined(&bdbtofsb);
    eval 'sub MAXPATHLEN () {1024;}' unless defined(&MAXPATHLEN);
    eval 'sub MAXSYMLINKS () {20;}' unless defined(&MAXSYMLINKS);
    eval 'sub setbit {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] |= 1<<(($i)% &NBBY)));
    }' unless defined(&setbit);
    eval 'sub clrbit {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] &= ~(1<<(($i)% &NBBY))));
    }' unless defined(&clrbit);
    eval 'sub isset {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))));
    }' unless defined(&isset);
    eval 'sub isclr {
        local($a,$i) = @_;
	    eval q(((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))) == 0));
    }' unless defined(&isclr);
    eval 'sub wsetbit {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBTSPW] |= 1<<(($i)% &NBTSPW)));
    }' unless defined(&wsetbit);
    eval 'sub wclrbit {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBTSPW] &= ~(1<<(($i)% &NBTSPW))));
    }' unless defined(&wclrbit);
    eval 'sub wisset {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBTSPW] & (1<<(($i)% &NBTSPW))));
    }' unless defined(&wisset);
    eval 'sub wisclr {
        local($a,$i) = @_;
	    eval q(((($a)[($i)/ &NBTSPW] & (1<<(($i)% &NBTSPW))) == 0));
    }' unless defined(&wisclr);
    eval 'sub MIN {
        local($a,$b) = @_;
	    eval q(((($a)<($b))?($a):($b)));
    }' unless defined(&MIN);
    eval 'sub MAX {
        local($a,$b) = @_;
	    eval q(((($a)>($b))?($a):($b)));
    }' unless defined(&MAX);
    eval 'sub howmany {
        local($x, $y) = @_;
	    eval q(((($x)+(($y)-1))/($y)));
    }' unless defined(&howmany);
    eval 'sub roundup {
        local($x, $y) = @_;
	    eval q((((($x)+(($y)-1))/($y))*($y)));
    }' unless defined(&roundup);
    if(defined(&_UNSUPPORTED)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/_param.ph';
	} else {
	    require '.unsupp/sys/_param.ph';
	}
    }
}
1;
