require '_h2ph_pre.ph';

if(defined(&_KERNEL_BUILD)) {
    require '../h/kmetric.ph';
    require '../h/sem_beta.ph';
    require '../h/spinlock.ph';
}
unless(defined(&CRIT)) {
    sub CRIT () {
	eval q( &panic(\"No SCSI CRIT/UNCRIT\"));
    }
}
unless(defined(&UNCRIT)) {
    sub UNCRIT () {
	eval q( &panic(\"No SCSI CRIT/UNCRIT\"));
    }
}
unless(defined(&_SCSI_CTL_INCLUDED)) {
    eval 'sub _SCSI_CTL_INCLUDED () {1;}' unless defined(&_SCSI_CTL_INCLUDED);
    eval 'sub STINGRAY {
        local($lp) = @_;
	    eval q(( &strncmp(($lp)-> ($inquiry_data->{inq2}->{vendor_id}), \\"HP      \\", 8) == 0 && ( &strncmp(($lp)-> ($inquiry_data->{inq2}->{product_id}), \\"C2425D\\", 6) == 0||  &strncmp(($lp)-> ($inquiry_data->{inq2}->{product_id}), \\"C2430D\\", 6) == 0)));
    }' unless defined(&STINGRAY);
    eval 'sub NIKE {
        local($lp) = @_;
	    eval q(( &strncmp(($lp)-> ($inquiry_data->{inq2}->{vendor_id}), \\"DGC     \\", 8) == 0 && ( &strncmp(($lp)-> ($inquiry_data->{inq2}->{product_id}), \\"C1300\\", 5) == 0||  &strncmp(($lp)-> ($inquiry_data->{inq2}->{product_id}), \\"C2300\\", 5) == 0)));
    }' unless defined(&NIKE);
    eval 'sub ICE {
        local($lp) = @_;
	    eval q(( &strncmp(($lp)-> ($inquiry_data->{inq2}->{vendor_id}), \\"HP      \\", 8) == 0 &&  &strncmp(($lp)-> ($inquiry_data->{inq2}->{product_id}), \\"C3586A\\", 6) == 0));
    }' unless defined(&ICE);
    eval 'sub SCSI_MAXPHYS () {(1024* 1024);}' unless defined(&SCSI_MAXPHYS);
    eval 'sub SCSI_MAX_BUS_ID () {0xff;}' unless defined(&SCSI_MAX_BUS_ID);
    eval 'sub m_bus_id {
        local($dev) = @_;
	    eval q(( &m_instance($dev)));
    }' unless defined(&m_bus_id);
    if(defined(&__hp9000s300)) {
	eval 'sub m_bus_id {
	    local($dev) = @_;
    	    eval q(( &m_selcode($dev)));
	}' unless defined(&m_bus_id);
    }
    eval 'sub m_tgt_id {
        local($dev) = @_;
	    eval q((($dev)>>12&0xf));
    }' unless defined(&m_tgt_id);
    eval 'sub m_lun_id {
        local($dev) = @_;
	    eval q((($dev)>>8&0xf));
    }' unless defined(&m_lun_id);
    eval 'sub SCSI_MAX_TGT_ID () {0x0f;}' unless defined(&SCSI_MAX_TGT_ID);
    eval 'sub SCSI_MAX_LUN_ID () {0x07;}' unless defined(&SCSI_MAX_LUN_ID);
    eval 'sub scsi_lock_t () { &lock_t;}' unless defined(&scsi_lock_t);
    eval 'sub scsi_sv_lock_t () { &sv_lock_t;}' unless defined(&scsi_sv_lock_t);
    eval 'sub ASSERT {
        local($EX) = @_;
	    eval q( &if (!($EX))  &assfail(\\"EX\\",  &__FILE__,  &__LINE__));
    }' unless defined(&ASSERT);
    eval 'sub DB_ASSERT {
        local($EX) = @_;
	    eval q();
    }' unless defined(&DB_ASSERT);
    eval 'sub DB_STMT {
        local($STMT) = @_;
	    eval q();
    }' unless defined(&DB_STMT);
    eval 'sub BPB () {8;}' unless defined(&BPB);
    eval 'sub PT_OKAY () {1;}' unless defined(&PT_OKAY);
    eval 'sub B_SIOC_IO () {( &B_SCRACH6);}' unless defined(&B_SIOC_IO);
    eval 'sub B_SCSI_CMD () {( &B_SCRACH5);}' unless defined(&B_SCSI_CMD);
    eval 'sub B_SPECIAL () {( &B_SIOC_IO |  &B_SCSI_CMD);}' unless defined(&B_SPECIAL);
    eval 'sub SCSI_MAX_CDB_LEN () {24;}' unless defined(&SCSI_MAX_CDB_LEN);
    eval 'sub SCB_READ () { &SCTL_READ;}' unless defined(&SCB_READ);
    eval 'sub SCB_NO_DISC () { &SCTL_NO_DISC;}' unless defined(&SCB_NO_DISC);
    eval 'sub SCB_NO_ATN () { &SCTL_NO_DISC;}' unless defined(&SCB_NO_ATN);
    eval 'sub SCB_SDTR () { &SCTL_INIT_SDTR;}' unless defined(&SCB_SDTR);
    eval 'sub SCB_WDTR () { &SCTL_INIT_WDTR;}' unless defined(&SCB_WDTR);
    eval 'sub SCB_4BYTE () { &SCTL_4BYTE;}' unless defined(&SCB_4BYTE);
    eval 'sub SCB_2BYTE () { &SCTL_2BYTE;}' unless defined(&SCB_2BYTE);
    eval 'sub SCB_LOGGED () {0x08000000;}' unless defined(&SCB_LOGGED);
    eval 'sub SCB_LOG_ERROR () {0x20000000;}' unless defined(&SCB_LOG_ERROR);
    eval 'sub SCB_ORDERED_TAG () {0x40000000;}' unless defined(&SCB_ORDERED_TAG);
    eval 'sub SCB_DONT_PRINT () {0x80000000;}' unless defined(&SCB_DONT_PRINT);
    eval 'sub SCTL_IO_ID () {0;}' unless defined(&SCTL_IO_ID);
    eval 'sub SCTL_MAX_RETRIES () {1;}' unless defined(&SCTL_MAX_RETRIES);
    eval 'sub SCTL_STATUS_ACTION () {2;}' unless defined(&SCTL_STATUS_ACTION);
    eval 'sub SCTL_STATUS_CNT () {3;}' unless defined(&SCTL_STATUS_CNT);
    eval 'sub b_scb () { &b_s2;}' unless defined(&b_scb);
    eval 'sub b_state () { &b_s3;}' unless defined(&b_state);
    eval 'sub b_dd0 () { &b_s7;}' unless defined(&b_dd0);
    eval 'sub b_dd1 () { &b_s8;}' unless defined(&b_dd1);
    eval 'sub BS_SCB_Q () {0x01;}' unless defined(&BS_SCB_Q);
    eval 'sub BS_TAG_Q () {0x02;}' unless defined(&BS_TAG_Q);
    eval 'sub BS_NEXUS_Q () {0x04;}' unless defined(&BS_NEXUS_Q);
    eval 'sub BS_SELECT_Q () {0x08;}' unless defined(&BS_SELECT_Q);
    eval 'sub BS_RETRY () {0x10;}' unless defined(&BS_RETRY);
    eval 'sub L_EXCLUSIVE () {0x01;}' unless defined(&L_EXCLUSIVE);
    eval 'sub L_IN_START_LOOP () {0x02;}' unless defined(&L_IN_START_LOOP);
    eval 'sub L_SET_LIMITS () {0x04;}' unless defined(&L_SET_LIMITS);
    eval 'sub L_START_NEEDED () {0x08;}' unless defined(&L_START_NEEDED);
    eval 'sub L_INIT_INQUIRY () {0x10;}' unless defined(&L_INIT_INQUIRY);
    eval 'sub L_TAGS () {0x20;}' unless defined(&L_TAGS);
    eval 'sub L_ENABLE_TAGS () {0x40;}' unless defined(&L_ENABLE_TAGS);
    eval 'sub L_SLEEPING_ON_IN_USE () {0x80;}' unless defined(&L_SLEEPING_ON_IN_USE);
    eval 'sub L_NPT_DD_BITS () {0xff00;}' unless defined(&L_NPT_DD_BITS);
    eval 'sub L_DISABLE_OPENS () {0x0100;}' unless defined(&L_DISABLE_OPENS);
    eval 'sub L_IF2_STATUS () {0x0200;}' unless defined(&L_IF2_STATUS);
    eval 'sub L_IF2_XSENSE () {0x0400;}' unless defined(&L_IF2_XSENSE);
    eval 'sub L_CCS_XSENSE () {0x0800;}' unless defined(&L_CCS_XSENSE);
    eval 'sub L_ANSI2_SENSE () {0x8000;}' unless defined(&L_ANSI2_SENSE);
    eval 'sub L_DEFERRED_ERROR () {0x100000;}' unless defined(&L_DEFERRED_ERROR);
    eval 'sub dd_open_cnt {
        local($xp) = @_;
	    eval q((($xp)-> &open_cnt - ($xp)-> &sctl_open_cnt));
    }' unless defined(&dd_open_cnt);
    eval 'sub dd_raw_open_cnt {
        local($lp) = @_;
	    eval q((($lp)-> &raw_open_cnt - ($lp)-> &sctl_open_cnt));
    }' unless defined(&dd_raw_open_cnt);
    eval 'sub dd_blk_open_cnt {
        local($lp) = @_;
	    eval q((($lp)-> &open_cnt - ($lp)-> &raw_open_cnt));
    }' unless defined(&dd_blk_open_cnt);
    eval 'sub EVERYTHING () {0;}' unless defined(&EVERYTHING);
    eval 'sub CMD_MODE_ONLY () {1;}' unless defined(&CMD_MODE_ONLY);
    eval 'sub SCTL_MAJOR () {( ($sctl_ddsw->{raw_major}));}' unless defined(&SCTL_MAJOR);
    eval 'sub pass_thru_major {
        local($dev) = @_;
	    eval q(( &major($dev) ==  &SCTL_MAJOR));
    }' unless defined(&pass_thru_major);
    eval 'sub T_EXCLUSIVE () {0x01;}' unless defined(&T_EXCLUSIVE);
    eval 'sub T_SET_LIMITS () {0x04;}' unless defined(&T_SET_LIMITS);
    eval 'sub T_ENABLE_SDTR () {0x20;}' unless defined(&T_ENABLE_SDTR);
    eval 'sub T_ENABLE_WDTR () {0x40;}' unless defined(&T_ENABLE_WDTR);
    eval 'sub T_COMPATIBILITY () {0x80;}' unless defined(&T_COMPATIBILITY);
    eval 'sub B_EXCLUSIVE () {0x01;}' unless defined(&B_EXCLUSIVE);
    eval 'sub B_SET_LIMITS () {0x04;}' unless defined(&B_SET_LIMITS);
    eval 'sub B_IF_START_NEEDED () {0x40;}' unless defined(&B_IF_START_NEEDED);
    eval 'sub B_STOP_CLEANUP_SCBS () {0x80;}' unless defined(&B_STOP_CLEANUP_SCBS);
    if(defined( &SCSI_ALT_IF_DRIVER)) {
    }
    eval 'sub bus_min_sdtr_period () { &spoll_byte;}' unless defined(&bus_min_sdtr_period);
    eval 'sub bus_max_width () { &int_enabled;}' unless defined(&bus_max_width);
    eval 'sub bus_max_reqack_offset () { &tfr_control;}' unless defined(&bus_max_reqack_offset);
    eval 'sub tgt_sdtr_done () { &lock_count;}' unless defined(&tgt_sdtr_done);
    eval 'sub tgt_wdtr_done () { &ppoll_f;}' unless defined(&tgt_wdtr_done);
    eval 'sub tgt_wdtr_width () { &ppoll_l;}' unless defined(&tgt_wdtr_width);
    eval 'sub tgt_sdtr_period () { &event_f;}' unless defined(&tgt_sdtr_period);
    eval 'sub tgt_sdtr_period1 () { &event_l;}' unless defined(&tgt_sdtr_period1);
    eval 'sub tgt_sdtr_period2 () { &status_f;}' unless defined(&tgt_sdtr_period2);
    eval 'sub tgt_sdtr_period3 () { &status_l;}' unless defined(&tgt_sdtr_period3);
    eval 'sub if_char0 () { &ppoll_flag;}' unless defined(&if_char0);
    eval 'sub if_uchar1 () { &ppoll_mask;}' unless defined(&if_uchar1);
    eval 'sub if_uchar2 () { &ppoll_sense;}' unless defined(&if_uchar2);
    eval 'sub SA_ANY () {-1;}' unless defined(&SA_ANY);
    eval 'sub SA_NONE () {-2;}' unless defined(&SA_NONE);
    eval 'sub SA_DONE () {0x00;}' unless defined(&SA_DONE);
    eval 'sub SA_RETRY () {0x10;}' unless defined(&SA_RETRY);
    eval 'sub SA_PANIC () {0x80;}' unless defined(&SA_PANIC);
    eval 'sub SA_LOG_IT_NEVER () {0x00;}' unless defined(&SA_LOG_IT_NEVER);
    eval 'sub SA_LOG_IT_SOMETIMES () {0x01;}' unless defined(&SA_LOG_IT_SOMETIMES);
    eval 'sub SA_LOG_IT () {0x02;}' unless defined(&SA_LOG_IT);
    eval 'sub SA_LOG_IT_ALWAYS () { &SA_LOG_IT;}' unless defined(&SA_LOG_IT_ALWAYS);
    eval 'sub SA_VALID_RESID () {0x04;}' unless defined(&SA_VALID_RESID);
    eval 'sub SA_DISABLE_TAGS () {0x20;}' unless defined(&SA_DISABLE_TAGS);
    eval 'sub SA_IGNORE_MAX_RETRIES () {0x40;}' unless defined(&SA_IGNORE_MAX_RETRIES);
    eval 'sub IF_BUS_TAGS () {0x00;}' unless defined(&IF_BUS_TAGS);
    eval 'sub IF_NO_TAGS () {0x01;}' unless defined(&IF_NO_TAGS);
    eval 'sub IF_B2_LIST () {0x02;}' unless defined(&IF_B2_LIST);
    eval 'sub IF_ALT_DRIVER () {0x04;}' unless defined(&IF_ALT_DRIVER);
    eval 'sub TAIL () {0;}' unless defined(&TAIL);
    eval 'sub HEAD () {1;}' unless defined(&HEAD);
    eval 'sub FUNC_COMMON () {0x01;}' unless defined(&FUNC_COMMON);
    eval 'sub FUNC_CMD () {0x02;}' unless defined(&FUNC_CMD);
    eval 'sub FUNC_SIOC_IO () {0x04;}' unless defined(&FUNC_SIOC_IO);
    eval 'sub FUNC_TAG_STATE () {0x08;}' unless defined(&FUNC_TAG_STATE);
    eval 'sub FUNC_OPEN_CLOSE () {0x10;}' unless defined(&FUNC_OPEN_CLOSE);
    eval 'sub FUNC_IOCTL () {0x20;}' unless defined(&FUNC_IOCTL);
    eval 'sub SLOG_IO_ID () {0x00000001;}' unless defined(&SLOG_IO_ID);
    eval 'sub SLOG_LBOLT () {0x00000002;}' unless defined(&SLOG_LBOLT);
    eval 'sub SLOG_DEV () {0x00000010;}' unless defined(&SLOG_DEV);
    eval 'sub SLOG_BP () {0x00000100;}' unless defined(&SLOG_BP);
    eval 'sub SLOG_RETRY_CNT () {0x00000200;}' unless defined(&SLOG_RETRY_CNT);
    eval 'sub SLOG_TAG () {0x00000400;}' unless defined(&SLOG_TAG);
    eval 'sub SLOG_CDB () {0x00000800;}' unless defined(&SLOG_CDB);
    eval 'sub SLOG_OPCODE () {0x00001000;}' unless defined(&SLOG_OPCODE);
    eval 'sub SLOG_ADDR () {0x00002000;}' unless defined(&SLOG_ADDR);
    eval 'sub SLOG_BCOUNT () {0x00004000;}' unless defined(&SLOG_BCOUNT);
    eval 'sub SLOG_DATA () {0x00008000;}' unless defined(&SLOG_DATA);
    eval 'sub SLOG_RESID () {0x00010000;}' unless defined(&SLOG_RESID);
    eval 'sub SLOG_STATUS () {0x00020000;}' unless defined(&SLOG_STATUS);
    eval 'sub SLOG_FLAGS () {0x00040000;}' unless defined(&SLOG_FLAGS);
    eval 'sub SLOG_ERROR () {0x00080000;}' unless defined(&SLOG_ERROR);
    eval 'sub SLOG_SENSE_STATUS () {0x00100000;}' unless defined(&SLOG_SENSE_STATUS);
    eval 'sub SLOG_SENSE_DATA () {0x00200000;}' unless defined(&SLOG_SENSE_DATA);
    eval 'sub SLOG_ERROR_CLASS () {0x00400000;}' unless defined(&SLOG_ERROR_CLASS);
    eval 'sub SLOG_ERROR_CODE () {0x00800000;}' unless defined(&SLOG_ERROR_CODE);
    eval 'sub SLOG_SENSE_KEY () {0x01000000;}' unless defined(&SLOG_SENSE_KEY);
    eval 'sub SLOG_INFO () {0x02000000;}' unless defined(&SLOG_INFO);
    eval 'sub SLOG_ASC () {0x04000000;}' unless defined(&SLOG_ASC);
    eval 'sub SLOG_ASCQ () {0x08000000;}' unless defined(&SLOG_ASCQ);
    eval 'sub SLOG_AS_DECODE () {0x10000000;}' unless defined(&SLOG_AS_DECODE);
    eval 'sub SLOG_DMESG () {0x20000000;}' unless defined(&SLOG_DMESG);
    eval 'sub CS_GOOD () {(0x01 << 8);}' unless defined(&CS_GOOD);
    eval 'sub CS_ABORTED_BY_HOST () {(0x02 << 8);}' unless defined(&CS_ABORTED_BY_HOST);
    eval 'sub CS_REQ_COMP_WERROR () {(0x04 << 8);}' unless defined(&CS_REQ_COMP_WERROR);
    eval 'sub CS_INVALID_REQUEST () {(0x06 << 8);}' unless defined(&CS_INVALID_REQUEST);
    eval 'sub CS_SELECT_TIMEOUT () {(0x0a << 8);}' unless defined(&CS_SELECT_TIMEOUT);
    eval 'sub scsi_lock_alloc {
        local($order, $name) = @_;
	    eval q( &alloc_spinlock($order, $name));
    }' unless defined(&scsi_lock_alloc);
    eval 'sub scsi_lock {
        local($lock) = @_;
	    eval q( &spinlock($lock));
    }' unless defined(&scsi_lock);
    eval 'sub scsi_unlock {
        local($lock) = @_;
	    eval q( &spinunlock($lock));
    }' unless defined(&scsi_unlock);
    eval 'sub scsi_lockx {
        local($lock, $state) = @_;
	    eval q( &spinlockx($lock, $state));
    }' unless defined(&scsi_lockx);
    eval 'sub scsi_unlockx {
        local($lock, $state) = @_;
	    eval q( &spinunlockx($lock, $state));
    }' unless defined(&scsi_unlockx);
    eval 'sub scsi_lock_owned {
        local($lock) = @_;
	    eval q( &owns_spinlock($lock));
    }' unless defined(&scsi_lock_owned);
    eval 'sub scsi_lock_term {
        local($lock) = @_;
	    eval q( &dealloc_spinlock($lock));
    }' unless defined(&scsi_lock_term);
    eval 'sub scsi_lun_lock {
        local($lp) = @_;
	    eval q( &spinlock(( ($lp->{lock}))));
    }' unless defined(&scsi_lun_lock);
    eval 'sub scsi_lun_unlock {
        local($lp) = @_;
	    eval q( &spinunlock(( ($lp->{lock}))));
    }' unless defined(&scsi_lun_unlock);
    eval 'sub scsi_lun_lockx {
        local($lp, $state) = @_;
	    eval q( &spinlockx(( ($lp->{lock})), $state));
    }' unless defined(&scsi_lun_lockx);
    eval 'sub scsi_lun_unlockx {
        local($lp, $state) = @_;
	    eval q( &spinunlockx(( ($lp->{lock})), $state));
    }' unless defined(&scsi_lun_unlockx);
    eval 'sub scsi_lun_lock_owned {
        local($lp) = @_;
	    eval q( &owns_spinlock(( ($lp->{lock}))));
    }' unless defined(&scsi_lun_lock_owned);
    eval 'sub scsi_tgt_lock {
        local($tgt) = @_;
	    eval q( &spinlock(( ($tgt->{lock}))));
    }' unless defined(&scsi_tgt_lock);
    eval 'sub scsi_tgt_unlock {
        local($tgt) = @_;
	    eval q( &spinunlock(( ($tgt->{lock}))));
    }' unless defined(&scsi_tgt_unlock);
    eval 'sub scsi_tgt_lockx {
        local($tgt, $state) = @_;
	    eval q( &spinlockx(( ($tgt->{lock})), $state));
    }' unless defined(&scsi_tgt_lockx);
    eval 'sub scsi_tgt_unlockx {
        local($tgt,$state) = @_;
	    eval q( &spinunlockx(( ($tgt->{lock})), $state));
    }' unless defined(&scsi_tgt_unlockx);
    eval 'sub scsi_tgt_lock_owned {
        local($tgt) = @_;
	    eval q( &owns_spinlock(( ($tgt->{lock}))));
    }' unless defined(&scsi_tgt_lock_owned);
    eval 'sub scsi_bus_lock {
        local($busp) = @_;
	    eval q( &spinlock(( ($busp->{lock}))));
    }' unless defined(&scsi_bus_lock);
    eval 'sub scsi_bus_unlock {
        local($busp) = @_;
	    eval q( &spinunlock(( ($busp->{lock}))));
    }' unless defined(&scsi_bus_unlock);
    eval 'sub scsi_bus_lockx {
        local($busp, $state) = @_;
	    eval q( &spinlockx(( ($busp->{lock})), $state));
    }' unless defined(&scsi_bus_lockx);
    eval 'sub scsi_bus_unlockx {
        local($busp,$state) = @_;
	    eval q( &spinunlockx(( ($busp->{lock})), $state));
    }' unless defined(&scsi_bus_unlockx);
    eval 'sub scsi_bus_lock_owned {
        local($busp) = @_;
	    eval q( &owns_spinlock(( ($busp->{lock}))));
    }' unless defined(&scsi_bus_lock_owned);
    eval 'sub scsi_subsys_lock () {
        eval q( &spinlock( &scsi_subsystem_lock));
    }' unless defined(&scsi_subsys_lock);
    eval 'sub scsi_subsys_unlock () {
        eval q( &spinunlock( &scsi_subsystem_lock));
    }' unless defined(&scsi_subsys_unlock);
    eval 'sub scsi_subsys_lockx {
        local($state) = @_;
	    eval q( &spinlockx( &scsi_subsystem_lock, $state));
    }' unless defined(&scsi_subsys_lockx);
    eval 'sub scsi_subsys_unlockx {
        local($state) = @_;
	    eval q( &spinunlockx( &scsi_subsystem_lock,$state));
    }' unless defined(&scsi_subsys_unlockx);
    eval 'sub scsi_subsys_lock_owned () {
        eval q( &owns_spinlock( &scsi_subsystem_lock));
    }' unless defined(&scsi_subsys_lock_owned);
    eval 'sub DEV_S400_CMD_MODE () {0x01;}' unless defined(&DEV_S400_CMD_MODE);
    eval 'sub DEV_NO_INQUIRY () {0x02;}' unless defined(&DEV_NO_INQUIRY);
    eval 'sub DEV_ALT_IF_DRIVER () {0x04;}' unless defined(&DEV_ALT_IF_DRIVER);
}
1;
