require '_h2ph_pre.ph';

unless(defined(&_SEM_ALPHA_INCLUDED)) {
    eval 'sub _SEM_ALPHA_INCLUDED () {1;}' unless defined(&_SEM_ALPHA_INCLUDED);
    if(defined(&_KERNEL_BUILD)) {
	require '../h/semglobal.ph';
	require '../h/sem_utl.ph';
	require '../h/spinlock.ph';
    } else {
	require 'sys/semglobal.ph';
	require 'sys/sem_utl.ph';
	require 'sys/spinlock.ph';
    }
    if(defined( &GPROF)  && defined( &GP_SPIN_SPECIAL)) {
    }
    if(defined(&SEMA_COUNTING)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub MP_PSEMA {
	    local($sema) = @_;
    	    eval q((! &uniprocessor ?  &psema($sema):0));
	}' unless defined(&MP_PSEMA);
	eval 'sub MP_VSEMA {
	    local($sema) = @_;
    	    eval q((! &uniprocessor ?  &vsema($sema):0));
	}' unless defined(&MP_VSEMA);
	eval 'sub MP_PXSEMA {
	    local($sema,$ss) = @_;
    	    eval q((! &uniprocessor ?  &pxsema($sema,$ss):0));
	}' unless defined(&MP_PXSEMA);
	eval 'sub MP_VXSEMA {
	    local($sema,$ss) = @_;
    	    eval q((! &uniprocessor ?  &vxsema($sema,$ss):0));
	}' unless defined(&MP_VXSEMA);
	eval 'sub OWN_NET_SEMA () {( &owns_sema( &up_io_sema));}' unless defined(&OWN_NET_SEMA);
	eval 'sub PSEMA {
	    local($sema) = @_;
    	    eval q( &MP_PSEMA($sema));
	}' unless defined(&PSEMA);
	eval 'sub VSEMA {
	    local($sema) = @_;
    	    eval q( &MP_VSEMA($sema));
	}' unless defined(&VSEMA);
	eval 'sub PXSEMA {
	    local($sema,$ss) = @_;
    	    eval q( &MP_PXSEMA($sema,$ss));
	}' unless defined(&PXSEMA);
	eval 'sub VXSEMA {
	    local($sema,$ss) = @_;
    	    eval q( &MP_VXSEMA($sema,$ss));
	}' unless defined(&VXSEMA);
	eval 'sub NET_PXSEMA {
	    local($ss) = @_;
    	    eval q( &MP_PXSEMA( &up_io_sema, $ss));
	}' unless defined(&NET_PXSEMA);
	eval 'sub NET_VXSEMA {
	    local($ss) = @_;
    	    eval q( &MP_VXSEMA( &up_io_sema, $ss));
	}' unless defined(&NET_VXSEMA);
	eval 'sub NET_PSEMA () {
	    eval q( &MP_PSEMA( &up_io_sema));
	}' unless defined(&NET_PSEMA);
	eval 'sub NET_VSEMA () {
	    eval q( &MP_VSEMA( &up_io_sema));
	}' unless defined(&NET_VSEMA);
	if(defined(&MP_VM)) {
	    eval 'sub vmemp_lock () {
	        eval q( &MP_PSEMA( &vmsys_sema));
	    }' unless defined(&vmemp_lock);
	    eval 'sub vmemp_unlock () {
	        eval q( &MP_VSEMA( &vmsys_sema));
	    }' unless defined(&vmemp_unlock);
	    eval 'sub vmemp_lockx () {
	        eval q( &MP_PXSEMA( &vmsys_sema,  ($sema_state->{sema})));
	    }' unless defined(&vmemp_lockx);
	    eval 'sub vmemp_unlockx () {
	        eval q( &MP_VXSEMA( &vmsys_sema,  ($sema_state->{sema})));
	    }' unless defined(&vmemp_unlockx);
	    eval 'sub vmemp_returnx {
	        local($X) = @_;
    		eval q({  &vmemp_unlockx();  &return $X ; });
	    }' unless defined(&vmemp_returnx);
	    eval 'sub vmemp_return {
	        local($X) = @_;
    		eval q({  &vmemp_unlock();  &return $X ; });
	    }' unless defined(&vmemp_return);
	    eval 'sub vm_sema_state () { &union {  &sv_sema_t  &sema;  &sv_lock_t  &lock; }  &sema_state;}' unless defined(&vm_sema_state);
	} else {
	    eval 'sub vmemp_lock () {
	        eval q();
	    }' unless defined(&vmemp_lock);
	    eval 'sub vmemp_unlock () {
	        eval q();
	    }' unless defined(&vmemp_unlock);
	    eval 'sub vmemp_lockx () {
	        eval q();
	    }' unless defined(&vmemp_lockx);
	    eval 'sub vmemp_unlockx () {
	        eval q();
	    }' unless defined(&vmemp_unlockx);
	    eval 'sub vmemp_returnx {
	        local($X) = @_;
    		eval q( &return $X);
	    }' unless defined(&vmemp_returnx);
	    eval 'sub vmemp_return {
	        local($X) = @_;
    		eval q( &return $X);
	    }' unless defined(&vmemp_return);
	    eval 'sub vm_sema_state () { &extern  &void  &vm_sema_state_rtn();}' unless defined(&vm_sema_state);
	}
	eval 'sub STAT_MP_DEVSW {
	    local($FLAG) = @_;
    	    eval q();
	}' unless defined(&STAT_MP_DEVSW);
	eval 'sub STAT_UP_DEVSW {
	    local($FLAG) = @_;
    	    eval q();
	}' unless defined(&STAT_UP_DEVSW);
	eval 'sub DEVSW {
	    local($TABLE, $MAJOR, $FUNC, $ARGS, $RET, $SAVE) = @_;
    	    eval q({  &extern \'struct sema\' * &kt_sema(); \'int\'  &DevswConj;  &SD_ASSERT(!  &ON_ICS, \\"DEVSW: entered on ICS\\");  &if ($SAVE =  &kt_sema( ($u->{u_kthreadp})))  &vsema;  &if ( &kt_sema( ($u->{u_kthreadp})))  &panic;  &DevswConj = (! &uniprocessor  && !( ($TABLE[$MAJOR]->{d_flags}) &  &MGR_IS_MP));  &if  &psema( &up_io_sema);  &if (! ($TABLE[$MAJOR]->{d_pfilter})) $RET = (* ($TABLE[$MAJOR]->{FUNC})) $ARGS;  &else { \'int\'  &DevswTmp; \'char\' * &DevswTable = $TABLE; \'int\'  &CharTable = ($TABLE ==  &cdevsw); \'int\' (* &DevswFunc)() =  ($TABLE[$MAJOR]->{FUNC});  &pfilter_t * &DevswFilter =  ($TABLE[$MAJOR]->{d_pfilter});  &FILTER_FUNC $ARGS; $RET =  &DevswTmp; }  &if  &vsema( &up_io_sema);  &if  &psema($SAVE); });
	}' unless defined(&DEVSW);
	eval 'sub MP_DEVSW {
	    local($TABLE, $MAJOR, $FUNC, $ARGS, $RET) = @_;
    	    eval q({  &extern \'struct sema\' * &kt_sema(); \'int\'  &DevswConj;  &SD_ASSERT(!  &ON_ICS, \\"MP_DEVSW(): entered on ICS\\");  &SD_ASSERT( ( &kt_sema( ($u->{u_kthreadp})) ==  &NULL) || ( &kt_sema( ($u->{u_kthreadp})) ==  &up_io_sema), \\"MP_DEVSW(): entered with wrong semas\\");  &DevswConj = (! &uniprocessor  && !( ($TABLE[$MAJOR]->{d_flags}) &  &MGR_IS_MP)  && ( &kt_sema( ($u->{u_kthreadp})) !=  &up_io_sema));  &if  &psema( &up_io_sema);  &else  &STAT_MP_DEVSW(  ($TABLE[$MAJOR]->{d_flags}) );  &if (! ($TABLE[$MAJOR]->{d_pfilter})) $RET = (* ($TABLE[$MAJOR]->{FUNC})) $ARGS;  &else { \'int\'  &DevswTmp; \'char\' * &DevswTable = $TABLE; \'int\'  &CharTable = ($TABLE ==  &cdevsw); \'int\' (* &DevswFunc)() =  ($TABLE[$MAJOR]->{FUNC});  &pfilter_t * &DevswFilter =  ($TABLE[$MAJOR]->{d_pfilter});  &FILTER_FUNC $ARGS; $RET =  &DevswTmp; }  &if  &vsema( &up_io_sema); });
	}' unless defined(&MP_DEVSW);
	eval 'sub UP_DEVSW {
	    local($TABLE, $MAJOR, $FUNC, $ARGS, $RET) = @_;
    	    eval q({  &extern \'struct sema\' * &kt_sema(); \'int\'  &DevswConj;  &SD_ASSERT(!  &ON_ICS, \\"UP_DEVSW(): entered on ICS\\");  &DevswConj = (! &uniprocessor  && ( ($TABLE[$MAJOR]->{d_flags}) &  &MGR_IS_MP));  &if {  &SD_ASSERT( &kt_sema( ($u->{u_kthreadp})) ==  &up_io_sema, \\"UP_DEVSW(): entered without up_io_sema\\");  &vsema( &up_io_sema); }  &else  &STAT_UP_DEVSW(  ($TABLE[$MAJOR]->{d_flags}) );  &if (! ($TABLE[$MAJOR]->{d_pfilter})) $RET = (* ($TABLE[$MAJOR]->{FUNC})) $ARGS;  &else { \'int\'  &DevswTmp; \'char\' * &DevswTable = $TABLE; \'int\'  &CharTable = ($TABLE ==  &cdevsw); \'int\' (* &DevswFunc)() =  ($TABLE[$MAJOR]->{FUNC});  &pfilter_t * &DevswFilter =  ($TABLE[$MAJOR]->{d_pfilter});  &FILTER_FUNC $ARGS; $RET =  &DevswTmp; }  &if  &vsema( &up_io_sema); });
	}' unless defined(&UP_DEVSW);
	eval 'sub UP_EMULATE {
	    local($FUNC, $ARGS, $RET) = @_;
    	    eval q({  &extern \'struct sema\' * &kt_sema();  &SD_ASSERT(!  &ON_ICS, \\"UP_EMULATE: entered on ICS\\");  &SD_ASSERT( ( &kt_sema( ($u->{u_kthreadp})) ==  &NULL) || ( &kt_sema( ($u->{u_kthreadp})) ==  &up_io_sema), \\"UP_EMULATE(): entered with wrong semas\\");  &if (! &uniprocessor  && ( &kt_sema( ($u->{u_kthreadp})) !=  &up_io_sema)) {  &psema( &up_io_sema); $RET = $FUNC $ARGS;  &vsema( &up_io_sema); }  &else $RET = $FUNC $ARGS; });
	}' unless defined(&UP_EMULATE);
	eval 'sub DISK_SECTION_MASK () {0xf;}' unless defined(&DISK_SECTION_MASK);
	eval 'sub FILTER_d_open {
	    local($DEV, $A2, $A3, $A4) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_open}))( &DevswFunc,  &CharTable, $DEV, $A2, $A3, $A4);  &else  &DevswTmp = (* &DevswFunc)($DEV, $A2, $A3, $A4); });
	}' unless defined(&FILTER_d_open);
	eval 'sub FILTER_d_close {
	    local($DEV, $A2, $A3) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_close}))( &DevswFunc,  &CharTable, $DEV, $A2, $A3);  &else  &DevswTmp = (* &DevswFunc)($DEV, $A2, $A3); });
	}' unless defined(&FILTER_d_close);
	eval 'sub FILTER_d_read {
	    local($DEV, $UIO) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_read}))( &DevswFunc,  &CharTable, $DEV, $UIO);  &else  &DevswTmp = (* &DevswFunc)($DEV, $UIO); });
	}' unless defined(&FILTER_d_read);
	eval 'sub FILTER_d_write {
	    local($DEV, $UIO) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_write}))( &DevswFunc,  &CharTable, $DEV, $UIO);  &else  &DevswTmp = (* &DevswFunc)($DEV, $UIO); });
	}' unless defined(&FILTER_d_write);
	eval 'sub FILTER_d_ioctl {
	    local($DEV, $CMD, $DATA, $FLAG) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_ioctl}))( &DevswFunc,  &CharTable, $DEV, $CMD, $DATA, $FLAG);  &else  &DevswTmp = (* &DevswFunc)($DEV, $CMD, $DATA, $FLAG); });
	}' unless defined(&FILTER_d_ioctl);
	eval 'sub FILTER_d_select {
	    local($DEV, $WHICH) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_select}))( &DevswFunc,  &CharTable, $DEV, $WHICH);  &else  &DevswTmp = (* &DevswFunc)($DEV, $WHICH); });
	}' unless defined(&FILTER_d_select);
	eval 'sub FILTER_d_option1 {
	    local($DEV) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_option1}))( &DevswFunc,  &CharTable, $DEV);  &else  &DevswTmp = (* &DevswFunc)($DEV); });
	}' unless defined(&FILTER_d_option1);
	eval 'sub FILTER_d_strategy {
	    local($BP) = @_;
    	    eval q({  &if ( ($BP->{b_dev}) &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_strategy}))( &DevswFunc,  &CharTable, $BP);  &else  &DevswTmp = (* &DevswFunc)($BP); });
	}' unless defined(&FILTER_d_strategy);
	eval 'sub FILTER_d_dump {
	    local($DEV) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_dump}))( &DevswFunc,  &CharTable, $DEV);  &else  &DevswTmp = (* &DevswFunc)($DEV); });
	}' unless defined(&FILTER_d_dump);
	eval 'sub FILTER_d_psize {
	    local($DEV) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_psize}))( &DevswFunc,  &CharTable, $DEV);  &else  &DevswTmp = (* &DevswFunc)($DEV); });
	}' unless defined(&FILTER_d_psize);
	eval 'sub FILTER_d_mount {
	    local($DEV, $A1, $A2, $A3, $A4) = @_;
    	    eval q({  &if ($DEV &  &DISK_SECTION_MASK)  &DevswTmp = (* ($DevswFilter->{pf_mount}))( &DevswFunc,  &CharTable, $DEV, $A1, $A2, $A3, $A4);  &else  &DevswTmp = (* &DevswFunc)($DEV, $A1, $A2, $A3, $A4); });
	}' unless defined(&FILTER_d_mount);
	if(defined(&OPTIMIZED_PV)) {
	    eval 'sub psema {
	        local($sema) = @_;
    		eval q({  &lock_sema();  &if (--($sema)-> &count < 0) {  &sema_locked();  &psema_fail($sema); }  &else { ($sema)-> &owner =  ($udot->{u_kthreadp});  &unlock_sema(); } });
	    }' unless defined(&psema);
	    eval 'sub vsema {
	        local($sema) = @_;
    		eval q({  &lock_sema(); ($sema)-> &owner = 0;  &if (($sema)-> &count++ < 0) {  &sema_locked();  &vsema_wake($sema); }  &else {  &unlock_sema(); } });
	    }' unless defined(&vsema);
	}
    }
}
1;
