require '_h2ph_pre.ph';

unless(defined(&_SYS_VFS_INCLUDED)) {
    eval 'sub _SYS_VFS_INCLUDED () {1;}' unless defined(&_SYS_VFS_INCLUDED);
    if(defined(&_INCLUDE_HPUX_SOURCE)) {
	if(defined(&_KERNEL_BUILD)) {
	    require '../h/types.ph';
	    require '../h/param.ph';
	} else {
	    require 'sys/types.ph';
	    require 'sys/param.ph';
	}
	unless(defined(&SDOCHAR)) {
	    eval 'sub SDOCHAR () {ord(\'+\');}' unless defined(&SDOCHAR);
	}
	eval 'sub VFS_AFSMAGIC () {(0x123456);}' unless defined(&VFS_AFSMAGIC);
	eval 'sub VFS_RDONLY () {0x01;}' unless defined(&VFS_RDONLY);
	eval 'sub VFS_MLOCK () {0x02;}' unless defined(&VFS_MLOCK);
	eval 'sub VFS_MWAIT () {0x04;}' unless defined(&VFS_MWAIT);
	eval 'sub VFS_NOSUID () {0x08;}' unless defined(&VFS_NOSUID);
	eval 'sub VFS_EXPORTED () {0x10;}' unless defined(&VFS_EXPORTED);
	eval 'sub VFS_REMOTE () {0x20;}' unless defined(&VFS_REMOTE);
	eval 'sub VFS_HASQUOTA () {0x40;}' unless defined(&VFS_HASQUOTA);
	eval 'sub VFS_MI_DEV () {0x100;}' unless defined(&VFS_MI_DEV);
	eval 'sub VFS_MOUNTING () {0x200;}' unless defined(&VFS_MOUNTING);
	eval 'sub VFS_ORD () {0x400;}' unless defined(&VFS_ORD);
	eval 'sub VFS_LARGEFILES () {0x800;}' unless defined(&VFS_LARGEFILES);
	eval 'sub EX_RDONLY () {0x01;}' unless defined(&EX_RDONLY);
	eval 'sub EX_RDMOSTLY () {0x02;}' unless defined(&EX_RDMOSTLY);
	eval 'sub EX_ASYNC () {0x04;}' unless defined(&EX_ASYNC);
	if(defined(&__cplusplus)) {
	    eval 'sub __x () {...;}' unless defined(&__x);
	} else {
	    eval 'sub __x () {1;}' unless defined(&__x);
	}
	if(defined(&__cplusplus)) {
	    undef(&__x) if defined(&__x);
	}
	eval 'sub VFS_MOUNT {
	    local($VFSP, $PATH, $DATA) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_mount}))($VFSP, $PATH, $DATA));
	}' unless defined(&VFS_MOUNT);
	eval 'sub VFS_UNMOUNT {
	    local($VFSP) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_unmount}))($VFSP));
	}' unless defined(&VFS_UNMOUNT);
	eval 'sub VFS_ROOT {
	    local($VFSP,$VPP,$NAME) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_root}))($VFSP,$VPP,$NAME));
	}' unless defined(&VFS_ROOT);
	eval 'sub VFS_STATVFS {
	    local($VFSP, $SBP) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_statvfs}))($VFSP,$SBP));
	}' unless defined(&VFS_STATVFS);
	eval 'sub VFS_SYNC {
	    local($VFSP, $FLAGS) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_sync}))($VFSP, $FLAGS));
	}' unless defined(&VFS_SYNC);
	eval 'sub VFS_VGET {
	    local($VFSP, $VPP, $FIDP) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_vget}))($VFSP, $VPP, $FIDP));
	}' unless defined(&VFS_VGET);
	eval 'sub VFS_GETMOUNT {
	    local($VFSP, $FSMNTDIR, $MNTDATA, $OPTIONSTR) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_getmount}))($VFSP, $FSMNTDIR, $MNTDATA, $OPTIONSTR));
	}' unless defined(&VFS_GETMOUNT);
	eval 'sub VFS_FREEZE {
	    local($VFSP) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_freeze}))($VFSP));
	}' unless defined(&VFS_FREEZE);
	eval 'sub VFS_THAW {
	    local($VFSP) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_thaw}))($VFSP));
	}' unless defined(&VFS_THAW);
	eval 'sub VFS_QUOTA {
	    local($VFSP, $CMD, $UID, $ADDR) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_quota}))($VFSP, $CMD, $UID, $ADDR));
	}' unless defined(&VFS_QUOTA);
	eval 'sub VFS_MOUNTROOT {
	    local($VFSP,$RWFLAG) = @_;
    	    eval q((*($VFSP)-> ($vfs_op->{vfs_mountroot}))($VFSP,$RWFLAG));
	}' unless defined(&VFS_MOUNTROOT);
	eval 'sub SYNC_NOLOCKWAIT () {0x00000001;}' unless defined(&SYNC_NOLOCKWAIT);
	eval 'sub SYNC_META () {0x00000002;}' unless defined(&SYNC_META);
	eval 'sub SYNC_PANIC () {0x00000004;}' unless defined(&SYNC_PANIC);
	eval 'sub SYNC_REBOOT1 () {0x00000008;}' unless defined(&SYNC_REBOOT1);
	eval 'sub SYNC_REBOOT2 () {0x00000010;}' unless defined(&SYNC_REBOOT2);
	eval 'sub SYNC_SYNC () {0x00000020;}' unless defined(&SYNC_SYNC);
	eval 'sub M_OPTS () {0x00010000;}' unless defined(&M_OPTS);
	if(defined(&_KERNEL)) {
	    eval 'sub VFS_INIT {
	        local($VFSP, $OP, $DATA, $MTYPE) = @_;
    		eval q({ -> &vfs_next = 0; -> &vfs_op = ; -> &vfs_flag = 0; -> &vfs_exflags = 0; -> &vfs_icount = 0; -> &vfs_data = ; -> &vfs_mtype = ; -> &vfs_dev = 0; -> &vfs_logp = 0; -> &vfs_ncachehd = 0; });
	    }' unless defined(&VFS_INIT);
	    eval 'sub MOUNT_UFS () {0;}' unless defined(&MOUNT_UFS);
	    eval 'sub MOUNT_NFS () {1;}' unless defined(&MOUNT_NFS);
	    eval 'sub MOUNT_CDFS () {2;}' unless defined(&MOUNT_CDFS);
	    eval 'sub MOUNT_PC () {3;}' unless defined(&MOUNT_PC);
	    eval 'sub MOUNT_DCFS () {4;}' unless defined(&MOUNT_DCFS);
	}
	eval 'sub MAXFIDSZ () {16;}' unless defined(&MAXFIDSZ);
	eval 'sub freefid {
	    local($fidp) = @_;
    	    eval q( &kmem_free(($fidp), $sizeof{\'struct fid\'} -  &MAXFIDSZ + ($fidp)-> &fid_len));
	}' unless defined(&freefid);
	if(defined(&_KERNEL_BUILD)) {
	    if(defined(&__cplusplus)) {
	    }
	    if(defined(&_PROTOTYPES)) {
		if(defined(&__cplusplus)) {
		} else {
		}
	    } else {
	    }
	    if(defined(&__cplusplus)) {
	    }
	}
	unless(defined(&_KERNEL)) {
	    if(defined(&__cplusplus)) {
	    }
	    if(defined(&_PROTOTYPES)) {
	    } else {
	    }
	    if(defined(&__cplusplus)) {
	    }
	}
	eval 'sub MDU_QUOTA () {0x1;}' unless defined(&MDU_QUOTA);
	eval 'sub MDU_DELAY () {0x2;}' unless defined(&MDU_DELAY);
	eval 'sub MDU_BEHIND () {0x4;}' unless defined(&MDU_BEHIND);
	eval 'sub MDU_FSASYNC () {0x8;}' unless defined(&MDU_FSASYNC);
	eval 'sub MDU_NO_FSASYNC () {0x10;}' unless defined(&MDU_NO_FSASYNC);
	eval 'sub md_rdev () { ($md_un->{md_ufs}->{mdu_rdev});}' unless defined(&md_rdev);
	eval 'sub md_ufsopts () { ($md_un->{md_ufs}->{mdu_ufsopts});}' unless defined(&md_ufsopts);
	eval 'sub md_nfsopts () { ($md_un->{md_nfs}->{mdn_nfsopts});}' unless defined(&md_nfsopts);
	eval 'sub md_retrans () { ($md_un->{md_nfs}->{mdn_retrans});}' unless defined(&md_retrans);
	eval 'sub md_timeo () { ($md_un->{md_nfs}->{mdn_timeo});}' unless defined(&md_timeo);
	eval 'sub md_rsize () { ($md_un->{md_nfs}->{mdn_rsize});}' unless defined(&md_rsize);
	eval 'sub md_wsize () { ($md_un->{md_nfs}->{mdn_wsize});}' unless defined(&md_wsize);
	eval 'sub md_port () { ($md_un->{md_nfs}->{mdn_port});}' unless defined(&md_port);
	eval 'sub md_acregmin () { ($md_un->{md_nfs}->{mdn_acregmin});}' unless defined(&md_acregmin);
	eval 'sub md_acregmax () { ($md_un->{md_nfs}->{mdn_acregmax});}' unless defined(&md_acregmax);
	eval 'sub md_acdirmin () { ($md_un->{md_nfs}->{mdn_acdirmin});}' unless defined(&md_acdirmin);
	eval 'sub md_acdirmax () { ($md_un->{md_nfs}->{mdn_acdirmax});}' unless defined(&md_acdirmax);
    }
}
1;
