require '_h2ph_pre.ph';

unless(defined(&_WSIO_H_INCLUDED)) {
    eval 'sub _WSIO_H_INCLUDED () {1;}' unless defined(&_WSIO_H_INCLUDED);
    if(defined(&_KERNEL_BUILD)) {
	require '../h/conf.ph';
	require '../h/io.ph';
	require '../h/types.ph';
	require '../io/ioparams.ph';
	require '../h/spinlock.ph';
    } else {
	require 'sys/conf.ph';
	require 'sys/io.ph';
	require 'sys/types.ph';
	require 'sys/ioparams.ph';
	require 'sys/spinlock.ph';
    }
    eval 'sub MAX_INSTANCES_PER_CLASS () {256;}' unless defined(&MAX_INSTANCES_PER_CLASS);
    unless(defined(&WSIO_OLD_MINORS)) {
	undef(&get_isc) if defined(&get_isc);
	eval 'sub get_isc {
	    local($x,$y) = @_;
    	    eval q( &wsio_get_isc($x,$y, &NULL););
	}' unless defined(&get_isc);
	undef(&m_vsc) if defined(&m_vsc);
	eval 'sub m_vsc {
	    local($x) = @_;
    	    eval q( &m_wsio_vsc($x, &NULL););
	}' unless defined(&m_vsc);
	undef(&m_slot) if defined(&m_slot);
	eval 'sub m_slot {
	    local($x) = @_;
    	    eval q( &m_wsio_slot($x, &NULL););
	}' unless defined(&m_slot);
	undef(&m_funcnum) if defined(&m_funcnum);
	eval 'sub m_funcnum {
	    local($x) = @_;
    	    eval q( &m_wsio_funcnum($x, &NULL););
	}' unless defined(&m_funcnum);
	undef(&m_function) if defined(&m_function);
	eval 'sub m_function {
	    local($x) = @_;
    	    eval q( &m_wsio_funcnum($x, &NULL););
	}' unless defined(&m_function);
	undef(&m_selcode) if defined(&m_selcode);
	eval 'sub m_selcode {
	    local($x) = @_;
    	    eval q( &m_wsio_selcode($x, &NULL););
	}' unless defined(&m_selcode);
    }
    eval 'sub WSIO_SLEEP {
        local($flag,$chan) = @_;
	    eval q({  &register  &lock_t * &slp_lock =  &get_sleep_lock;  &if  &sleep($chan, &PRIBIO);  &else  &spinunlock( &slp_lock); });
    }' unless defined(&WSIO_SLEEP);
    eval 'sub WSIO_WAKEUP {
        local($flag,$chan) = @_;
	    eval q({  &register  &lock_t * &slp_lock =  &get_sleep_lock; $flag =  &FALSE;  &wakeup($chan);  &spinunlock( &slp_lock); });
    }' unless defined(&WSIO_WAKEUP);
    eval 'sub WSIO_LOCK {
        local($context) = @_;
	    eval q({  &if (! &WSIO_LOCKED())  &SPINLOCK_USAV( &wsio_lock, $context);  &wsio_lock_count++; });
    }' unless defined(&WSIO_LOCK);
    eval 'sub WSIO_UNLOCK {
        local($context) = @_;
	    eval q({  &if (-- &wsio_lock_count == 0)  &SPINUNLOCK_USAV( &wsio_lock, $context); });
    }' unless defined(&WSIO_UNLOCK);
    eval 'sub WSIO_LOCKED () {
        eval q( &owns_spinlock( &wsio_lock));
    }' unless defined(&WSIO_LOCKED);
    eval 'sub WSIO_PLAIN_SPINLOCK () {
        eval q({  &if (! &WSIO_LOCKED())  &spinlock( &wsio_lock);  &wsio_lock_count++; });
    }' unless defined(&WSIO_PLAIN_SPINLOCK);
    eval 'sub WSIO_PLAIN_SPINUNLOCK () {
        eval q({  &if (-- &wsio_lock_count == 0)  &spinunlock( &wsio_lock); });
    }' unless defined(&WSIO_PLAIN_SPINUNLOCK);
    eval 'sub wsio_get_new_eim {
        local($Isc,$EIM_control_var,$Default_eim) = @_;
	    eval q((*$EIM_control_var ? 0: (*$EIM_control_var =  &pa_reassign_eim_mask( ($Isc->{card_node}),$Default_eim, &NULL))));
    }' unless defined(&wsio_get_new_eim);
    eval 'sub MKMINOR () {1;}' unless defined(&MKMINOR);
    eval 'sub DECODE () {2;}' unless defined(&DECODE);
    eval 'sub DRV_CONVERGED () {0x1;}' unless defined(&DRV_CONVERGED);
    eval 'sub NOT_CONVERGED () {0x2;}' unless defined(&NOT_CONVERGED);
    eval 'sub ATTACH_OK () {1;}' unless defined(&ATTACH_OK);
    eval 'sub ATTACH_INIT_ERROR () {-1;}' unless defined(&ATTACH_INIT_ERROR);
    eval 'sub ATTACH_NO_DRIVER () {-2;}' unless defined(&ATTACH_NO_DRIVER);
    eval 'sub ATTACH_INCOMPLETE () {99;}' unless defined(&ATTACH_INCOMPLETE);
    eval 'sub HAS_IOCHKERR () {0x1;}' unless defined(&HAS_IOCHKERR);
    eval 'sub INITIALIZED () {0x2;}' unless defined(&INITIALIZED);
    eval 'sub INIT_ERROR () {0x4;}' unless defined(&INIT_ERROR);
    eval 'sub IS_ISA_CARD () {0x8;}' unless defined(&IS_ISA_CARD);
    eval 'sub SLOT_ADDR_VALID () {0x10;}' unless defined(&SLOT_ADDR_VALID);
    eval 'sub NO_ALLOC_GDD () {0x20;}' unless defined(&NO_ALLOC_GDD);
    eval 'sub ISR_IS_MP_SAFE () {0x1;}' unless defined(&ISR_IS_MP_SAFE);
    eval 'sub WSIO_ERROR () {-1;}' unless defined(&WSIO_ERROR);
    eval 'sub CLAIMED () {1;}' unless defined(&CLAIMED);
    eval 'sub UNCLAIMED () {0;}' unless defined(&UNCLAIMED);
    eval 'sub PROBE_SUCCESS () {1;}' unless defined(&PROBE_SUCCESS);
    eval 'sub PROBE_UNSUCCESSFUL () {0;}' unless defined(&PROBE_UNSUCCESSFUL);
    eval 'sub PROBE_UNKNOWN () {-3;}' unless defined(&PROBE_UNKNOWN);
    eval 'sub PROBE_FIRST () {0;}' unless defined(&PROBE_FIRST);
    eval 'sub PROBE_NEXT () {1;}' unless defined(&PROBE_NEXT);
    eval 'sub PROBE_ADDRESS () {2;}' unless defined(&PROBE_ADDRESS);
    eval 'sub IF_CLASS () {1;}' unless defined(&IF_CLASS);
    eval 'sub DRV_NAME () {2;}' unless defined(&DRV_NAME);
    eval 'sub INVAL_TGT () {-1;}' unless defined(&INVAL_TGT);
    eval 'sub INVAL_LUN () {-2;}' unless defined(&INVAL_LUN);
    eval 'sub INVAL_UNIT () {-2;}' unless defined(&INVAL_UNIT);
    eval 'sub NO_DEV () {1;}' unless defined(&NO_DEV);
    eval 'sub VALID_TGT () {2;}' unless defined(&VALID_TGT);
    eval 'sub VALID_LUN () {3;}' unless defined(&VALID_LUN);
    eval 'sub VALID_UNIT () {3;}' unless defined(&VALID_UNIT);
    eval 'sub NO_SCSI_DEV () {0x1f;}' unless defined(&NO_SCSI_DEV);
}
1;
